define(['dart_sdk', 'test/test__shared_2', 'packages/w_transport/lib__w_transport', 'packages/matcher/lib__shared_0', 'packages/test/lib__test', 'test/test__shared_0', 'packages/w_transport/lib__mock'], function(dart_sdk, test__shared_2, lib__w_transport, lib__shared_0, lib__test, test__shared_0, lib__mock) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const src__mocks__mock_transports = lib__w_transport.src__mocks__mock_transports;
  const src__http__client = lib__w_transport.src__http__client;
  const src__http__mock__http_client = lib__w_transport.src__http__mock__http_client;
  const src__http__http_client = lib__w_transport.src__http__http_client;
  const src__http__requests = lib__w_transport.src__http__requests;
  const src__http__mock__requests = lib__w_transport.src__http__mock__requests;
  const src__web_socket__web_socket = lib__w_transport.src__web_socket__web_socket;
  const src__web_socket__mock__web_socket = lib__w_transport.src__web_socket__mock__web_socket;
  const src__web_socket__w_socket = lib__w_transport.src__web_socket__w_socket;
  const src__transport_platform = lib__w_transport.src__transport_platform;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const test = lib__test.test;
  const src__frontend__throws_matcher = lib__test.src__frontend__throws_matcher;
  const integration__integration_paths = test__shared_0.integration__integration_paths;
  const mock = lib__mock.mock;
  const _root = Object.create(null);
  const integration__platforms__mock_aware_transport_platform = Object.create(_root);
  const $_set = dartx._set;
  let isInstanceOfOfMockHttpClient = () => (isInstanceOfOfMockHttpClient = dart.constFn(src__core_matchers.isInstanceOf$(src__http__mock__http_client.MockHttpClient)))();
  let isInstanceOfOfMockFormRequest = () => (isInstanceOfOfMockFormRequest = dart.constFn(src__core_matchers.isInstanceOf$(src__http__mock__requests.MockFormRequest)))();
  let isInstanceOfOfMockJsonRequest = () => (isInstanceOfOfMockJsonRequest = dart.constFn(src__core_matchers.isInstanceOf$(src__http__mock__requests.MockJsonRequest)))();
  let isInstanceOfOfMockMultipartRequest = () => (isInstanceOfOfMockMultipartRequest = dart.constFn(src__core_matchers.isInstanceOf$(src__http__mock__requests.MockMultipartRequest)))();
  let isInstanceOfOfMockPlainTextRequest = () => (isInstanceOfOfMockPlainTextRequest = dart.constFn(src__core_matchers.isInstanceOf$(src__http__mock__requests.MockPlainTextRequest)))();
  let isInstanceOfOfMockStreamedRequest = () => (isInstanceOfOfMockStreamedRequest = dart.constFn(src__core_matchers.isInstanceOf$(src__http__mock__requests.MockStreamedRequest)))();
  let isInstanceOfOfMockWebSocket = () => (isInstanceOfOfMockWebSocket = dart.constFn(src__core_matchers.isInstanceOf$(src__web_socket__mock__web_socket.MockWebSocket)))();
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let isInstanceOfOfTransportPlatformMissing = () => (isInstanceOfOfTransportPlatformMissing = dart.constFn(src__core_matchers.isInstanceOf$(src__transport_platform.TransportPlatformMissing)))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  integration__platforms__mock_aware_transport_platform.main = function() {
    let naming = new naming$.Naming.new();
    naming.platform = "mock";
    naming.testType = "integration";
    naming.topic = "Transport Platform";
    test.group(naming.toString(), dart.fn(() => {
      test.test('MockTransports.install()', dart.fn(() => async.async(core.Null, function*() {
        src__mocks__mock_transports.MockTransports.install();
        src__frontend__expect.expect(src__http__client.Client.new(), new (isInstanceOfOfMockHttpClient()).new());
        src__frontend__expect.expect(src__http__http_client.HttpClient.new(), new (isInstanceOfOfMockHttpClient()).new());
        src__frontend__expect.expect(src__http__requests.FormRequest.new(), new (isInstanceOfOfMockFormRequest()).new());
        src__frontend__expect.expect(src__http__requests.JsonRequest.new(), new (isInstanceOfOfMockJsonRequest()).new());
        src__frontend__expect.expect(src__http__requests.MultipartRequest.new(), new (isInstanceOfOfMockMultipartRequest()).new());
        src__frontend__expect.expect(src__http__requests.Request.new(), new (isInstanceOfOfMockPlainTextRequest()).new());
        src__frontend__expect.expect(src__http__requests.StreamedRequest.new(), new (isInstanceOfOfMockStreamedRequest()).new());
        let mockWebSocketServer = new src__mocks__mock_transports.MockWebSocketServer.new();
        src__mocks__mock_transports.MockTransports.webSocket.expect(integration__integration_paths.IntegrationPaths.pingUri, {connectTo: mockWebSocketServer});
        let webSocket = (yield src__web_socket__web_socket.WebSocket.connect(integration__integration_paths.IntegrationPaths.pingUri));
        src__frontend__expect.expect(webSocket, new (isInstanceOfOfMockWebSocket()).new());
        yield webSocket.close();
        src__mocks__mock_transports.MockTransports.webSocket.expect(integration__integration_paths.IntegrationPaths.pingUri, {connectTo: mockWebSocketServer});
        let wSocket = (yield src__web_socket__w_socket.WSocket.connect(integration__integration_paths.IntegrationPaths.pingUri));
        src__frontend__expect.expect(webSocket, new (isInstanceOfOfMockWebSocket()).new());
        yield wSocket.close();
        yield mockWebSocketServer.shutDown();
        src__mocks__mock_transports.MockTransports.verifyNoOutstandingExceptions();
        yield src__mocks__mock_transports.MockTransports.uninstall();
      }), VoidToFutureOfNull()));
      test.test('configureWTransportForTest()', dart.fn(() => async.async(core.Null, function*() {
        mock.configureWTransportForTest();
        src__frontend__expect.expect(src__http__client.Client.new(), new (isInstanceOfOfMockHttpClient()).new());
        src__frontend__expect.expect(src__http__http_client.HttpClient.new(), new (isInstanceOfOfMockHttpClient()).new());
        src__frontend__expect.expect(src__http__requests.FormRequest.new(), new (isInstanceOfOfMockFormRequest()).new());
        src__frontend__expect.expect(src__http__requests.JsonRequest.new(), new (isInstanceOfOfMockJsonRequest()).new());
        src__frontend__expect.expect(src__http__requests.MultipartRequest.new(), new (isInstanceOfOfMockMultipartRequest()).new());
        src__frontend__expect.expect(src__http__requests.Request.new(), new (isInstanceOfOfMockPlainTextRequest()).new());
        src__frontend__expect.expect(src__http__requests.StreamedRequest.new(), new (isInstanceOfOfMockStreamedRequest()).new());
        let mockWebSocketServer = new src__mocks__mock_transports.MockWebSocketServer.new();
        src__mocks__mock_transports.MockTransports.webSocket.expect(integration__integration_paths.IntegrationPaths.pingUri, {connectTo: mockWebSocketServer});
        let webSocket = (yield src__web_socket__web_socket.WebSocket.connect(integration__integration_paths.IntegrationPaths.pingUri));
        src__frontend__expect.expect(webSocket, new (isInstanceOfOfMockWebSocket()).new());
        yield webSocket.close();
        src__mocks__mock_transports.MockTransports.webSocket.expect(integration__integration_paths.IntegrationPaths.pingUri, {connectTo: mockWebSocketServer});
        let wSocket = (yield src__web_socket__w_socket.WSocket.connect(integration__integration_paths.IntegrationPaths.pingUri));
        src__frontend__expect.expect(webSocket, new (isInstanceOfOfMockWebSocket()).new());
        yield wSocket.close();
        yield mockWebSocketServer.shutDown();
        src__mocks__mock_transports.MockTransports.verifyNoOutstandingExceptions();
        yield src__mocks__mock_transports.MockTransports.uninstall();
      }), VoidToFutureOfNull()));
      test.test('switching to real requests should fail if no real TP is given', dart.fn(() => async.async(core.Null, function*() {
        src__mocks__mock_transports.MockTransports.install({fallThrough: true});
        let formRequest = src__http__requests.FormRequest.new();
        src__frontend__expect.expect(formRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri}), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfTransportPlatformMissing()).new()));
        let jsonRequest = src__http__requests.JsonRequest.new();
        src__frontend__expect.expect(jsonRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri}), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfTransportPlatformMissing()).new()));
        let multipartRequest = src__http__requests.MultipartRequest.new();
        multipartRequest.fields[$_set]('foo', 'bar');
        src__frontend__expect.expect(multipartRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri}), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfTransportPlatformMissing()).new()));
        let request = src__http__requests.Request.new();
        src__frontend__expect.expect(request.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri}), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfTransportPlatformMissing()).new()));
        let streamedRequest = src__http__requests.StreamedRequest.new();
        src__frontend__expect.expect(streamedRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri}), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfTransportPlatformMissing()).new()));
        let requestWithStreamedResponse = src__http__requests.Request.new();
        src__frontend__expect.expect(requestWithStreamedResponse.streamGet({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri}), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfTransportPlatformMissing()).new()));
        let httpClient = src__http__http_client.HttpClient.new();
        let clientFormRequest = httpClient.newFormRequest();
        src__frontend__expect.expect(clientFormRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri}), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfTransportPlatformMissing()).new()));
        let clientJsonRequest = httpClient.newJsonRequest();
        src__frontend__expect.expect(clientJsonRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri}), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfTransportPlatformMissing()).new()));
        let clientMultipartRequest = httpClient.newMultipartRequest();
        clientMultipartRequest.fields[$_set]('foo', 'bar');
        src__frontend__expect.expect(clientMultipartRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri}), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfTransportPlatformMissing()).new()));
        let clientRequest = httpClient.newRequest();
        src__frontend__expect.expect(clientRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri}), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfTransportPlatformMissing()).new()));
        let clientStreamedRequest = httpClient.newStreamedRequest();
        src__frontend__expect.expect(clientStreamedRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri}), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfTransportPlatformMissing()).new()));
        let clientRequestWithStreamedResponse = httpClient.newRequest();
        src__frontend__expect.expect(clientRequestWithStreamedResponse.streamGet({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri}), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfTransportPlatformMissing()).new()));
        yield src__mocks__mock_transports.MockTransports.uninstall();
      }), VoidToFutureOfNull()));
    }, VoidToNull()));
  };
  dart.trackLibraries("test/test__integration__platforms__mock_aware_transport_platform", {
    "integration/platforms/mock_aware_transport_platform.dart": integration__platforms__mock_aware_transport_platform
  }, null);
  // Exports:
  return {
    integration__platforms__mock_aware_transport_platform: integration__platforms__mock_aware_transport_platform
  };
});
