define(['dart_sdk', 'test/test__shared_2', 'packages/w_transport/lib__w_transport', 'packages/test/lib__test', 'packages/w_transport/lib__shared_3', 'packages/matcher/lib__shared_0', 'test/test__shared_0', 'packages/w_transport/lib__vm'], function(dart_sdk, test__shared_2, lib__w_transport, lib__test, lib__shared_3, lib__shared_0, test__shared_0, lib__vm) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const src__global_transport_platform = lib__w_transport.src__global_transport_platform;
  const src__http__client = lib__w_transport.src__http__client;
  const src__http__http_client = lib__w_transport.src__http__http_client;
  const src__http__requests = lib__w_transport.src__http__requests;
  const src__web_socket__web_socket = lib__w_transport.src__web_socket__web_socket;
  const src__web_socket__w_socket = lib__w_transport.src__web_socket__w_socket;
  const src__mocks__mock_transports = lib__w_transport.src__mocks__mock_transports;
  const src__http__mock__response = lib__w_transport.src__http__mock__response;
  const src__http__finalized_request = lib__w_transport.src__http__finalized_request;
  const test = lib__test.test;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const src__frontend__throws_matchers = lib__test.src__frontend__throws_matchers;
  const src__vm_transport_platform = lib__shared_3.src__vm_transport_platform;
  const src__http__vm__http_client = lib__shared_3.src__http__vm__http_client;
  const src__http__vm__requests = lib__shared_3.src__http__vm__requests;
  const src__web_socket__vm__web_socket = lib__shared_3.src__web_socket__vm__web_socket;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const integration__integration_paths = test__shared_0.integration__integration_paths;
  const vm = lib__vm.vm;
  const _root = Object.create(null);
  const integration__platforms__vm_transport_platform_test = Object.create(_root);
  const $_set = dartx._set;
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let isInstanceOfOfVMHttpClient = () => (isInstanceOfOfVMHttpClient = dart.constFn(src__core_matchers.isInstanceOf$(src__http__vm__http_client.VMHttpClient)))();
  let isInstanceOfOfVMFormRequest = () => (isInstanceOfOfVMFormRequest = dart.constFn(src__core_matchers.isInstanceOf$(src__http__vm__requests.VMFormRequest)))();
  let isInstanceOfOfVMJsonRequest = () => (isInstanceOfOfVMJsonRequest = dart.constFn(src__core_matchers.isInstanceOf$(src__http__vm__requests.VMJsonRequest)))();
  let isInstanceOfOfVMMultipartRequest = () => (isInstanceOfOfVMMultipartRequest = dart.constFn(src__core_matchers.isInstanceOf$(src__http__vm__requests.VMMultipartRequest)))();
  let isInstanceOfOfVMPlainTextRequest = () => (isInstanceOfOfVMPlainTextRequest = dart.constFn(src__core_matchers.isInstanceOf$(src__http__vm__requests.VMPlainTextRequest)))();
  let isInstanceOfOfVMStreamedRequest = () => (isInstanceOfOfVMStreamedRequest = dart.constFn(src__core_matchers.isInstanceOf$(src__http__vm__requests.VMStreamedRequest)))();
  let isInstanceOfOfVMWebSocket = () => (isInstanceOfOfVMWebSocket = dart.constFn(src__core_matchers.isInstanceOf$(src__web_socket__vm__web_socket.VMWebSocket)))();
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let FutureOfMockResponse = () => (FutureOfMockResponse = dart.constFn(async.Future$(src__http__mock__response.MockResponse)))();
  let FinalizedRequestToFutureOfMockResponse = () => (FinalizedRequestToFutureOfMockResponse = dart.constFn(dart.fnType(FutureOfMockResponse(), [src__http__finalized_request.FinalizedRequest])))();
  let FutureOfMockWebSocketServer = () => (FutureOfMockWebSocketServer = dart.constFn(async.Future$(src__mocks__mock_transports.MockWebSocketServer)))();
  let MapOfString$dynamic = () => (MapOfString$dynamic = dart.constFn(core.Map$(core.String, dart.dynamic)))();
  let IterableOfString = () => (IterableOfString = dart.constFn(core.Iterable$(core.String)))();
  let Uri__ToFutureOfMockWebSocketServer = () => (Uri__ToFutureOfMockWebSocketServer = dart.constFn(dart.fnType(FutureOfMockWebSocketServer(), [core.Uri], {headers: MapOfString$dynamic(), protocols: IterableOfString()})))();
  let const$;
  integration__platforms__vm_transport_platform_test.main = function() {
    let naming = new naming$.Naming.new();
    naming.platform = "vm";
    naming.testType = "integration";
    naming.topic = "Transport Platform";
    test.group(naming.toString(), dart.fn(() => {
      test.tearDown(dart.fn(() => {
        src__global_transport_platform.resetGlobalTransportPlatform();
      }, VoidToNull()));
      test.test('globalTransportPlatform = vmTransportPlatform', dart.fn(() => async.async(core.Null, function*() {
        src__global_transport_platform.globalTransportPlatform = src__vm_transport_platform.vmTransportPlatform;
        src__frontend__expect.expect(src__http__client.Client.new(), new (isInstanceOfOfVMHttpClient()).new());
        src__frontend__expect.expect(src__http__http_client.HttpClient.new(), new (isInstanceOfOfVMHttpClient()).new());
        src__frontend__expect.expect(src__http__requests.FormRequest.new(), new (isInstanceOfOfVMFormRequest()).new());
        src__frontend__expect.expect(src__http__requests.JsonRequest.new(), new (isInstanceOfOfVMJsonRequest()).new());
        src__frontend__expect.expect(src__http__requests.MultipartRequest.new(), new (isInstanceOfOfVMMultipartRequest()).new());
        src__frontend__expect.expect(src__http__requests.Request.new(), new (isInstanceOfOfVMPlainTextRequest()).new());
        src__frontend__expect.expect(src__http__requests.StreamedRequest.new(), new (isInstanceOfOfVMStreamedRequest()).new());
        let webSocket = (yield src__web_socket__web_socket.WebSocket.connect(integration__integration_paths.IntegrationPaths.pingUri));
        src__frontend__expect.expect(webSocket, new (isInstanceOfOfVMWebSocket()).new());
        yield webSocket.close();
        let wSocket = (yield src__web_socket__w_socket.WSocket.connect(integration__integration_paths.IntegrationPaths.pingUri));
        src__frontend__expect.expect(wSocket, new (isInstanceOfOfVMWebSocket()).new());
        yield wSocket.close();
      }), VoidToFutureOfNull()));
      test.test('configureWTransportForVM()', dart.fn(() => async.async(core.Null, function*() {
        vm.configureWTransportForVM();
        src__frontend__expect.expect(src__http__client.Client.new(), new (isInstanceOfOfVMHttpClient()).new());
        src__frontend__expect.expect(src__http__http_client.HttpClient.new(), new (isInstanceOfOfVMHttpClient()).new());
        src__frontend__expect.expect(src__http__requests.FormRequest.new(), new (isInstanceOfOfVMFormRequest()).new());
        src__frontend__expect.expect(src__http__requests.JsonRequest.new(), new (isInstanceOfOfVMJsonRequest()).new());
        src__frontend__expect.expect(src__http__requests.MultipartRequest.new(), new (isInstanceOfOfVMMultipartRequest()).new());
        src__frontend__expect.expect(src__http__requests.Request.new(), new (isInstanceOfOfVMPlainTextRequest()).new());
        src__frontend__expect.expect(src__http__requests.StreamedRequest.new(), new (isInstanceOfOfVMStreamedRequest()).new());
        let webSocket = (yield src__web_socket__web_socket.WebSocket.connect(integration__integration_paths.IntegrationPaths.pingUri));
        src__frontend__expect.expect(webSocket, new (isInstanceOfOfVMWebSocket()).new());
        yield webSocket.close();
        let wSocket = (yield src__web_socket__w_socket.WSocket.connect(integration__integration_paths.IntegrationPaths.pingUri));
        src__frontend__expect.expect(wSocket, new (isInstanceOfOfVMWebSocket()).new());
        yield wSocket.close();
      }), VoidToFutureOfNull()));
      test.group('mock-aware', dart.fn(() => {
        test.tearDown(dart.fn(() => async.async(core.Null, function*() {
          src__mocks__mock_transports.MockTransports.verifyNoOutstandingExceptions();
          yield src__mocks__mock_transports.MockTransports.uninstall();
        }), VoidToFutureOfNull()));
        test.group('fallThrough: false', dart.fn(() => {
          test.setUp(dart.fn(() => {
            src__mocks__mock_transports.MockTransports.install({fallThrough: false});
          }, VoidToNull()));
          test.test('requests with matching expectation should be handled', dart.fn(() => async.async(core.Null, function*() {
            let formRequest = src__http__requests.FormRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield formRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let jsonRequest = src__http__requests.JsonRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield jsonRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let multipartRequest = src__http__requests.MultipartRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            multipartRequest.fields[$_set]('foo', 'bar');
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield multipartRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let request = src__http__requests.Request.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield request.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let streamedRequest = src__http__requests.StreamedRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield streamedRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let requestWithStreamedResponse = src__http__requests.Request.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield requestWithStreamedResponse.streamGet({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let httpClient = src__http__http_client.HttpClient.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            let clientFormRequest = httpClient.newFormRequest();
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield clientFormRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientJsonRequest = httpClient.newJsonRequest();
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield clientJsonRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientMultipartRequest = httpClient.newMultipartRequest();
            clientMultipartRequest.fields[$_set]('foo', 'bar');
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield clientMultipartRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientRequest = httpClient.newRequest();
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield clientRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientStreamedRequest = httpClient.newStreamedRequest();
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield clientStreamedRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientRequestWithStreamedResponse = httpClient.newRequest();
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield clientRequestWithStreamedResponse.streamGet({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
          }), VoidToFutureOfNull()));
          test.test('requests with matching handler should be handled', dart.fn(() => async.async(core.Null, function*() {
            src__mocks__mock_transports.MockTransports.http.when(integration__integration_paths.IntegrationPaths.pingEndpointUri, dart.fn(request => async.async(src__http__mock__response.MockResponse, function*() {
              return src__http__mock__response.MockResponse.ok();
            }), FinalizedRequestToFutureOfMockResponse()));
            let formRequest = src__http__requests.FormRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            yield formRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let jsonRequest = src__http__requests.JsonRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            yield jsonRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let multipartRequest = src__http__requests.MultipartRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            multipartRequest.fields[$_set]('foo', 'bar');
            yield multipartRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let request = src__http__requests.Request.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            yield request.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let streamedRequest = src__http__requests.StreamedRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            yield streamedRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let requestWithStreamedResponse = src__http__requests.Request.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            yield requestWithStreamedResponse.streamGet({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let httpClient = src__http__http_client.HttpClient.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            let clientFormRequest = httpClient.newFormRequest();
            yield clientFormRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientJsonRequest = httpClient.newJsonRequest();
            yield clientJsonRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientMultipartRequest = httpClient.newMultipartRequest();
            clientMultipartRequest.fields[$_set]('foo', 'bar');
            yield clientMultipartRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientRequest = httpClient.newRequest();
            yield clientRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientStreamedRequest = httpClient.newStreamedRequest();
            yield clientStreamedRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientRequestWithStreamedResponse = httpClient.newRequest();
            yield clientRequestWithStreamedResponse.streamGet({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
          }), VoidToFutureOfNull()));
          test.test('websockets with matching expectation should be handled', dart.fn(() => async.async(core.Null, function*() {
            let mockWebSocketServer = new src__mocks__mock_transports.MockWebSocketServer.new();
            src__mocks__mock_transports.MockTransports.webSocket.expect(integration__integration_paths.IntegrationPaths.pingUri, {connectTo: mockWebSocketServer});
            let webSocket = (yield src__web_socket__web_socket.WebSocket.connect(integration__integration_paths.IntegrationPaths.pingUri, {transportPlatform: src__vm_transport_platform.vmTransportPlatform}));
            yield webSocket.close();
            yield mockWebSocketServer.shutDown();
          }), VoidToFutureOfNull()));
          test.test('websockets with matching handler should be handled', dart.fn(() => async.async(core.Null, function*() {
            let mockWebSocketServer = new src__mocks__mock_transports.MockWebSocketServer.new();
            src__mocks__mock_transports.MockTransports.webSocket.when(integration__integration_paths.IntegrationPaths.pingUri, {handler: dart.fn((uri, opts) => async.async(src__mocks__mock_transports.MockWebSocketServer, function*() {
                let headers = opts && 'headers' in opts ? opts.headers : null;
                let protocols = opts && 'protocols' in opts ? opts.protocols : null;
                return mockWebSocketServer;
              }), Uri__ToFutureOfMockWebSocketServer())});
            let webSocket = (yield src__web_socket__web_socket.WebSocket.connect(integration__integration_paths.IntegrationPaths.pingUri, {transportPlatform: src__vm_transport_platform.vmTransportPlatform}));
            yield webSocket.close();
            yield mockWebSocketServer.shutDown();
          }), VoidToFutureOfNull()));
          test.test('requests without expectation or handler should be pending', dart.fn(() => async.async(core.Null, function*() {
            let formRequest = src__http__requests.FormRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            formRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let jsonRequest = src__http__requests.JsonRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            jsonRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let multipartRequest = src__http__requests.MultipartRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            multipartRequest.fields[$_set]('foo', 'bar');
            multipartRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let request = src__http__requests.Request.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            request.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let streamedRequest = src__http__requests.StreamedRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            streamedRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let requestWithStreamedResponse = src__http__requests.Request.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            requestWithStreamedResponse.streamGet({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let httpClient = src__http__http_client.HttpClient.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            let clientFormRequest = httpClient.newFormRequest();
            clientFormRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientJsonRequest = httpClient.newJsonRequest();
            clientJsonRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientMultipartRequest = httpClient.newMultipartRequest();
            clientMultipartRequest.fields[$_set]('foo', 'bar');
            clientMultipartRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientRequest = httpClient.newRequest();
            clientRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientStreamedRequest = httpClient.newStreamedRequest();
            clientStreamedRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientRequestWithStreamedResponse = httpClient.newRequest();
            clientRequestWithStreamedResponse.streamGet({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            yield async.Future.delayed(const$ || (const$ = dart.const(new core.Duration.new({milliseconds: 50}))));
            src__frontend__expect.expect(src__mocks__mock_transports.MockTransports.http.numPendingRequests, src__core_matchers.equals(12));
            yield src__mocks__mock_transports.MockTransports.reset();
          }), VoidToFutureOfNull()));
          test.test('websockets without expectation or handler should throw StateError', dart.fn(() => async.async(core.Null, function*() {
            src__frontend__expect.expect(src__web_socket__web_socket.WebSocket.connect(integration__integration_paths.IntegrationPaths.pingUri, {transportPlatform: src__vm_transport_platform.vmTransportPlatform}), src__frontend__throws_matchers.throwsStateError);
          }), VoidToFutureOfNull()));
        }, VoidToNull()));
        test.group('fallThrough: true', dart.fn(() => {
          test.setUp(dart.fn(() => {
            src__mocks__mock_transports.MockTransports.install({fallThrough: true});
          }, VoidToNull()));
          test.test('requests with matching expectation should be handled', dart.fn(() => async.async(core.Null, function*() {
            let formRequest = src__http__requests.FormRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield formRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let jsonRequest = src__http__requests.JsonRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield jsonRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let multipartRequest = src__http__requests.MultipartRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            multipartRequest.fields[$_set]('foo', 'bar');
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield multipartRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let request = src__http__requests.Request.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield request.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let streamedRequest = src__http__requests.StreamedRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield streamedRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let requestWithStreamedResponse = src__http__requests.Request.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield requestWithStreamedResponse.streamGet({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let httpClient = src__http__http_client.HttpClient.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            let clientFormRequest = httpClient.newFormRequest();
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield clientFormRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientJsonRequest = httpClient.newJsonRequest();
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield clientJsonRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientMultipartRequest = httpClient.newMultipartRequest();
            clientMultipartRequest.fields[$_set]('foo', 'bar');
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield clientMultipartRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientRequest = httpClient.newRequest();
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield clientRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientStreamedRequest = httpClient.newStreamedRequest();
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield clientStreamedRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientRequestWithStreamedResponse = httpClient.newRequest();
            src__mocks__mock_transports.MockTransports.http.expect('GET', integration__integration_paths.IntegrationPaths.pingEndpointUri);
            yield clientRequestWithStreamedResponse.streamGet({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
          }), VoidToFutureOfNull()));
          test.test('requests with matching handler should be handled', dart.fn(() => async.async(core.Null, function*() {
            src__mocks__mock_transports.MockTransports.http.when(integration__integration_paths.IntegrationPaths.pingEndpointUri, dart.fn(request => async.async(src__http__mock__response.MockResponse, function*() {
              return src__http__mock__response.MockResponse.ok();
            }), FinalizedRequestToFutureOfMockResponse()));
            let formRequest = src__http__requests.FormRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            yield formRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let jsonRequest = src__http__requests.JsonRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            yield jsonRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let multipartRequest = src__http__requests.MultipartRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            multipartRequest.fields[$_set]('foo', 'bar');
            yield multipartRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let request = src__http__requests.Request.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            yield request.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let streamedRequest = src__http__requests.StreamedRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            yield streamedRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let requestWithStreamedResponse = src__http__requests.Request.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            yield requestWithStreamedResponse.streamGet({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let httpClient = src__http__http_client.HttpClient.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            let clientFormRequest = httpClient.newFormRequest();
            yield clientFormRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientJsonRequest = httpClient.newJsonRequest();
            yield clientJsonRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientMultipartRequest = httpClient.newMultipartRequest();
            clientMultipartRequest.fields[$_set]('foo', 'bar');
            yield clientMultipartRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientRequest = httpClient.newRequest();
            yield clientRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientStreamedRequest = httpClient.newStreamedRequest();
            yield clientStreamedRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientRequestWithStreamedResponse = httpClient.newRequest();
            yield clientRequestWithStreamedResponse.streamGet({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
          }), VoidToFutureOfNull()));
          test.test('websockets with matching expectation should be handled', dart.fn(() => async.async(core.Null, function*() {
            let mockWebSocketServer = new src__mocks__mock_transports.MockWebSocketServer.new();
            src__mocks__mock_transports.MockTransports.webSocket.expect(integration__integration_paths.IntegrationPaths.pingUri, {connectTo: mockWebSocketServer});
            let webSocket = (yield src__web_socket__web_socket.WebSocket.connect(integration__integration_paths.IntegrationPaths.pingUri, {transportPlatform: src__vm_transport_platform.vmTransportPlatform}));
            yield webSocket.close();
            yield mockWebSocketServer.shutDown();
          }), VoidToFutureOfNull()));
          test.test('websockets with matching handler should be handled', dart.fn(() => async.async(core.Null, function*() {
            let mockWebSocketServer = new src__mocks__mock_transports.MockWebSocketServer.new();
            src__mocks__mock_transports.MockTransports.webSocket.when(integration__integration_paths.IntegrationPaths.pingUri, {handler: dart.fn((uri, opts) => async.async(src__mocks__mock_transports.MockWebSocketServer, function*() {
                let headers = opts && 'headers' in opts ? opts.headers : null;
                let protocols = opts && 'protocols' in opts ? opts.protocols : null;
                return mockWebSocketServer;
              }), Uri__ToFutureOfMockWebSocketServer())});
            let webSocket = (yield src__web_socket__web_socket.WebSocket.connect(integration__integration_paths.IntegrationPaths.pingUri, {transportPlatform: src__vm_transport_platform.vmTransportPlatform}));
            yield webSocket.close();
            yield mockWebSocketServer.shutDown();
          }), VoidToFutureOfNull()));
          test.test('requests without expectation or handler should switch to real request', dart.fn(() => async.async(core.Null, function*() {
            let formRequest = src__http__requests.FormRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            yield formRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let jsonRequest = src__http__requests.JsonRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            yield jsonRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let multipartRequest = src__http__requests.MultipartRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            multipartRequest.fields[$_set]('foo', 'bar');
            yield multipartRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let request = src__http__requests.Request.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            yield request.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let streamedRequest = src__http__requests.StreamedRequest.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            yield streamedRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let requestWithStreamedResponse = src__http__requests.Request.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            yield requestWithStreamedResponse.streamGet({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let httpClient = src__http__http_client.HttpClient.new({transportPlatform: src__vm_transport_platform.vmTransportPlatform});
            let clientFormRequest = httpClient.newFormRequest();
            yield clientFormRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientJsonRequest = httpClient.newJsonRequest();
            yield clientJsonRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientMultipartRequest = httpClient.newMultipartRequest();
            clientMultipartRequest.fields[$_set]('foo', 'bar');
            yield clientMultipartRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientRequest = httpClient.newRequest();
            yield clientRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientStreamedRequest = httpClient.newStreamedRequest();
            yield clientStreamedRequest.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
            let clientRequestWithStreamedResponse = httpClient.newRequest();
            yield clientRequestWithStreamedResponse.streamGet({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
          }), VoidToFutureOfNull()));
          test.test('websockets without expectation or handler should switch to real websocket', dart.fn(() => async.async(core.Null, function*() {
            let webSocket = (yield src__web_socket__web_socket.WebSocket.connect(integration__integration_paths.IntegrationPaths.pingUri, {transportPlatform: src__vm_transport_platform.vmTransportPlatform}));
            yield webSocket.close();
          }), VoidToFutureOfNull()));
        }, VoidToNull()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  dart.trackLibraries("test/test__integration__platforms__vm_transport_platform_test", {
    "integration/platforms/vm_transport_platform_test.dart": integration__platforms__vm_transport_platform_test
  }, null);
  // Exports:
  return {
    integration__platforms__vm_transport_platform_test: integration__platforms__vm_transport_platform_test
  };
});
