define(['dart_sdk', 'test/test__shared_2', 'packages/w_transport/lib__shared_1', 'test/test__shared_18', 'test/test__shared_0', 'packages/w_transport/lib__w_transport', 'packages/test/lib__test'], function(dart_sdk, test__shared_2, lib__shared_1, test__shared_18, test__shared_0, lib__w_transport, lib__test) {
  'use strict';
  const core = dart_sdk.core;
  const html = dart_sdk.html;
  const async = dart_sdk.async;
  const _interceptors = dart_sdk._interceptors;
  const typed_data = dart_sdk.typed_data;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const src__browser_transport_platform = lib__shared_1.src__browser_transport_platform;
  const integration__ws__common = test__shared_18.integration__ws__common;
  const integration__integration_paths = test__shared_0.integration__integration_paths;
  const src__web_socket__web_socket = lib__w_transport.src__web_socket__web_socket;
  const test = lib__test.test;
  const src__frontend__throws_matchers = lib__test.src__frontend__throws_matchers;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const _root = Object.create(null);
  const integration__ws__browser_test = Object.create(_root);
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let JSArrayOfint = () => (JSArrayOfint = dart.constFn(_interceptors.JSArray$(core.int)))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  integration__ws__browser_test.main = function() {
    let naming = new naming$.Naming.new();
    naming.platform = "browser";
    naming.testType = "integration";
    naming.topic = "WS";
    test.group(naming.toString(), dart.fn(() => {
      integration__ws__common.runCommonWebSocketIntegrationTests({transportPlatform: src__browser_transport_platform.browserTransportPlatform});
      test.test('should support Blob', dart.fn(() => async.async(core.Null, function*() {
        let blob = html.Blob.new(['one', 'two']);
        let socket = (yield src__web_socket__web_socket.WebSocket.connect(integration__integration_paths.IntegrationPaths.echoUri, {transportPlatform: src__browser_transport_platform.browserTransportPlatform}));
        socket.add(blob);
        yield socket.close();
      }), VoidToFutureOfNull()));
      test.test('should support String', dart.fn(() => async.async(core.Null, function*() {
        let data = 'data';
        let socket = (yield src__web_socket__web_socket.WebSocket.connect(integration__integration_paths.IntegrationPaths.echoUri, {transportPlatform: src__browser_transport_platform.browserTransportPlatform}));
        socket.add(data);
        yield socket.close();
      }), VoidToFutureOfNull()));
      test.test('should support TypedData', dart.fn(() => async.async(core.Null, function*() {
        let data = typed_data.Uint16List.fromList(JSArrayOfint().of([1, 2, 3]));
        let socket = (yield src__web_socket__web_socket.WebSocket.connect(integration__integration_paths.IntegrationPaths.echoUri, {transportPlatform: src__browser_transport_platform.browserTransportPlatform}));
        socket.add(data);
        yield socket.close();
      }), VoidToFutureOfNull()));
      test.test('should throw when attempting to send invalid data', dart.fn(() => async.async(core.Null, function*() {
        let socket = (yield src__web_socket__web_socket.WebSocket.connect(integration__integration_paths.IntegrationPaths.pingUri, {transportPlatform: src__browser_transport_platform.browserTransportPlatform}));
        src__frontend__expect.expect(dart.fn(() => {
          socket.add(true);
        }, VoidToNull()), src__frontend__throws_matchers.throwsArgumentError);
        yield socket.close();
      }), VoidToFutureOfNull()));
    }, VoidToNull()));
  };
  dart.trackLibraries("test/test__integration__ws__browser_test", {
    "integration/ws/browser_test.dart": integration__ws__browser_test
  }, null);
  // Exports:
  return {
    integration__ws__browser_test: integration__ws__browser_test
  };
});
