define(['dart_sdk', 'test/test__shared_2', 'packages/w_transport/lib__w_transport', 'test/test__shared_0', 'packages/test/lib__test', 'test/test__shared_18'], function(dart_sdk, test__shared_2, lib__w_transport, test__shared_0, lib__test, test__shared_18) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const _interceptors = dart_sdk._interceptors;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const src__mocks__mock_transports = lib__w_transport.src__mocks__mock_transports;
  const src__web_socket__mock__w_socket = lib__w_transport.src__web_socket__mock__w_socket;
  const integration__integration_paths = test__shared_0.integration__integration_paths;
  const test = lib__test.test;
  const integration__ws__common = test__shared_18.integration__ws__common;
  const _root = Object.create(null);
  const integration__ws__mock_test = Object.create(_root);
  let dynamicToNull = () => (dynamicToNull = dart.constFn(dart.fnType(core.Null, [dart.dynamic])))();
  let MockWebSocketConnectionToNull = () => (MockWebSocketConnectionToNull = dart.constFn(dart.fnType(core.Null, [src__mocks__mock_transports.MockWebSocketConnection])))();
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let dynamicToFutureOfNull = () => (dynamicToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [dart.dynamic])))();
  let FutureOfMockWebSocketServer = () => (FutureOfMockWebSocketServer = dart.constFn(async.Future$(src__mocks__mock_transports.MockWebSocketServer)))();
  let IterableOfString = () => (IterableOfString = dart.constFn(core.Iterable$(core.String)))();
  let MapOfString$dynamic = () => (MapOfString$dynamic = dart.constFn(core.Map$(core.String, dart.dynamic)))();
  let Uri__ToFutureOfMockWebSocketServer = () => (Uri__ToFutureOfMockWebSocketServer = dart.constFn(dart.fnType(FutureOfMockWebSocketServer(), [core.Uri], {protocols: IterableOfString(), headers: MapOfString$dynamic()})))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let JSArrayOfFutureOfNull = () => (JSArrayOfFutureOfNull = dart.constFn(_interceptors.JSArray$(FutureOfNull())))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let FutureOfMockWSocket = () => (FutureOfMockWSocket = dart.constFn(async.Future$(src__web_socket__mock__w_socket.MockWSocket)))();
  let Uri__ToFutureOfMockWSocket = () => (Uri__ToFutureOfMockWSocket = dart.constFn(dart.fnType(FutureOfMockWSocket(), [core.Uri], {protocols: IterableOfString(), headers: MapOfString$dynamic()})))();
  integration__ws__mock_test.main = function() {
    let naming = new naming$.Naming.new();
    naming.platform = "mock";
    naming.testType = "integration";
    naming.topic = "WS";
    test.group(naming.toString(), dart.fn(() => {
      let mockCloseWebSocketServer = null;
      let mockEchoWebSocketServer = null;
      let mockPingWebSocketServer = null;
      test.setUp(dart.fn(() => {
        src__mocks__mock_transports.MockTransports.install();
        mockCloseWebSocketServer = new src__mocks__mock_transports.MockWebSocketServer.new();
        mockEchoWebSocketServer = new src__mocks__mock_transports.MockWebSocketServer.new();
        mockPingWebSocketServer = new src__mocks__mock_transports.MockWebSocketServer.new();
        mockCloseWebSocketServer.onClientConnected.listen(dart.fn(connection => {
          connection.onData(dart.fn(data => {
            if (dart.dtest(dart.dsend(data, 'startsWith', ['close']))) {
              let parts = dart.dsend(data, 'split', [':']);
              let closeCode = null;
              let closeReason = null;
              if (dart.dtest(dart.dsend(dart.dload(parts, 'length'), '>=', [2]))) {
                closeCode = core.int.parse(core.String._check(dart.dindex(parts, 1)));
              }
              if (dart.dtest(dart.dsend(dart.dload(parts, 'length'), '>=', [3]))) {
                closeReason = core.String._check(dart.dindex(parts, 2));
              }
              connection.close(closeCode, closeReason);
            }
          }, dynamicToNull()));
        }, MockWebSocketConnectionToNull()));
        mockEchoWebSocketServer.onClientConnected.listen(dart.fn(connection => {
          connection.onData(dart.bind(connection, 'send'));
        }, MockWebSocketConnectionToNull()));
        mockPingWebSocketServer.onClientConnected.listen(dart.fn(connection => {
          connection.onData(dart.fn(data => async.async(core.Null, function*() {
            data = dart.dsend(data, 'replaceAll', ['ping', '']);
            let numPongs = 1;
            try {
              numPongs = core.int.parse(core.String._check(data));
            } catch (_) {
            }
            for (let i = 0; i < dart.notNull(numPongs); i++) {
              yield async.Future.delayed(new core.Duration.new({milliseconds: 5}));
              connection.send('pong');
            }
          }), dynamicToFutureOfNull()));
        }, MockWebSocketConnectionToNull()));
        src__mocks__mock_transports.MockTransports.webSocket.when(integration__integration_paths.IntegrationPaths.fourOhFourUri, {reject: true});
        src__mocks__mock_transports.MockTransports.webSocket.when(integration__integration_paths.IntegrationPaths.closeUri, {handler: dart.fn((uri, opts) => async.async(src__mocks__mock_transports.MockWebSocketServer, function*() {
            let protocols = opts && 'protocols' in opts ? opts.protocols : null;
            let headers = opts && 'headers' in opts ? opts.headers : null;
            return mockCloseWebSocketServer;
          }), Uri__ToFutureOfMockWebSocketServer())});
        src__mocks__mock_transports.MockTransports.webSocket.when(integration__integration_paths.IntegrationPaths.echoUri, {handler: dart.fn((uri, opts) => async.async(src__mocks__mock_transports.MockWebSocketServer, function*() {
            let protocols = opts && 'protocols' in opts ? opts.protocols : null;
            let headers = opts && 'headers' in opts ? opts.headers : null;
            return mockEchoWebSocketServer;
          }), Uri__ToFutureOfMockWebSocketServer())});
        src__mocks__mock_transports.MockTransports.webSocket.when(integration__integration_paths.IntegrationPaths.pingUri, {handler: dart.fn((uri, opts) => async.async(src__mocks__mock_transports.MockWebSocketServer, function*() {
            let protocols = opts && 'protocols' in opts ? opts.protocols : null;
            let headers = opts && 'headers' in opts ? opts.headers : null;
            return mockPingWebSocketServer;
          }), Uri__ToFutureOfMockWebSocketServer())});
      }, VoidToNull()));
      test.tearDown(dart.fn(() => async.async(core.Null, function*() {
        yield async.Future.wait(core.Null, JSArrayOfFutureOfNull().of([mockCloseWebSocketServer.shutDown(), mockEchoWebSocketServer.shutDown(), mockPingWebSocketServer.shutDown()]));
        src__mocks__mock_transports.MockTransports.verifyNoOutstandingExceptions();
        yield src__mocks__mock_transports.MockTransports.uninstall();
      }), VoidToFutureOfNull()));
      integration__ws__common.runCommonWebSocketIntegrationTests();
    }, VoidToNull()));
    test.group(dart.notNull(naming.toString()) + ' legacy', dart.fn(() => {
      test.setUp(dart.fn(() => {
        src__mocks__mock_transports.MockTransports.install();
        src__mocks__mock_transports.MockTransports.webSocket.when(integration__integration_paths.IntegrationPaths.fourOhFourUri, {reject: true});
        src__mocks__mock_transports.MockTransports.webSocket.when(integration__integration_paths.IntegrationPaths.closeUri, {handler: dart.fn((uri, opts) => async.async(src__web_socket__mock__w_socket.MockWSocket, function*() {
            let protocols = opts && 'protocols' in opts ? opts.protocols : null;
            let headers = opts && 'headers' in opts ? opts.headers : null;
            let webSocket = src__web_socket__mock__w_socket.MockWSocket.new();
            webSocket.onOutgoing(dart.fn(data => {
              if (dart.dtest(dart.dsend(data, 'startsWith', ['close']))) {
                let parts = dart.dsend(data, 'split', [':']);
                let closeCode = null;
                let closeReason = null;
                if (dart.dtest(dart.dsend(dart.dload(parts, 'length'), '>=', [2]))) {
                  closeCode = core.int.parse(core.String._check(dart.dindex(parts, 1)));
                }
                if (dart.dtest(dart.dsend(dart.dload(parts, 'length'), '>=', [3]))) {
                  closeReason = core.String._check(dart.dindex(parts, 2));
                }
                webSocket.close(closeCode, closeReason);
              }
            }, dynamicToNull()));
            return webSocket;
          }), Uri__ToFutureOfMockWSocket())});
        src__mocks__mock_transports.MockTransports.webSocket.when(integration__integration_paths.IntegrationPaths.echoUri, {handler: dart.fn((uri, opts) => async.async(src__web_socket__mock__w_socket.MockWSocket, function*() {
            let protocols = opts && 'protocols' in opts ? opts.protocols : null;
            let headers = opts && 'headers' in opts ? opts.headers : null;
            let webSocket = src__web_socket__mock__w_socket.MockWSocket.new();
            webSocket.onOutgoing(dart.bind(webSocket, 'addIncoming'));
            return webSocket;
          }), Uri__ToFutureOfMockWSocket())});
        src__mocks__mock_transports.MockTransports.webSocket.when(integration__integration_paths.IntegrationPaths.pingUri, {handler: dart.fn((uri, opts) => async.async(src__web_socket__mock__w_socket.MockWSocket, function*() {
            let protocols = opts && 'protocols' in opts ? opts.protocols : null;
            let headers = opts && 'headers' in opts ? opts.headers : null;
            let webSocket = src__web_socket__mock__w_socket.MockWSocket.new();
            webSocket.onOutgoing(dart.fn(data => async.async(core.Null, function*() {
              data = dart.dsend(data, 'replaceAll', ['ping', '']);
              let numPongs = 1;
              try {
                numPongs = core.int.parse(core.String._check(data));
              } catch (_) {
              }
              for (let i = 0; i < dart.notNull(numPongs); i++) {
                yield async.Future.delayed(new core.Duration.new({milliseconds: 5}));
                webSocket.addIncoming('pong');
              }
            }), dynamicToFutureOfNull()));
            return webSocket;
          }), Uri__ToFutureOfMockWSocket())});
      }, VoidToNull()));
      test.tearDown(dart.fn(() => async.async(core.Null, function*() {
        src__mocks__mock_transports.MockTransports.verifyNoOutstandingExceptions();
        yield src__mocks__mock_transports.MockTransports.uninstall();
      }), VoidToFutureOfNull()));
      integration__ws__common.runCommonWebSocketIntegrationTests();
    }, VoidToNull()));
  };
  dart.trackLibraries("test/test__integration__ws__mock_test", {
    "integration/ws/mock_test.dart": integration__ws__mock_test
  }, null);
  // Exports:
  return {
    integration__ws__mock_test: integration__ws__mock_test
  };
});
