define(['dart_sdk', 'packages/dart2_constant/lib__convert', 'packages/w_transport/lib__shared_0', 'packages/w_transport/lib__w_transport', 'test/test__shared_0', 'packages/matcher/lib__shared_0', 'packages/test/lib__test', 'packages/http_parser/lib__http_parser'], function(dart_sdk, lib__convert, lib__shared_0, lib__w_transport, test__shared_0, lib__shared_0$, lib__test, lib__http_parser) {
  'use strict';
  const core = dart_sdk.core;
  const _interceptors = dart_sdk._interceptors;
  const async = dart_sdk.async;
  const _js_helper = dart_sdk._js_helper;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const convert = lib__convert.convert;
  const src__http__multipart_file = lib__shared_0.src__http__multipart_file;
  const src__http__requests = lib__w_transport.src__http__requests;
  const integration__integration_paths = test__shared_0.integration__integration_paths;
  const src__order_matchers = lib__shared_0$.src__order_matchers;
  const src__core_matchers = lib__shared_0$.src__core_matchers;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const test = lib__test.test;
  const src__media_type = lib__http_parser.src__media_type;
  const _root = Object.create(null);
  const integration__http__multipart_request__suite = Object.create(_root);
  const $length = dartx.length;
  const $_set = dartx._set;
  const $_get = dartx._get;
  let ListOfint = () => (ListOfint = dart.constFn(core.List$(core.int)))();
  let JSArrayOfListOfint = () => (JSArrayOfListOfint = dart.constFn(_interceptors.JSArray$(ListOfint())))();
  let StreamOfListOfint = () => (StreamOfListOfint = dart.constFn(async.Stream$(ListOfint())))();
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let IdentityMapOfString$String = () => (IdentityMapOfString$String = dart.constFn(_js_helper.IdentityMap$(core.String, core.String)))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  integration__http__multipart_request__suite.runMultipartRequestSuite = function(transportPlatform) {
    if (transportPlatform === void 0) transportPlatform = null;
    test.group('MultipartRequest', dart.fn(() => {
      test.test('contentLength should be set automatically', dart.fn(() => async.async(core.Null, function*() {
        let chunks = JSArrayOfListOfint().of([convert.utf8.encode('chunk1'), convert.utf8.encode('chunk2'), convert.utf8.encode('chunk2'), convert.utf8.encode('chunk3')]);
        let size = 0;
        for (let chunk of chunks) {
          size = dart.notNull(size) + dart.notNull(chunk[$length]);
        }
        let fileStream = StreamOfListOfint().fromIterable(chunks);
        let file = new src__http__multipart_file.MultipartFile.new(fileStream, size);
        let request = src__http__requests.MultipartRequest.new({transportPlatform: transportPlatform});
        request.uri = integration__integration_paths.IntegrationPaths.reflectEndpointUri;
        request.files[$_set]('file', file);
        request.fields[$_set]('field', 'value');
        let response = (yield request.post({uri: integration__integration_paths.IntegrationPaths.reflectEndpointUri}));
        let contentLength = core.int.parse(core.String._check(dart.dindex(dart.dindex(response.body.asJson(), 'headers'), 'content-length')));
        src__frontend__expect.expect(contentLength, src__order_matchers.greaterThan(0), {reason: 'Non-empty multipart request\'s content-length should be greater than 0.'});
      }), VoidToFutureOfNull()));
      test.test('content-type should be set automatically', dart.fn(() => async.async(core.Null, function*() {
        let request = src__http__requests.MultipartRequest.new({transportPlatform: transportPlatform});
        request.uri = integration__integration_paths.IntegrationPaths.reflectEndpointUri;
        request.fields[$_set]('field', 'value');
        let response = (yield request.post());
        let contentType = src__media_type.MediaType.parse(core.String._check(dart.dindex(dart.dindex(response.body.asJson(), 'headers'), 'content-type')));
        src__frontend__expect.expect(contentType.mimeType, src__core_matchers.equals('multipart/form-data'));
      }), VoidToFutureOfNull()));
      test.test('text fields with non-ASCII chars', dart.fn(() => async.async(core.Null, function*() {
        let request = src__http__requests.MultipartRequest.new({transportPlatform: transportPlatform});
        request.uri = integration__integration_paths.IntegrationPaths.uploadEndpointUri;
        request.fields[$_set]('field', 'ç®å');
        yield request.post();
      }), VoidToFutureOfNull()));
      test.test('uploading multiple files with different charsets', dart.fn(() => async.async(core.Null, function*() {
        let utf8Chunks = JSArrayOfListOfint().of([convert.utf8.encode('chunk1'), convert.utf8.encode('ç®å')]);
        let utf8Stream = StreamOfListOfint().fromIterable(utf8Chunks);
        let utf8Size = dart.notNull(utf8Chunks[$_get](0)[$length]) + dart.notNull(utf8Chunks[$_get](1)[$length]);
        let utf8ContentType = new src__media_type.MediaType.new('text', 'plain', new (IdentityMapOfString$String()).from(['charset', convert.utf8.name]));
        let utf8File = new src__http__multipart_file.MultipartFile.new(utf8Stream, utf8Size, {contentType: utf8ContentType, filename: 'utf8-file'});
        let latin1Chunks = JSArrayOfListOfint().of([convert.latin1.encode('chunk1'), convert.latin1.encode('ç®å')]);
        let latin1Stream = StreamOfListOfint().fromIterable(latin1Chunks);
        let latin1Size = dart.notNull(latin1Chunks[$_get](0)[$length]) + dart.notNull(latin1Chunks[$_get](1)[$length]);
        let latin1ContentType = new src__media_type.MediaType.new('text', 'plain', new (IdentityMapOfString$String()).from(['charset', convert.latin1.name]));
        let latin1File = new src__http__multipart_file.MultipartFile.new(latin1Stream, latin1Size, {contentType: latin1ContentType, filename: 'latin1-file'});
        let asciiChunks = JSArrayOfListOfint().of([convert.ascii.encode('chunk1'), convert.ascii.encode('chunk2')]);
        let asciiStream = StreamOfListOfint().fromIterable(asciiChunks);
        let asciiSize = dart.notNull(asciiChunks[$_get](0)[$length]) + dart.notNull(asciiChunks[$_get](1)[$length]);
        let asciiContentType = new src__media_type.MediaType.new('text', 'plain', new (IdentityMapOfString$String()).from(['charset', convert.ascii.name]));
        let asciiFile = new src__http__multipart_file.MultipartFile.new(asciiStream, asciiSize, {contentType: asciiContentType, filename: 'ascii-file'});
        let request = src__http__requests.MultipartRequest.new({transportPlatform: transportPlatform});
        request.uri = integration__integration_paths.IntegrationPaths.uploadEndpointUri;
        request.files[$_set]('utf8File', utf8File);
        request.files[$_set]('latin1File', latin1File);
        request.files[$_set]('asciiFile', asciiFile);
        yield request.post();
      }), VoidToFutureOfNull()));
    }, VoidToNull()));
  };
  dart.trackLibraries("test/test__shared_15", {
    "integration/http/multipart_request/suite.dart": integration__http__multipart_request__suite
  }, null);
  // Exports:
  return {
    integration__http__multipart_request__suite: integration__http__multipart_request__suite
  };
});
