define(['dart_sdk', 'packages/w_transport/lib__w_transport', 'test/test__shared_0', 'packages/matcher/lib__shared_0', 'packages/test/lib__test', 'packages/http_parser/lib__http_parser', 'packages/dart2_constant/lib__convert'], function(dart_sdk, lib__w_transport, test__shared_0, lib__shared_0, lib__test, lib__http_parser, lib__convert) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const src__http__requests = lib__w_transport.src__http__requests;
  const integration__integration_paths = test__shared_0.integration__integration_paths;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const src__order_matchers = lib__shared_0.src__order_matchers;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const test = lib__test.test;
  const src__media_type = lib__http_parser.src__media_type;
  const convert = lib__convert.convert;
  const _root = Object.create(null);
  const integration__http__plain_text_request__suite = Object.create(_root);
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  integration__http__plain_text_request__suite.runPlainTextRequestSuite = function(transportPlatform) {
    if (transportPlatform === void 0) transportPlatform = null;
    test.group('Request', dart.fn(() => {
      test.test('contentLength should be set automatically', dart.fn(() => async.async(core.Null, function*() {
        let emptyRequest = src__http__requests.Request.new({transportPlatform: transportPlatform});
        let response = (yield emptyRequest.post({uri: integration__integration_paths.IntegrationPaths.reflectEndpointUri}));
        let contentLength = core.int.parse(core.String._check(dart.dindex(dart.dindex(response.body.asJson(), 'headers'), 'content-length')));
        src__frontend__expect.expect(contentLength, src__core_matchers.equals(0), {reason: 'Empty plain-text request\'s content-length should be 0.'});
        let nonEmptyRequest = src__http__requests.Request.new({transportPlatform: transportPlatform});
        nonEmptyRequest.uri = integration__integration_paths.IntegrationPaths.reflectEndpointUri;
        nonEmptyRequest.body = 'data';
        let response2 = (yield nonEmptyRequest.post());
        let contentLength2 = core.int.parse(core.String._check(dart.dindex(dart.dindex(response2.body.asJson(), 'headers'), 'content-length')));
        src__frontend__expect.expect(contentLength2, src__order_matchers.greaterThan(0), {reason: 'Non-empty plain-text request\'s content-length should be greater than 0.'});
      }), VoidToFutureOfNull()));
      test.test('content-type should be set automatically', dart.fn(() => async.async(core.Null, function*() {
        let request = src__http__requests.Request.new({transportPlatform: transportPlatform});
        request.uri = integration__integration_paths.IntegrationPaths.reflectEndpointUri;
        request.body = 'data';
        let response = (yield request.post());
        let contentType = src__media_type.MediaType.parse(core.String._check(dart.dindex(dart.dindex(response.body.asJson(), 'headers'), 'content-type')));
        src__frontend__expect.expect(contentType.mimeType, src__core_matchers.equals('text/plain'));
      }), VoidToFutureOfNull()));
      test.test('content-type should be overridable', dart.fn(() => async.async(core.Null, function*() {
        let contentType = new src__media_type.MediaType.new('application', 'x-custom');
        let request = src__http__requests.Request.new({transportPlatform: transportPlatform});
        request.uri = integration__integration_paths.IntegrationPaths.reflectEndpointUri;
        request.body = 'data';
        request.contentType = contentType;
        let response = (yield request.post());
        let reflectedContentType = src__media_type.MediaType.parse(core.String._check(dart.dindex(dart.dindex(response.body.asJson(), 'headers'), 'content-type')));
        src__frontend__expect.expect(reflectedContentType.mimeType, src__core_matchers.equals(contentType.mimeType));
      }), VoidToFutureOfNull()));
      test.test('UTF8', dart.fn(() => async.async(core.Null, function*() {
        let request = src__http__requests.Request.new({transportPlatform: transportPlatform});
        request.uri = integration__integration_paths.IntegrationPaths.echoEndpointUri;
        request.encoding = convert.utf8;
        request.body = 'dataç®å';
        let response = (yield request.post());
        src__frontend__expect.expect(response.encoding.name, src__core_matchers.equals(convert.utf8.name));
        src__frontend__expect.expect(response.body.asString(), src__core_matchers.equals('dataç®å'));
      }), VoidToFutureOfNull()));
      test.test('LATIN1', dart.fn(() => async.async(core.Null, function*() {
        let request = src__http__requests.Request.new({transportPlatform: transportPlatform});
        request.uri = integration__integration_paths.IntegrationPaths.echoEndpointUri;
        request.encoding = convert.latin1;
        request.body = 'dataç®å';
        let response = (yield request.post());
        src__frontend__expect.expect(response.encoding.name, src__core_matchers.equals(convert.latin1.name));
        src__frontend__expect.expect(response.body.asString(), src__core_matchers.equals('dataç®å'));
      }), VoidToFutureOfNull()));
      test.test('ASCII', dart.fn(() => async.async(core.Null, function*() {
        let request = src__http__requests.Request.new({transportPlatform: transportPlatform});
        request.uri = integration__integration_paths.IntegrationPaths.echoEndpointUri;
        request.encoding = convert.ascii;
        request.body = 'data';
        let response = (yield request.post());
        src__frontend__expect.expect(response.encoding.name, src__core_matchers.equals(convert.ascii.name));
        src__frontend__expect.expect(response.body.asString(), src__core_matchers.equals('data'));
      }), VoidToFutureOfNull()));
    }, VoidToNull()));
  };
  dart.trackLibraries("test/test__shared_16", {
    "integration/http/plain_text_request/suite.dart": integration__http__plain_text_request__suite
  }, null);
  // Exports:
  return {
    integration__http__plain_text_request__suite: integration__http__plain_text_request__suite
  };
});
