define(['dart_sdk', 'packages/w_transport/lib__w_transport', 'test/test__shared_0', 'packages/w_transport/lib__shared_0', 'packages/matcher/lib__shared_0', 'packages/test/lib__test'], function(dart_sdk, lib__w_transport, test__shared_0, lib__shared_0, lib__shared_0$, lib__test) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const _interceptors = dart_sdk._interceptors;
  const _js_helper = dart_sdk._js_helper;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const src__web_socket__web_socket = lib__w_transport.src__web_socket__web_socket;
  const integration__integration_paths = test__shared_0.integration__integration_paths;
  const src__web_socket__web_socket_exception = lib__shared_0.src__web_socket__web_socket_exception;
  const src__core_matchers = lib__shared_0$.src__core_matchers;
  const src__iterable_matchers = lib__shared_0$.src__iterable_matchers;
  const src__error_matchers = lib__shared_0$.src__error_matchers;
  const src__frontend__throws_matcher = lib__test.src__frontend__throws_matcher;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const test = lib__test.test;
  const src__frontend__throws_matchers = lib__test.src__frontend__throws_matchers;
  const _root = Object.create(null);
  const integration__ws__common = Object.create(_root);
  const $single = dartx.single;
  const $add = dartx.add;
  const $length = dartx.length;
  const $forEach = dartx.forEach;
  const $_set = dartx._set;
  let FutureOfWebSocket = () => (FutureOfWebSocket = dart.constFn(async.Future$(src__web_socket__web_socket.WebSocket)))();
  let UriToFutureOfWebSocket = () => (UriToFutureOfWebSocket = dart.constFn(dart.fnType(FutureOfWebSocket(), [core.Uri])))();
  let isInstanceOfOfWebSocketException = () => (isInstanceOfOfWebSocketException = dart.constFn(src__core_matchers.isInstanceOf$(src__web_socket__web_socket_exception.WebSocketException)))();
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let dynamicToNull = () => (dynamicToNull = dart.constFn(dart.fnType(core.Null, [dart.dynamic])))();
  let JSArrayOfString = () => (JSArrayOfString = dart.constFn(_interceptors.JSArray$(core.String)))();
  let StreamOfString = () => (StreamOfString = dart.constFn(async.Stream$(core.String)))();
  let CompleterOfNull = () => (CompleterOfNull = dart.constFn(async.Completer$(core.Null)))();
  let JSArrayOfFutureOfNull = () => (JSArrayOfFutureOfNull = dart.constFn(_interceptors.JSArray$(FutureOfNull())))();
  let CompleterOfString = () => (CompleterOfString = dart.constFn(async.Completer$(core.String)))();
  let FutureOrOfString = () => (FutureOrOfString = dart.constFn(async.FutureOr$(core.String)))();
  let IdentityMapOfint$CompleterOfNull = () => (IdentityMapOfint$CompleterOfNull = dart.constFn(_js_helper.IdentityMap$(core.int, CompleterOfNull())))();
  let intAndCompleterOfNullToNull = () => (intAndCompleterOfNullToNull = dart.constFn(dart.fnType(core.Null, [core.int, CompleterOfNull()])))();
  let MapOfint$CompleterOfNull = () => (MapOfint$CompleterOfNull = dart.constFn(core.Map$(core.int, CompleterOfNull())))();
  let ListOfString = () => (ListOfString = dart.constFn(core.List$(core.String)))();
  let const$;
  integration__ws__common.runCommonWebSocketIntegrationTests = function(opts) {
    let connect = opts && 'connect' in opts ? opts.connect : null;
    let port = opts && 'port' in opts ? opts.port : null;
    let transportPlatform = opts && 'transportPlatform' in opts ? opts.transportPlatform : null;
    let t = connect;
    t == null ? connect = dart.fn(uri => src__web_socket__web_socket.WebSocket.connect(uri, {transportPlatform: transportPlatform}), UriToFutureOfWebSocket()) : t;
    let closeUri = integration__integration_paths.IntegrationPaths.closeUri;
    let echoUri = integration__integration_paths.IntegrationPaths.echoUri;
    let fourOhFourUri = integration__integration_paths.IntegrationPaths.fourOhFourUri;
    let pingUri = integration__integration_paths.IntegrationPaths.pingUri;
    if (port != null) {
      closeUri = closeUri.replace({port: port});
      echoUri = echoUri.replace({port: port});
      pingUri = pingUri.replace({port: port});
    }
    test.test('should throw if connection cannot be established', dart.fn(() => async.async(core.Null, function*() {
      src__frontend__expect.expect(connect(fourOhFourUri), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfWebSocketException()).new()));
    }), VoidToFutureOfNull()));
    test.test('add() should send a message', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      let helper = new integration__ws__common.WSHelper.new(webSocket);
      webSocket.add('message');
      yield helper.messagesReceived(1);
      src__frontend__expect.expect(helper.messages[$single], src__core_matchers.equals('message'));
      yield webSocket.close();
    }), VoidToFutureOfNull()));
    test.test('add() should support sending multiple messages', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      let helper = new integration__ws__common.WSHelper.new(webSocket);
      webSocket.add('message1');
      webSocket.add('message2');
      yield helper.messagesReceived(2);
      src__frontend__expect.expect(helper.messages, src__iterable_matchers.unorderedEquals(['message1', 'message2']));
      yield webSocket.close();
    }), VoidToFutureOfNull()));
    test.test('add() should throw after sink has been closed', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      yield webSocket.close();
      src__frontend__expect.expect(dart.fn(() => {
        webSocket.add('too late');
      }, VoidToNull()), src__frontend__throws_matchers.throwsStateError);
    }), VoidToFutureOfNull()));
    test.test('addError() should close the socket with an error that can be caught', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      webSocket.addError(core.Exception.new('Exception should close the socket with an error.'));
      let error = null;
      try {
        yield webSocket.done;
      } catch (e) {
        error = e;
      }
      src__frontend__expect.expect(error, src__core_matchers.isNotNull);
      src__frontend__expect.expect(error, src__error_matchers.isException);
      yield webSocket.close().catchError(dart.fn(_ => {
      }, dynamicToNull()));
    }), VoidToFutureOfNull()));
    test.test('addStream() should send a Stream of data', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      let helper = new integration__ws__common.WSHelper.new(webSocket);
      let stream = StreamOfString().fromIterable(JSArrayOfString().of(['message1', 'message2']));
      yield webSocket.addStream(stream);
      yield helper.messagesReceived(2);
      src__frontend__expect.expect(helper.messages, src__iterable_matchers.unorderedEquals(['message1', 'message2']));
      yield webSocket.close();
    }), VoidToFutureOfNull()));
    test.test('addStream() should support sending multiple Streams serially', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      let helper = new integration__ws__common.WSHelper.new(webSocket);
      let stream1 = StreamOfString().fromIterable(JSArrayOfString().of(['message1a', 'message2a']));
      let stream2 = StreamOfString().fromIterable(JSArrayOfString().of(['message1b', 'message2b']));
      yield webSocket.addStream(stream1);
      yield webSocket.addStream(stream2);
      yield helper.messagesReceived(4);
      src__frontend__expect.expect(helper.messages, src__iterable_matchers.unorderedEquals(['message1a', 'message1b', 'message2a', 'message2b']));
      yield webSocket.close();
    }), VoidToFutureOfNull()));
    test.test('addStream() should throw if multiple Streams added concurrently', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      let stream = StreamOfString().fromIterable(JSArrayOfString().of(['message1', 'message2']));
      let firstFuture = webSocket.addStream(stream);
      let lateFuture = webSocket.addStream(stream);
      src__frontend__expect.expect(lateFuture, src__frontend__throws_matchers.throwsStateError);
      yield firstFuture;
      try {
        yield lateFuture;
      } catch (_) {
      }
      try {
        yield webSocket.close();
      } catch (_) {
      }
    }), VoidToFutureOfNull()));
    test.test('addStream() should throw after sink has been closed', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      yield webSocket.close();
      src__frontend__expect.expect(webSocket.addStream(async.Stream.fromIterable(['too late'])), src__frontend__throws_matchers.throwsStateError);
    }), VoidToFutureOfNull()));
    test.test('addStream() should cause socket to close if error is added', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      let controller = async.StreamController.new();
      controller.add('message1');
      controller.addError(core.Exception.new('addStream error, should close socket'));
      controller.close();
      yield webSocket.addStream(controller.stream);
      src__frontend__expect.expect(webSocket.done, src__frontend__throws_matchers.throwsException);
      yield webSocket.close().catchError(dart.fn(_ => {
      }, dynamicToNull()));
    }), VoidToFutureOfNull()));
    test.test('should support listening to incoming messages', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(pingUri));
      let helper = new integration__ws__common.WSHelper.new(webSocket);
      webSocket.add('ping2');
      yield helper.messagesReceived(2);
      src__frontend__expect.expect(helper.messages, src__iterable_matchers.unorderedEquals(['pong', 'pong']));
      yield webSocket.close();
    }), VoidToFutureOfNull()));
    test.test('should not allow multiple listeners by default', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      webSocket.listen(dart.fn(_ => {
      }, dynamicToNull()));
      src__frontend__expect.expect(dart.fn(() => {
        webSocket.listen(dart.fn(_ => {
        }, dynamicToNull()));
      }, VoidToNull()), src__frontend__throws_matchers.throwsStateError);
      yield webSocket.close();
    }), VoidToFutureOfNull()));
    test.test('should lose messages if a listener is registered late', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(pingUri));
      webSocket.add('ping2');
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      let helper = new integration__ws__common.WSHelper.new(webSocket);
      webSocket.add('ping3');
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      yield helper.messagesReceived(3);
      src__frontend__expect.expect(helper.messages, src__iterable_matchers.unorderedEquals(['pong', 'pong', 'pong']));
      yield webSocket.close();
    }), VoidToFutureOfNull()));
    test.test('should call onDone() when socket closes', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      let c = CompleterOfNull().new();
      webSocket.listen(dart.fn(_ => {
      }, dynamicToNull()), {onDone: dart.fn(() => {
          c.complete();
        }, VoidToNull())});
      webSocket.close();
      yield c.future;
    }), VoidToFutureOfNull()));
    test.test('should have the close code and reason available in onDone() callback', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      let c = CompleterOfNull().new();
      webSocket.listen(dart.fn(_ => {
      }, dynamicToNull()), {onDone: dart.fn(() => {
          src__frontend__expect.expect(webSocket.closeCode, src__core_matchers.equals(4001));
          src__frontend__expect.expect(webSocket.closeReason, src__core_matchers.equals('Closed.'));
          c.complete();
        }, VoidToNull())});
      webSocket.add('echo');
      async.Timer.new(new core.Duration.new({milliseconds: 200}), dart.fn(() => {
        webSocket.close(4001, 'Closed.');
      }, VoidToNull()));
      yield c.future;
    }), VoidToFutureOfNull()));
    test.test('should close successfully if a subscription is canceled prior to closing', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      let subscription = webSocket.listen(dart.fn(_ => {
      }, dynamicToNull()));
      yield subscription.cancel();
      yield webSocket.close(4001, 'Closed.');
      src__frontend__expect.expect(webSocket.closeCode, src__core_matchers.equals(4001));
      src__frontend__expect.expect(webSocket.closeReason, src__core_matchers.equals('Closed.'));
    }), VoidToFutureOfNull()));
    test.test('should not receive events once the subscription is canceled', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      let doneEventReceived = false;
      let messagesReceived = 0;
      let subscription = webSocket.listen(dart.fn(_ => {
        messagesReceived++;
      }, dynamicToNull()), {onDone: dart.fn(() => {
          doneEventReceived = true;
        }, VoidToNull())});
      webSocket.add('one');
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      yield subscription.cancel();
      webSocket.add('two');
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      src__frontend__expect.expect(messagesReceived, src__core_matchers.equals(1));
      yield webSocket.close();
      src__frontend__expect.expect(doneEventReceived, src__core_matchers.isFalse);
    }), VoidToFutureOfNull()));
    test.test('should not close if the only listener is canceled', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      let subscription = webSocket.listen(dart.fn(_ => {
      }, dynamicToNull()));
      yield subscription.cancel();
      webSocket.add('one');
      src__frontend__expect.expect(webSocket.closeCode, src__core_matchers.isNull);
      src__frontend__expect.expect(webSocket.closeReason, src__core_matchers.isNull);
      yield async.Future.delayed(const$ || (const$ = dart.const(new core.Duration.new({milliseconds: 100}))));
      yield webSocket.close();
    }), VoidToFutureOfNull()));
    test.test('should work as a broadcast stream', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(pingUri));
      let stream = webSocket.asBroadcastStream();
      let c1 = CompleterOfNull().new();
      let c2 = CompleterOfNull().new();
      stream.listen(dart.fn(_ => {
        c1.complete();
      }, dynamicToNull()));
      stream.listen(dart.fn(_ => {
        c2.complete();
      }, dynamicToNull()));
      webSocket.add('ping');
      yield async.Future.wait(core.Null, JSArrayOfFutureOfNull().of([c1.future, c2.future]));
      yield webSocket.close();
    }), VoidToFutureOfNull()));
    test.test('should have the close code and reason available after closing', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      yield webSocket.close(4001, 'Closed.');
      src__frontend__expect.expect(webSocket.closeCode, src__core_matchers.equals(4001));
      src__frontend__expect.expect(webSocket.closeReason, src__core_matchers.equals('Closed.'));
    }), VoidToFutureOfNull()));
    test.test('should close and properly drain stream even if no listeners were registered', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      yield webSocket.close();
    }), VoidToFutureOfNull()));
    test.test('should handle the server closing the connection', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(closeUri));
      webSocket.add(integration__ws__common._closeRequest());
      yield webSocket.done;
      yield webSocket.close();
    }), VoidToFutureOfNull()));
    test.test('should ignore close() being called after the server closes the connection', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(closeUri));
      webSocket.add(integration__ws__common._closeRequest(4001, 'Closed by server.'));
      yield webSocket.done;
      yield webSocket.close(4002, 'Late close.');
      src__frontend__expect.expect(webSocket.closeCode, src__core_matchers.equals(4001));
      src__frontend__expect.expect(webSocket.closeReason, src__core_matchers.equals('Closed by server.'));
    }), VoidToFutureOfNull()));
    test.test('should ignore close() calls after the first call', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      yield webSocket.close(4001, 'Custom close.');
      yield webSocket.close(4002, 'Late close.');
      src__frontend__expect.expect(webSocket.closeCode, src__core_matchers.equals(4001));
      src__frontend__expect.expect(webSocket.closeReason, src__core_matchers.equals('Custom close.'));
    }), VoidToFutureOfNull()));
    test.test('should report the close code and reason that the server used when closing the connection', dart.fn(() => async.async(core.Null, function*() {
      let socket = (yield connect(closeUri));
      socket.add(integration__ws__common._closeRequest(4001, 'Closed by server.'));
      yield socket.done;
      src__frontend__expect.expect(socket.closeCode, src__core_matchers.equals(4001));
      src__frontend__expect.expect(socket.closeReason, src__core_matchers.equals('Closed by server.'));
      yield socket.close();
    }), VoidToFutureOfNull()));
    test.test('message events should be discarded prior to a subscription', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      webSocket.add('1');
      webSocket.add('2');
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      let messages = JSArrayOfString().of([]);
      webSocket.listen(dart.fn(data => {
        messages[$add](core.String._check(data));
      }, dynamicToNull()));
      webSocket.add('3');
      webSocket.add('4');
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      yield webSocket.close();
      src__frontend__expect.expect(messages, src__iterable_matchers.orderedEquals(['3', '4']));
    }), VoidToFutureOfNull()));
    test.test('the first event should be received if a subscription is made immediately', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      let c = CompleterOfString().new();
      webSocket.listen(dart.fn(data => {
        c.complete(FutureOrOfString()._check(data));
      }, dynamicToNull()));
      webSocket.add('first');
      src__frontend__expect.expect(yield c.future, src__core_matchers.equals('first'));
      yield webSocket.close();
    }), VoidToFutureOfNull()));
    test.test('all event streams should respect pause() and resume() signals', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      let messages = JSArrayOfString().of([]);
      webSocket.add('1');
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      let sub = webSocket.listen(dart.fn(data => {
        messages[$add](core.String._check(data));
      }, dynamicToNull()));
      webSocket.add('2');
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      sub.pause();
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      webSocket.add('3');
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      sub.resume();
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      webSocket.add('4');
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      src__frontend__expect.expect(messages, src__iterable_matchers.orderedEquals(['2', '4']));
      yield webSocket.close();
      yield sub.cancel();
    }), VoidToFutureOfNull()));
    test.test('should support calling pause() with a resume signal', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      let messages = JSArrayOfString().of([]);
      let sub = webSocket.listen(dart.fn(data => {
        messages[$add](core.String._check(data));
      }, dynamicToNull()));
      webSocket.add('1');
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      let c = CompleterOfNull().new();
      sub.pause(c.future);
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      webSocket.add('2');
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      c.complete();
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      webSocket.add('3');
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      src__frontend__expect.expect(messages, src__iterable_matchers.orderedEquals(['1', '3']));
      yield webSocket.close();
      yield sub.cancel();
    }), VoidToFutureOfNull()));
    test.test('should support calling pause() with a resume signal even if it resolves with an error', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      let messages = JSArrayOfString().of([]);
      let sub = webSocket.listen(dart.fn(data => {
        messages[$add](core.String._check(data));
      }, dynamicToNull()));
      webSocket.add('1');
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      let c = CompleterOfNull().new();
      sub.pause(c.future);
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      webSocket.add('2');
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      c.completeError(core.Exception.new('Ignore. This error is expected.'));
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      webSocket.add('3');
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      src__frontend__expect.expect(messages, src__iterable_matchers.orderedEquals(['1', '3']));
      yield webSocket.close();
      yield sub.cancel();
    }), VoidToFutureOfNull()), {skip: 'Can\'t test without the exception causing the test to fail.'});
    test.test('should handle calling pause() multiple times', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      let messages = JSArrayOfString().of([]);
      let sub = webSocket.listen(dart.fn(data => {
        messages[$add](core.String._check(data));
      }, dynamicToNull()));
      webSocket.add('1');
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      sub.pause();
      sub.pause();
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      webSocket.add('2');
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      sub.resume();
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      webSocket.add('3');
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      sub.resume();
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      webSocket.add('4');
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      src__frontend__expect.expect(messages, src__iterable_matchers.orderedEquals(['1', '4']));
      yield webSocket.close();
      yield sub.cancel();
    }), VoidToFutureOfNull()));
    test.test('should support converting StreamSubscription to a Future', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(pingUri));
      let sub = webSocket.listen(dart.fn(_ => {
      }, dynamicToNull()));
      let future = sub.asFuture(core.String, 'futureValue');
      webSocket.close();
      src__frontend__expect.expect(yield future, src__core_matchers.equals('futureValue'));
      yield sub.cancel();
    }), VoidToFutureOfNull()));
    test.test('should support reassigning the onData() handler', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(echoUri));
      let origMessages = JSArrayOfString().of([]);
      let origOnData = data => {
        origMessages[$add](core.String._check(data));
      };
      dart.fn(origOnData, dynamicToNull());
      let newMessages = JSArrayOfString().of([]);
      let newOnData = data => {
        newMessages[$add](core.String._check(data));
      };
      dart.fn(newOnData, dynamicToNull());
      let subscription = webSocket.listen(origOnData);
      webSocket.add('1');
      webSocket.add('2');
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      subscription.onData(newOnData);
      webSocket.add('3');
      webSocket.add('4');
      yield async.Future.delayed(new core.Duration.new({milliseconds: 200}));
      src__frontend__expect.expect(origMessages, src__iterable_matchers.orderedEquals(['1', '2']));
      src__frontend__expect.expect(newMessages, src__iterable_matchers.orderedEquals(['3', '4']));
      yield webSocket.close();
      yield subscription.cancel();
    }), VoidToFutureOfNull()));
    test.test('should support reassigning the onDone() handler', dart.fn(() => async.async(core.Null, function*() {
      let webSocket = (yield connect(closeUri));
      let c = CompleterOfNull().new();
      let subscription = webSocket.listen(dart.fn(_ => {
      }, dynamicToNull()), {onDone: dart.fn(() => {
        }, VoidToNull())});
      subscription.onDone(dart.fn(() => {
        c.complete();
      }, VoidToNull()));
      webSocket.add(integration__ws__common._closeRequest());
      yield c.future;
      yield webSocket.close();
      yield subscription.cancel();
    }), VoidToFutureOfNull()));
  };
  integration__ws__common._closeRequest = function(closeCode, closeReason) {
    if (closeCode === void 0) closeCode = null;
    if (closeReason === void 0) closeReason = null;
    let c = 'close';
    if (closeCode != null) {
      c = dart.str`${c}:${closeCode}`;
      if (closeReason != null) {
        c = dart.str`${c}:${closeReason}`;
      }
    }
    return c;
  };
  const _completers = Symbol('_completers');
  const _messages = Symbol('_messages');
  integration__ws__common.WSHelper = class WSHelper extends core.Object {
    get socket() {
      return this[socket$];
    }
    set socket(value) {
      this[socket$] = value;
    }
    get messages() {
      return this[_messages];
    }
    messagesReceived(numMessages) {
      return async.async(core.Null, (function* messagesReceived() {
        if (dart.notNull(this[_messages][$length]) >= dart.notNull(numMessages)) return;
        let c = CompleterOfNull().new();
        this[_completers][$_set](numMessages, c);
        yield c.future;
      }).bind(this));
    }
  };
  (integration__ws__common.WSHelper.new = function(socket) {
    this[_completers] = new (IdentityMapOfint$CompleterOfNull()).new();
    this[_messages] = JSArrayOfString().of([]);
    this[socket$] = socket;
    this.socket.listen(dart.fn(message => {
      this[_messages][$add](core.String._check(message));
      this[_completers][$forEach](dart.fn((k, v) => {
        if (dart.notNull(k) <= dart.notNull(this[_messages][$length]) && !dart.test(v.isCompleted)) {
          v.complete();
        }
      }, intAndCompleterOfNullToNull()));
    }, dynamicToNull()));
  }).prototype = integration__ws__common.WSHelper.prototype;
  dart.addTypeTests(integration__ws__common.WSHelper);
  const socket$ = Symbol("WSHelper.socket");
  dart.setMethodSignature(integration__ws__common.WSHelper, () => ({
    __proto__: dart.getMethods(integration__ws__common.WSHelper.__proto__),
    messagesReceived: dart.fnType(async.Future$(core.Null), [core.int])
  }));
  dart.setGetterSignature(integration__ws__common.WSHelper, () => ({
    __proto__: dart.getGetters(integration__ws__common.WSHelper.__proto__),
    messages: core.Iterable$(core.String)
  }));
  dart.setFieldSignature(integration__ws__common.WSHelper, () => ({
    __proto__: dart.getFields(integration__ws__common.WSHelper.__proto__),
    socket: dart.fieldType(src__web_socket__web_socket.WebSocket),
    [_completers]: dart.fieldType(MapOfint$CompleterOfNull()),
    [_messages]: dart.fieldType(ListOfString())
  }));
  dart.trackLibraries("test/test__shared_18", {
    "integration/ws/common.dart": integration__ws__common
  }, null);
  // Exports:
  return {
    integration__ws__common: integration__ws__common
  };
});
