define(['dart_sdk', 'test/test__shared_2', 'packages/w_transport/lib__shared_1', 'packages/w_transport/lib__w_transport', 'packages/test/lib__test', 'test/test__shared_18', 'test/test__shared_0'], function(dart_sdk, test__shared_2, lib__shared_1, lib__w_transport, lib__test, test__shared_18, test__shared_0) {
  'use strict';
  const core = dart_sdk.core;
  const _interceptors = dart_sdk._interceptors;
  const async = dart_sdk.async;
  const html = dart_sdk.html;
  const typed_data = dart_sdk.typed_data;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming = test__shared_2.naming;
  const src__browser_transport_platform_with_sockjs = lib__shared_1.src__browser_transport_platform_with_sockjs;
  const src__browser_transport_platform = lib__shared_1.src__browser_transport_platform;
  const src__web_socket__web_socket = lib__w_transport.src__web_socket__web_socket;
  const test = lib__test.test;
  const src__frontend__throws_matchers = lib__test.src__frontend__throws_matchers;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const integration__ws__common = test__shared_18.integration__ws__common;
  const integration__integration_paths = test__shared_0.integration__integration_paths;
  const _root = Object.create(null);
  const integration__ws__sockjs_common = Object.create(_root);
  let JSArrayOfString = () => (JSArrayOfString = dart.constFn(_interceptors.JSArray$(core.String)))();
  let FutureOfWebSocket = () => (FutureOfWebSocket = dart.constFn(async.Future$(src__web_socket__web_socket.WebSocket)))();
  let UriAndStringToFutureOfWebSocket = () => (UriAndStringToFutureOfWebSocket = dart.constFn(dart.fnType(FutureOfWebSocket(), [core.Uri, core.String])))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let UriToFutureOfWebSocket = () => (UriToFutureOfWebSocket = dart.constFn(dart.fnType(FutureOfWebSocket(), [core.Uri])))();
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let JSArrayOfint = () => (JSArrayOfint = dart.constFn(_interceptors.JSArray$(core.int)))();
  dart.defineLazy(integration__ws__sockjs_common, {
    get _sockjsPort() {
      return 8026;
    }
  });
  integration__ws__sockjs_common.runCommonSockJSSuite = function(protocolsToTest, opts) {
    let usingSockjsPort = opts && 'usingSockjsPort' in opts ? opts.usingSockjsPort : true;
    let sockjsNaming = new naming.Naming.new();
    sockjsNaming.platform = dart.test(usingSockjsPort) ? "browser (SockJS Port)" : "browser (SockJS Wrapper)";
    sockjsNaming.testType = "integration";
    sockjsNaming.topic = "WS";
    let sockjsDeprecatedNaming = new naming.Naming.new();
    sockjsDeprecatedNaming.platform = dart.test(usingSockjsPort) ? "browser (SockJS Port) [DEPRECATED]" : "browser (SockJS Wrapper) [DEPRECATED]";
    sockjsDeprecatedNaming.testType = "integration";
    sockjsDeprecatedNaming.topic = "WS";
    test.group(sockjsNaming.toString(), dart.fn(() => {
      integration__ws__sockjs_common._sockJSSuite(protocolsToTest, dart.fn((uri, protocol) => src__web_socket__web_socket.WebSocket.connect(uri, {transportPlatform: new src__browser_transport_platform_with_sockjs.BrowserTransportPlatformWithSockJS.new({sockJSNoCredentials: true, sockJSProtocolsWhitelist: JSArrayOfString().of([protocol])})}), UriAndStringToFutureOfWebSocket()));
    }, VoidToNull()));
    test.group(sockjsDeprecatedNaming.toString(), dart.fn(() => {
      integration__ws__sockjs_common._sockJSSuite(protocolsToTest, dart.fn((uri, protocol) => src__web_socket__web_socket.WebSocket.connect(uri, {useSockJS: true, sockJSNoCredentials: true, sockJSProtocolsWhitelist: JSArrayOfString().of([protocol]), transportPlatform: src__browser_transport_platform.browserTransportPlatform}), UriAndStringToFutureOfWebSocket()));
    }, VoidToNull()));
  };
  integration__ws__sockjs_common._sockJSSuite = function(protocolsToTest, connect) {
    for (let protocol of protocolsToTest) {
      test.group(dart.str`(protocol=${protocol})`, dart.fn(() => {
        integration__ws__common.runCommonWebSocketIntegrationTests({connect: dart.fn(uri => connect(uri, protocol), UriToFutureOfWebSocket()), port: 8026});
        let echoUri = integration__integration_paths.IntegrationPaths.echoUri.replace({port: 8026});
        let pingUri = integration__integration_paths.IntegrationPaths.pingUri.replace({port: 8026});
        test.test('should not support Blob', dart.fn(() => async.async(core.Null, function*() {
          let blob = html.Blob.new(['one', 'two']);
          let socket = (yield connect(pingUri, protocol));
          src__frontend__expect.expect(dart.fn(() => {
            socket.add(blob);
          }, VoidToNull()), src__frontend__throws_matchers.throwsArgumentError);
          yield socket.close();
        }), VoidToFutureOfNull()));
        test.test('should support String', dart.fn(() => async.async(core.Null, function*() {
          let data = 'data';
          let socket = (yield connect(echoUri, protocol));
          socket.add(data);
          yield socket.close();
        }), VoidToFutureOfNull()));
        test.test('should not support TypedData', dart.fn(() => async.async(core.Null, function*() {
          let data = typed_data.Uint16List.fromList(JSArrayOfint().of([1, 2, 3]));
          let socket = (yield connect(echoUri, protocol));
          src__frontend__expect.expect(dart.fn(() => {
            socket.add(data);
          }, VoidToNull()), src__frontend__throws_matchers.throwsArgumentError);
          yield socket.close();
        }), VoidToFutureOfNull()));
        test.test('should throw when attempting to send invalid data', dart.fn(() => async.async(core.Null, function*() {
          let socket = (yield connect(pingUri, protocol));
          src__frontend__expect.expect(dart.fn(() => {
            socket.add(true);
          }, VoidToNull()), src__frontend__throws_matchers.throwsArgumentError);
          yield socket.close();
        }), VoidToFutureOfNull()));
      }, VoidToNull()));
    }
  };
  dart.trackLibraries("test/test__shared_19", {
    "integration/ws/sockjs_common.dart": integration__ws__sockjs_common
  }, null);
  // Exports:
  return {
    integration__ws__sockjs_common: integration__ws__sockjs_common
  };
});
