define(['dart_sdk'], function(dart_sdk) {
  'use strict';
  const core = dart_sdk.core;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const _root = Object.create(null);
  const naming = Object.create(_root);
  dart.defineLazy(naming, {
    get platformBrowser() {
      return 'browser';
    },
    get platformBrowserSockjsPort() {
      return 'browser (SockJS Port)';
    },
    get platformBrowserSockjsWrapper() {
      return 'browser (SockJS Wrapper)';
    },
    get platformBrowserSockjsPortDeprecated() {
      return 'browser (SockJS Port) [DEPRECATED]';
    },
    get platformBrowserSockjsWrapperDeprecated() {
      return 'browser (SockJS Wrapper) [DEPRECATED]';
    },
    get platformMock() {
      return 'mock';
    },
    get platformVM() {
      return 'vm';
    },
    get testTypeIntegration() {
      return 'integration';
    },
    get testTypeUnit() {
      return 'unit';
    },
    get topicBackoff() {
      return 'Backoff';
    },
    get topicHttp() {
      return 'HTTP';
    },
    get topicMocks() {
      return 'Mocks';
    },
    get topicTransportPlatform() {
      return 'Transport Platform';
    },
    get topicWebSocket() {
      return 'WS';
    },
    get topicGlobalWebSocketMonitor() {
      return 'GlobalWebSocketMonitor';
    }
  });
  naming.Naming = class Naming extends core.Object {
    get platform() {
      return this[platform];
    }
    set platform(value) {
      this[platform] = value;
    }
    get testType() {
      return this[testType];
    }
    set testType(value) {
      this[testType] = value;
    }
    get topic() {
      return this[topic];
    }
    set topic(value) {
      this[topic] = value;
    }
    toString() {
      let s = dart.str`${this.topic} [${this.testType}]`;
      if (this.platform != null) {
        s = s + dart.str` [${this.platform}]`;
      }
      return s;
    }
  };
  (naming.Naming.new = function() {
    this[platform] = null;
    this[testType] = null;
    this[topic] = null;
  }).prototype = naming.Naming.prototype;
  dart.addTypeTests(naming.Naming);
  const platform = Symbol("Naming.platform");
  const testType = Symbol("Naming.testType");
  const topic = Symbol("Naming.topic");
  dart.setFieldSignature(naming.Naming, () => ({
    __proto__: dart.getFields(naming.Naming.__proto__),
    platform: dart.fieldType(core.String),
    testType: dart.fieldType(core.String),
    topic: dart.fieldType(core.String)
  }));
  dart.defineExtensionMethods(naming.Naming, ['toString']);
  dart.trackLibraries("test/test__shared_2", {
    "naming.dart": naming
  }, null);
  // Exports:
  return {
    naming: naming
  };
});
