define(['dart_sdk', 'packages/w_transport/lib__w_transport', 'packages/dart2_constant/lib__convert', 'packages/test/lib__test', 'test/test__shared_0', 'packages/matcher/lib__shared_0', 'packages/w_transport/lib__shared_0'], function(dart_sdk, lib__w_transport, lib__convert, lib__test, test__shared_0, lib__shared_0, lib__shared_0$) {
  'use strict';
  const core = dart_sdk.core;
  const _js_helper = dart_sdk._js_helper;
  const _interceptors = dart_sdk._interceptors;
  const async = dart_sdk.async;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const src__http__requests = lib__w_transport.src__http__requests;
  const src__http__request_exception = lib__w_transport.src__http__request_exception;
  const src__http__base_request = lib__w_transport.src__http__base_request;
  const convert = lib__convert.convert;
  const test = lib__test.test;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const src__frontend__throws_matcher = lib__test.src__frontend__throws_matcher;
  const integration__integration_paths = test__shared_0.integration__integration_paths;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const src__map_matchers = lib__shared_0.src__map_matchers;
  const src__http__request_progress = lib__shared_0$.src__http__request_progress;
  const _root = Object.create(null);
  const integration__http__common_request__suite = Object.create(_root);
  const $_set = dartx._set;
  const $length = dartx.length;
  const $_get = dartx._get;
  const $contains = dartx.contains;
  const $toString = dartx.toString;
  const $removeAt = dartx.removeAt;
  let __ToFormRequest = () => (__ToFormRequest = dart.constFn(dart.fnType(src__http__requests.FormRequest, [], {withBody: core.bool})))();
  let IdentityMapOfString$String = () => (IdentityMapOfString$String = dart.constFn(_js_helper.IdentityMap$(core.String, core.String)))();
  let MapOfString$String = () => (MapOfString$String = dart.constFn(core.Map$(core.String, core.String)))();
  let JSArrayOfMapOfString$String = () => (JSArrayOfMapOfString$String = dart.constFn(_interceptors.JSArray$(MapOfString$String())))();
  let __ToJsonRequest = () => (__ToJsonRequest = dart.constFn(dart.fnType(src__http__requests.JsonRequest, [], {withBody: core.bool})))();
  let __ToMultipartRequest = () => (__ToMultipartRequest = dart.constFn(dart.fnType(src__http__requests.MultipartRequest, [], {withBody: core.bool})))();
  let __ToRequest = () => (__ToRequest = dart.constFn(dart.fnType(src__http__requests.Request, [], {withBody: core.bool})))();
  let ListOfint = () => (ListOfint = dart.constFn(core.List$(core.int)))();
  let JSArrayOfListOfint = () => (JSArrayOfListOfint = dart.constFn(_interceptors.JSArray$(ListOfint())))();
  let StreamOfListOfint = () => (StreamOfListOfint = dart.constFn(async.Stream$(ListOfint())))();
  let __ToStreamedRequest = () => (__ToStreamedRequest = dart.constFn(dart.fnType(src__http__requests.StreamedRequest, [], {withBody: core.bool})))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let CompleterOfNull = () => (CompleterOfNull = dart.constFn(async.Completer$(core.Null)))();
  let RequestProgressToNull = () => (RequestProgressToNull = dart.constFn(dart.fnType(core.Null, [src__http__request_progress.RequestProgress])))();
  let dynamicTobool = () => (dynamicTobool = dart.constFn(dart.fnType(core.bool, [dart.dynamic])))();
  let isInstanceOfOfRequestException = () => (isInstanceOfOfRequestException = dart.constFn(src__core_matchers.isInstanceOf$(src__http__request_exception.RequestException)))();
  let JSArrayOfint = () => (JSArrayOfint = dart.constFn(_interceptors.JSArray$(core.int)))();
  let IdentityMapOfString$dynamic = () => (IdentityMapOfString$dynamic = dart.constFn(_js_helper.IdentityMap$(core.String, dart.dynamic)))();
  let BaseRequestToNull = () => (BaseRequestToNull = dart.constFn(dart.fnType(core.Null, [src__http__base_request.BaseRequest])))();
  integration__http__common_request__suite.runCommonRequestSuite = function(transportPlatform) {
    if (transportPlatform === void 0) transportPlatform = null;
    test.group('Common Request API', dart.fn(() => {
      function formReqFactory(opts) {
        let withBody = opts && 'withBody' in opts ? opts.withBody : false;
        if (!dart.test(withBody)) return src__http__requests.FormRequest.new({transportPlatform: transportPlatform});
        let _ = src__http__requests.FormRequest.new({transportPlatform: transportPlatform});
        _.fields[$_set]('field', 'value');
        return _;
      }
      dart.fn(formReqFactory, __ToFormRequest());
      function jsonReqFactory(opts) {
        let withBody = opts && 'withBody' in opts ? opts.withBody : false;
        if (!dart.test(withBody)) return src__http__requests.JsonRequest.new({transportPlatform: transportPlatform});
        let _ = src__http__requests.JsonRequest.new({transportPlatform: transportPlatform});
        _.body = JSArrayOfMapOfString$String().of([new (IdentityMapOfString$String()).from(['field', 'value'])]);
        return _;
      }
      dart.fn(jsonReqFactory, __ToJsonRequest());
      function multipartReqFactory(opts) {
        let withBody = opts && 'withBody' in opts ? opts.withBody : null;
        let _ = src__http__requests.MultipartRequest.new({transportPlatform: transportPlatform});
        _.fields[$_set]('field', 'value');
        return _;
      }
      dart.fn(multipartReqFactory, __ToMultipartRequest());
      function reqFactory(opts) {
        let withBody = opts && 'withBody' in opts ? opts.withBody : false;
        if (!dart.test(withBody)) return src__http__requests.Request.new({transportPlatform: transportPlatform});
        let _ = src__http__requests.Request.new({transportPlatform: transportPlatform});
        _.body = 'body';
        return _;
      }
      dart.fn(reqFactory, __ToRequest());
      function streamedReqFactory(opts) {
        let withBody = opts && 'withBody' in opts ? opts.withBody : false;
        if (!dart.test(withBody)) return src__http__requests.StreamedRequest.new({transportPlatform: transportPlatform});
        let _ = src__http__requests.StreamedRequest.new({transportPlatform: transportPlatform});
        _.body = StreamOfListOfint().fromIterable(JSArrayOfListOfint().of([convert.utf8.encode('bytes')]));
        _.contentLength = convert.utf8.encode('bytes')[$length];
        return _;
      }
      dart.fn(streamedReqFactory, __ToStreamedRequest());
      integration__http__common_request__suite._runCommonRequestSuiteFor('FormRequest', formReqFactory);
      integration__http__common_request__suite._runCommonRequestSuiteFor('JsonRequest', jsonReqFactory);
      integration__http__common_request__suite._runCommonRequestSuiteFor('MultipartRequest', multipartReqFactory);
      integration__http__common_request__suite._runCommonRequestSuiteFor('Request', reqFactory);
      integration__http__common_request__suite._runCommonRequestSuiteFor('StreamedRequest', streamedReqFactory);
      integration__http__common_request__suite._runAutoRetryTestSuiteFor('FormRequest', formReqFactory);
      integration__http__common_request__suite._runAutoRetryTestSuiteFor('JsonRequest', jsonReqFactory);
      integration__http__common_request__suite._runAutoRetryTestSuiteFor('MultipartRequest', multipartReqFactory);
      integration__http__common_request__suite._runAutoRetryTestSuiteFor('Request', reqFactory);
    }, VoidToNull()));
  };
  integration__http__common_request__suite._runCommonRequestSuiteFor = function(name, requestFactory) {
    test.group(name, dart.fn(() => {
      let headers = new (IdentityMapOfString$String()).from(['authorization', 'test', 'x-custom', 'value', 'x-tokens', 'token1, token2']);
      test.test('"done" should complete when the request succeeds', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        request.post({uri: integration__integration_paths.IntegrationPaths.reflectEndpointUri});
        yield request.done;
      }), VoidToFutureOfNull()));
      test.test('"done" should complete when the request is canceled', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        try {
          let future = request.post({uri: integration__integration_paths.IntegrationPaths.timeoutEndpointUri});
          yield async.Future.delayed(new core.Duration.new({milliseconds: 5}));
          request.abort();
          yield future;
        } catch (_) {
          if (src__http__request_exception.RequestException.is(_)) {
          } else
            throw _;
        }
        yield request.done;
      }), VoidToFutureOfNull()));
      test.test('"done" should complete when the request fails', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        try {
          yield request.post({uri: integration__integration_paths.IntegrationPaths.fourOhFourEndpointUri});
        } catch (_) {
          if (src__http__request_exception.RequestException.is(_)) {
          } else
            throw _;
        }
        yield request.done;
      }), VoidToFutureOfNull()));
      test.test('DELETE (streamed)', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        let response = (yield request.streamDelete({uri: integration__integration_paths.IntegrationPaths.downloadEndpointUri}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        src__frontend__expect.expect(yield response.body.byteStream.isEmpty, src__core_matchers.isFalse);
      }), VoidToFutureOfNull()));
      test.test('GET (streamed)', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        let response = (yield request.streamGet({uri: integration__integration_paths.IntegrationPaths.downloadEndpointUri}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        src__frontend__expect.expect(yield response.body.byteStream.isEmpty, src__core_matchers.isFalse);
      }), VoidToFutureOfNull()));
      test.test('HEAD (streamed)', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        let response = (yield request.streamHead({uri: integration__integration_paths.IntegrationPaths.downloadEndpointUri}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
      }), VoidToFutureOfNull()));
      test.test('OPTIONS (streamed)', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        let response = (yield request.streamOptions({uri: integration__integration_paths.IntegrationPaths.downloadEndpointUri}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        src__frontend__expect.expect(yield response.body.byteStream.isEmpty, src__core_matchers.isFalse);
      }), VoidToFutureOfNull()));
      test.test('PATCH (streamed)', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        let response = (yield request.streamPatch({uri: integration__integration_paths.IntegrationPaths.downloadEndpointUri}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        src__frontend__expect.expect(yield response.body.byteStream.isEmpty, src__core_matchers.isFalse);
      }), VoidToFutureOfNull()));
      test.test('POST (streamed)', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        let response = (yield request.streamPost({uri: integration__integration_paths.IntegrationPaths.downloadEndpointUri}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        src__frontend__expect.expect(yield response.body.byteStream.isEmpty, src__core_matchers.isFalse);
      }), VoidToFutureOfNull()));
      test.test('PUT (streamed)', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        let response = (yield request.streamPut({uri: integration__integration_paths.IntegrationPaths.downloadEndpointUri}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        src__frontend__expect.expect(yield response.body.byteStream.isEmpty, src__core_matchers.isFalse);
      }), VoidToFutureOfNull()));
      test.test('custom HTTP method (streamed)', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        let response = (yield request.streamSend('COPY', {uri: integration__integration_paths.IntegrationPaths.downloadEndpointUri}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        src__frontend__expect.expect(yield response.body.byteStream.isEmpty, src__core_matchers.isFalse);
      }), VoidToFutureOfNull()));
      test.test('DELETE request', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        let response = (yield request.delete({uri: integration__integration_paths.IntegrationPaths.reflectEndpointUri}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        src__frontend__expect.expect(dart.dindex(response.body.asJson(), 'method'), src__core_matchers.equals('DELETE'));
      }), VoidToFutureOfNull()));
      test.test('DELETE request with headers', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        request.uri = integration__integration_paths.IntegrationPaths.reflectEndpointUri;
        request.headers = MapOfString$String().from(headers);
        let response = (yield request.delete());
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = response.body.asJson();
        src__frontend__expect.expect(dart.dindex(json, 'method'), src__core_matchers.equals('DELETE'));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('authorization', request.headers[$_get]('authorization')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-custom', request.headers[$_get]('x-custom')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-tokens', request.headers[$_get]('x-tokens')));
      }), VoidToFutureOfNull()));
      test.test('GET request', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        let response = (yield request.get({uri: integration__integration_paths.IntegrationPaths.reflectEndpointUri}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        src__frontend__expect.expect(dart.dindex(response.body.asJson(), 'method'), src__core_matchers.equals('GET'));
      }), VoidToFutureOfNull()));
      test.test('GET request with headers', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        request.uri = integration__integration_paths.IntegrationPaths.reflectEndpointUri;
        request.headers = MapOfString$String().from(headers);
        let response = (yield request.get());
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = response.body.asJson();
        src__frontend__expect.expect(dart.dindex(json, 'method'), src__core_matchers.equals('GET'));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('authorization', request.headers[$_get]('authorization')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-custom', request.headers[$_get]('x-custom')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-tokens', request.headers[$_get]('x-tokens')));
      }), VoidToFutureOfNull()));
      test.test('HEAD request', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        let response = (yield request.head({uri: integration__integration_paths.IntegrationPaths.reflectEndpointUri}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
      }), VoidToFutureOfNull()));
      test.test('HEAD request with headers', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        request.uri = integration__integration_paths.IntegrationPaths.reflectEndpointUri;
        request.headers = MapOfString$String().from(headers);
        let response = (yield request.head());
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
      }), VoidToFutureOfNull()));
      test.test('OPTIONS request', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        let response = (yield request.options({uri: integration__integration_paths.IntegrationPaths.reflectEndpointUri}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        src__frontend__expect.expect(dart.dindex(response.body.asJson(), 'method'), src__core_matchers.equals('OPTIONS'));
      }), VoidToFutureOfNull()));
      test.test('OPTIONS request with headers', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        request.uri = integration__integration_paths.IntegrationPaths.reflectEndpointUri;
        request.headers = MapOfString$String().from(headers);
        let response = (yield request.options());
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = response.body.asJson();
        src__frontend__expect.expect(dart.dindex(json, 'method'), src__core_matchers.equals('OPTIONS'));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('authorization', request.headers[$_get]('authorization')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-custom', request.headers[$_get]('x-custom')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-tokens', request.headers[$_get]('x-tokens')));
      }), VoidToFutureOfNull()));
      test.test('PATCH request', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        let response = (yield request.patch({uri: integration__integration_paths.IntegrationPaths.reflectEndpointUri}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        src__frontend__expect.expect(dart.dindex(response.body.asJson(), 'method'), src__core_matchers.equals('PATCH'));
      }), VoidToFutureOfNull()));
      test.test('PATCH request with headers', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        request.uri = integration__integration_paths.IntegrationPaths.reflectEndpointUri;
        request.headers = MapOfString$String().from(headers);
        let response = (yield request.patch());
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = response.body.asJson();
        src__frontend__expect.expect(dart.dindex(json, 'method'), src__core_matchers.equals('PATCH'));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('authorization', request.headers[$_get]('authorization')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-custom', request.headers[$_get]('x-custom')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-tokens', request.headers[$_get]('x-tokens')));
      }), VoidToFutureOfNull()));
      test.test('POST request', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        let response = (yield request.post({uri: integration__integration_paths.IntegrationPaths.reflectEndpointUri}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        src__frontend__expect.expect(dart.dindex(response.body.asJson(), 'method'), src__core_matchers.equals('POST'));
      }), VoidToFutureOfNull()));
      test.test('POST request with headers', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        request.uri = integration__integration_paths.IntegrationPaths.reflectEndpointUri;
        request.headers = MapOfString$String().from(headers);
        let response = (yield request.post());
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = response.body.asJson();
        src__frontend__expect.expect(dart.dindex(json, 'method'), src__core_matchers.equals('POST'));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('authorization', request.headers[$_get]('authorization')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-custom', request.headers[$_get]('x-custom')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-tokens', request.headers[$_get]('x-tokens')));
      }), VoidToFutureOfNull()));
      test.test('PUT request', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        let response = (yield request.put({uri: integration__integration_paths.IntegrationPaths.reflectEndpointUri}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        src__frontend__expect.expect(dart.dindex(response.body.asJson(), 'method'), src__core_matchers.equals('PUT'));
      }), VoidToFutureOfNull()));
      test.test('PUT request with headers', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        request.uri = integration__integration_paths.IntegrationPaths.reflectEndpointUri;
        request.headers = MapOfString$String().from(headers);
        let response = (yield request.put());
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = response.body.asJson();
        src__frontend__expect.expect(dart.dindex(json, 'method'), src__core_matchers.equals('PUT'));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('authorization', request.headers[$_get]('authorization')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-custom', request.headers[$_get]('x-custom')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-tokens', request.headers[$_get]('x-tokens')));
      }), VoidToFutureOfNull()));
      test.test('upload progress stream', dart.fn(() => async.async(core.Null, function*() {
        let uploadProgressListenedTo = CompleterOfNull().new();
        let request = requestFactory({withBody: true});
        request.uri = integration__integration_paths.IntegrationPaths.reflectEndpointUri;
        request.uploadProgress.listen(dart.fn(progress => {
          if (dart.notNull(progress.percent) > 0 && !dart.test(uploadProgressListenedTo.isCompleted)) {
            uploadProgressListenedTo.complete();
          }
        }, RequestProgressToNull()));
        yield request.post();
        yield uploadProgressListenedTo.future;
      }), VoidToFutureOfNull()));
      test.test('download progress stream', dart.fn(() => async.async(core.Null, function*() {
        let downloadProgressListenedTo = CompleterOfNull().new();
        let request = requestFactory();
        request.uri = integration__integration_paths.IntegrationPaths.downloadEndpointUri;
        request.downloadProgress.listen(dart.fn(progress => {
          if (dart.notNull(progress.percent) > 0 && !dart.test(downloadProgressListenedTo.isCompleted)) {
            downloadProgressListenedTo.complete();
          }
        }, RequestProgressToNull()));
        yield request.get();
        yield downloadProgressListenedTo.future;
      }), VoidToFutureOfNull()));
      test.test('should throw RequestException on failed requests', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        request.uri = integration__integration_paths.IntegrationPaths.fourOhFourEndpointUri;
        src__frontend__expect.expect(request.get(), src__frontend__throws_matcher.throwsA(src__core_matchers.predicate(dart.dynamic, dart.fn(exception => exception != null && src__http__request_exception.RequestException.is(exception) && exception.method === 'GET' && dart.equals(exception.uri, integration__integration_paths.IntegrationPaths.fourOhFourEndpointUri), dynamicTobool()), 'throws a RequestException')));
      }), VoidToFutureOfNull()));
      test.test('request cancellation prior to dispatch should cause request to fail', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        request.uri = integration__integration_paths.IntegrationPaths.hostUri;
        request.abort();
        src__frontend__expect.expect(request.get(), src__frontend__throws_matcher.throwsA(src__core_matchers.predicate(dart.dynamic, dart.fn(exception => src__http__request_exception.RequestException.is(exception) && dart.toString(exception)[$contains]('canceled'), dynamicTobool()))));
      }), VoidToFutureOfNull()));
      test.test('request cancellation after dispatch but prior to resolution should cause request to fail', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        request.uri = integration__integration_paths.IntegrationPaths.timeoutEndpointUri;
        let future = request.get();
        yield async.Future.delayed(new core.Duration.new({seconds: 1}));
        request.abort();
        src__frontend__expect.expect(future, src__frontend__throws_matcher.throwsA(new (isInstanceOfOfRequestException()).new()));
      }), VoidToFutureOfNull()));
      test.test('timeoutThreshold does nothing if request completes in time', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        request.timeoutThreshold = new core.Duration.new({seconds: 5});
        yield request.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
      }), VoidToFutureOfNull()));
      test.test('timeoutThreshold cancels the request if exceeded', dart.fn(() => async.async(core.Null, function*() {
        let request = requestFactory();
        request.timeoutThreshold = new core.Duration.new({milliseconds: 250});
        src__frontend__expect.expect(request.get({uri: integration__integration_paths.IntegrationPaths.timeoutEndpointUri}), src__frontend__throws_matcher.throwsA(src__core_matchers.predicate(dart.dynamic, dart.fn(error => src__http__request_exception.RequestException.is(error) && async.TimeoutException.is(error.error), dynamicTobool()))));
      }), VoidToFutureOfNull()));
    }, VoidToNull()));
  };
  integration__http__common_request__suite._runAutoRetryTestSuiteFor = function(name, requestFactory) {
    test.group(name, dart.fn(() => {
      test.group('auto retry', dart.fn(() => {
        test.test('disabled', dart.fn(() => async.async(core.Null, function*() {
          let request = requestFactory();
          integration__http__common_request__suite.defineResponseChain(request, JSArrayOfint().of([500]));
          src__frontend__expect.expect(request.get(), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfRequestException()).new()));
          yield request.done;
          src__frontend__expect.expect(request.autoRetry.numAttempts, src__core_matchers.equals(1));
          src__frontend__expect.expect(request.autoRetry.failures[$length], src__core_matchers.equals(1));
        }), VoidToFutureOfNull()));
        test.test('no retries', dart.fn(() => async.async(core.Null, function*() {
          let request = requestFactory();
          let _ = request.autoRetry;
          _.enabled = true;
          _.maxRetries = 2;
          integration__http__common_request__suite.defineResponseChain(request, JSArrayOfint().of([200]));
          yield request.get();
          src__frontend__expect.expect(request.autoRetry.numAttempts, src__core_matchers.equals(1));
          src__frontend__expect.expect(request.autoRetry.failures, src__core_matchers.isEmpty);
        }), VoidToFutureOfNull()));
        test.test('1 successful retry', dart.fn(() => async.async(core.Null, function*() {
          let request = requestFactory();
          let _ = request.autoRetry;
          _.enabled = true;
          _.maxRetries = 2;
          integration__http__common_request__suite.defineResponseChain(request, JSArrayOfint().of([500, 200]));
          yield request.get();
          src__frontend__expect.expect(request.autoRetry.numAttempts, src__core_matchers.equals(2));
          src__frontend__expect.expect(request.autoRetry.failures[$length], src__core_matchers.equals(1));
        }), VoidToFutureOfNull()));
        test.test('1 failed retry, 1 successful retry', dart.fn(() => async.async(core.Null, function*() {
          let request = requestFactory();
          let _ = request.autoRetry;
          _.enabled = true;
          _.maxRetries = 2;
          integration__http__common_request__suite.defineResponseChain(request, JSArrayOfint().of([500, 500, 200]));
          yield request.get();
          src__frontend__expect.expect(request.autoRetry.numAttempts, src__core_matchers.equals(3));
          src__frontend__expect.expect(request.autoRetry.failures[$length], src__core_matchers.equals(2));
        }), VoidToFutureOfNull()));
        test.test('maximum retries exceeded', dart.fn(() => async.async(core.Null, function*() {
          let request = requestFactory();
          let _ = request.autoRetry;
          _.enabled = true;
          _.maxRetries = 2;
          integration__http__common_request__suite.defineResponseChain(request, JSArrayOfint().of([500, 500, 500]));
          src__frontend__expect.expect(request.get(), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfRequestException()).new()));
          yield request.done;
          src__frontend__expect.expect(request.autoRetry.numAttempts, src__core_matchers.equals(3));
          src__frontend__expect.expect(request.autoRetry.failures[$length], src__core_matchers.equals(3));
        }), VoidToFutureOfNull()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  integration__http__common_request__suite.defineResponseChain = function(request, statusCodes) {
    request.uri = integration__integration_paths.IntegrationPaths.customEndpointUri;
    request.requestInterceptor = dart.fn(request => {
      request.updateQuery(new (IdentityMapOfString$dynamic()).from(['status', dart.toString(statusCodes[$removeAt](0))]));
    }, BaseRequestToNull());
  };
  dart.trackLibraries("test/test__shared_5", {
    "integration/http/common_request/suite.dart": integration__http__common_request__suite
  }, null);
  // Exports:
  return {
    integration__http__common_request__suite: integration__http__common_request__suite
  };
});
