define(['dart_sdk', 'packages/w_transport/lib__w_transport', 'test/test__shared_0', 'packages/matcher/lib__shared_0', 'packages/test/lib__test', 'packages/http_parser/lib__http_parser', 'packages/dart2_constant/lib__convert'], function(dart_sdk, lib__w_transport, test__shared_0, lib__shared_0, lib__test, lib__http_parser, lib__convert) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const _interceptors = dart_sdk._interceptors;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const src__http__requests = lib__w_transport.src__http__requests;
  const src__http__utils = lib__w_transport.src__http__utils;
  const integration__integration_paths = test__shared_0.integration__integration_paths;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const src__order_matchers = lib__shared_0.src__order_matchers;
  const src__map_matchers = lib__shared_0.src__map_matchers;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const test = lib__test.test;
  const src__frontend__throws_matchers = lib__test.src__frontend__throws_matchers;
  const src__media_type = lib__http_parser.src__media_type;
  const convert = lib__convert.convert;
  const _root = Object.create(null);
  const integration__http__form_request__suite = Object.create(_root);
  const $_set = dartx._set;
  const $_get = dartx._get;
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let JSArrayOfString = () => (JSArrayOfString = dart.constFn(_interceptors.JSArray$(core.String)))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  integration__http__form_request__suite.runFormRequestSuite = function(transportPlatform) {
    if (transportPlatform === void 0) transportPlatform = null;
    test.group('FormRequest', dart.fn(() => {
      test.test('content-length should be set automatically', dart.fn(() => async.async(core.Null, function*() {
        let emptyRequest = src__http__requests.FormRequest.new({transportPlatform: transportPlatform});
        let response = (yield emptyRequest.post({uri: integration__integration_paths.IntegrationPaths.reflectEndpointUri}));
        let contentLength = core.int.parse(core.String._check(dart.dindex(dart.dindex(response.body.asJson(), 'headers'), 'content-length')));
        src__frontend__expect.expect(contentLength, src__core_matchers.equals(0), {reason: 'Empty form request\'s content-length should be 0.'});
        let nonEmptyRequest = src__http__requests.FormRequest.new({transportPlatform: transportPlatform});
        nonEmptyRequest.uri = integration__integration_paths.IntegrationPaths.reflectEndpointUri;
        nonEmptyRequest.fields[$_set]('field1', 'value1');
        nonEmptyRequest.fields[$_set]('field2', 'value2');
        let response2 = (yield nonEmptyRequest.post());
        let contentLength2 = core.int.parse(core.String._check(dart.dindex(dart.dindex(response2.body.asJson(), 'headers'), 'content-length')));
        src__frontend__expect.expect(contentLength2, src__order_matchers.greaterThan(0), {reason: 'Non-empty form request\'s content-length should be greater than 0.'});
      }), VoidToFutureOfNull()));
      test.test('content-type should be set automatically', dart.fn(() => async.async(core.Null, function*() {
        let request = src__http__requests.FormRequest.new({transportPlatform: transportPlatform});
        request.uri = integration__integration_paths.IntegrationPaths.reflectEndpointUri;
        request.fields[$_set]('field', 'value');
        let response = (yield request.post());
        let contentType = src__media_type.MediaType.parse(core.String._check(dart.dindex(dart.dindex(response.body.asJson(), 'headers'), 'content-type')));
        src__frontend__expect.expect(contentType.mimeType, src__core_matchers.equals('application/x-www-form-urlencoded'));
      }), VoidToFutureOfNull()));
      test.test('content-type should be overridable', dart.fn(() => async.async(core.Null, function*() {
        let contentType = new src__media_type.MediaType.new('application', 'x-custom');
        let request = src__http__requests.FormRequest.new({transportPlatform: transportPlatform});
        request.uri = integration__integration_paths.IntegrationPaths.reflectEndpointUri;
        request.fields[$_set]('field', 'value');
        request.contentType = contentType;
        let response = (yield request.post());
        let reflectedContentType = src__media_type.MediaType.parse(core.String._check(dart.dindex(dart.dindex(response.body.asJson(), 'headers'), 'content-type')));
        src__frontend__expect.expect(reflectedContentType.mimeType, src__core_matchers.equals(contentType.mimeType));
      }), VoidToFutureOfNull()));
      test.test('UTF8', dart.fn(() => async.async(core.Null, function*() {
        let request = src__http__requests.FormRequest.new({transportPlatform: transportPlatform});
        request.uri = integration__integration_paths.IntegrationPaths.echoEndpointUri;
        request.encoding = convert.utf8;
        request.fields[$_set]('field1', 'value1');
        request.fields[$_set]('field2', 'ç®å');
        let response = (yield request.post());
        src__frontend__expect.expect(response.encoding.name, src__core_matchers.equals(convert.utf8.name));
        let echo = src__http__utils.queryToMap(response.body.asString(), {encoding: response.encoding});
        src__frontend__expect.expect(echo, src__map_matchers.containsPair('field1', 'value1'));
        src__frontend__expect.expect(echo, src__map_matchers.containsPair('field2', 'ç®å'));
      }), VoidToFutureOfNull()));
      test.test('LATIN1', dart.fn(() => async.async(core.Null, function*() {
        let request = src__http__requests.FormRequest.new({transportPlatform: transportPlatform});
        request.uri = integration__integration_paths.IntegrationPaths.echoEndpointUri;
        request.encoding = convert.latin1;
        request.fields[$_set]('field1', 'value1');
        request.fields[$_set]('field2', 'ç®å');
        let response = (yield request.post());
        src__frontend__expect.expect(response.encoding.name, src__core_matchers.equals(convert.latin1.name));
        let echo = src__http__utils.queryToMap(response.body.asString(), {encoding: response.encoding});
        src__frontend__expect.expect(echo, src__map_matchers.containsPair('field1', 'value1'));
        src__frontend__expect.expect(echo, src__map_matchers.containsPair('field2', 'ç®å'));
      }), VoidToFutureOfNull()));
      test.test('ASCII', dart.fn(() => async.async(core.Null, function*() {
        let request = src__http__requests.FormRequest.new({transportPlatform: transportPlatform});
        request.uri = integration__integration_paths.IntegrationPaths.echoEndpointUri;
        request.encoding = convert.ascii;
        request.fields[$_set]('field1', 'value1');
        request.fields[$_set]('field2', 'value2');
        let response = (yield request.post());
        src__frontend__expect.expect(response.encoding.name, src__core_matchers.equals(convert.ascii.name));
        let echo = src__http__utils.queryToMap(response.body.asString(), {encoding: response.encoding});
        src__frontend__expect.expect(echo, src__map_matchers.containsPair('field1', 'value1'));
        src__frontend__expect.expect(echo, src__map_matchers.containsPair('field2', 'value2'));
      }), VoidToFutureOfNull()));
      test.test('should support multiple values for a single field', dart.fn(() => async.async(core.Null, function*() {
        let request = src__http__requests.FormRequest.new({transportPlatform: transportPlatform});
        request.uri = integration__integration_paths.IntegrationPaths.echoEndpointUri;
        request.fields[$_set]('items', JSArrayOfString().of(['one', 'two']));
        let response = (yield request.post());
        let echo = src__http__utils.queryToMap(response.body.asString());
        src__frontend__expect.expect(echo[$_get]('items'), src__core_matchers.equals(JSArrayOfString().of(['one', 'two'])));
      }), VoidToFutureOfNull()));
      test.test('should prevent unsupported value types (anything other than String and List<String>)', dart.fn(() => {
        let request = src__http__requests.FormRequest.new({transportPlatform: transportPlatform});
        request.uri = integration__integration_paths.IntegrationPaths.echoEndpointUri;
        request.fields[$_set]('invalid', 10);
        src__frontend__expect.expect(request.post(), src__frontend__throws_matchers.throwsArgumentError);
      }, VoidToNull()));
    }, VoidToNull()));
  };
  dart.trackLibraries("test/test__shared_6", {
    "integration/http/form_request/suite.dart": integration__http__form_request__suite
  }, null);
  // Exports:
  return {
    integration__http__form_request__suite: integration__http__form_request__suite
  };
});
