define(['dart_sdk', 'test/test__shared_2', 'packages/w_transport/lib__shared_1', 'packages/w_transport/lib__shared_0', 'packages/matcher/lib__shared_0', 'packages/test/lib__test'], function(dart_sdk, test__shared_2, lib__shared_1, lib__shared_0, lib__shared_0$, lib__test) {
  'use strict';
  const core = dart_sdk.core;
  const html = dart_sdk.html;
  const _interceptors = dart_sdk._interceptors;
  const async = dart_sdk.async;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const src__http__browser__utils = lib__shared_1.src__http__browser__utils;
  const src__http__request_progress = lib__shared_0.src__http__request_progress;
  const src__core_matchers = lib__shared_0$.src__core_matchers;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const test = lib__test.test;
  const _root = Object.create(null);
  const unit__http__browser_utils_test = Object.create(_root);
  const $_get = dartx._get;
  const $composedPath = dartx.composedPath;
  const $preventDefault = dartx.preventDefault;
  const $stopImmediatePropagation = dartx.stopImmediatePropagation;
  const $stopPropagation = dartx.stopPropagation;
  const $matchingTarget = dartx.matchingTarget;
  const $path = dartx.path;
  const $currentTarget = dartx.currentTarget;
  const $target = dartx.target;
  const $bubbles = dartx.bubbles;
  const $cancelable = dartx.cancelable;
  const $composed = dartx.composed;
  const $defaultPrevented = dartx.defaultPrevented;
  const $eventPhase = dartx.eventPhase;
  const $isTrusted = dartx.isTrusted;
  const $timeStamp = dartx.timeStamp;
  const $type = dartx.type;
  let JSArrayOfProgressEvent = () => (JSArrayOfProgressEvent = dart.constFn(_interceptors.JSArray$(html.ProgressEvent)))();
  let StreamOfProgressEvent = () => (StreamOfProgressEvent = dart.constFn(async.Stream$(html.ProgressEvent)))();
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let StreamControllerOfProgressEvent = () => (StreamControllerOfProgressEvent = dart.constFn(async.StreamController$(html.ProgressEvent)))();
  let CompleterOfNull = () => (CompleterOfNull = dart.constFn(async.Completer$(core.Null)))();
  let RequestProgressToNull = () => (RequestProgressToNull = dart.constFn(dart.fnType(core.Null, [src__http__request_progress.RequestProgress])))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let ListOfEventTarget = () => (ListOfEventTarget = dart.constFn(core.List$(html.EventTarget)))();
  unit__http__browser_utils_test.main = function() {
    let naming = new naming$.Naming.new();
    naming.platform = "browser";
    naming.testType = "unit";
    naming.topic = "HTTP";
    test.group(naming.toString(), dart.fn(() => {
      test.group('utils transformProgressEvents', dart.fn(() => {
        test.test('should convert computable ProgressEvents to WProgress instances with correct values', dart.fn(() => async.async(core.Null, function*() {
          let eventStream = StreamOfProgressEvent().fromIterable(JSArrayOfProgressEvent().of([new unit__http__browser_utils_test.MockProgressEvent.computable(0, 100), new unit__http__browser_utils_test.MockProgressEvent.computable(10, 100), new unit__http__browser_utils_test.MockProgressEvent.computable(50, 100), new unit__http__browser_utils_test.MockProgressEvent.computable(73, 100), new unit__http__browser_utils_test.MockProgressEvent.computable(100, 100)]));
          let requestProgressStream = eventStream.transform(src__http__request_progress.RequestProgress, src__http__browser__utils.transformProgressEvents);
          let wEvents = (yield requestProgressStream.toList());
          src__frontend__expect.expect(wEvents[$_get](0).percent, src__core_matchers.equals(0.0));
          src__frontend__expect.expect(wEvents[$_get](1).percent, src__core_matchers.equals(10.0));
          src__frontend__expect.expect(wEvents[$_get](2).percent, src__core_matchers.equals(50.0));
          src__frontend__expect.expect(wEvents[$_get](3).percent, src__core_matchers.equals(73.0));
          src__frontend__expect.expect(wEvents[$_get](4).percent, src__core_matchers.equals(100.0));
        }), VoidToFutureOfNull()));
        test.test('should convert non-computable ProgressEvents to WProgress instances with 0% values', dart.fn(() => async.async(core.Null, function*() {
          let events = StreamOfProgressEvent().fromIterable(JSArrayOfProgressEvent().of([new unit__http__browser_utils_test.MockProgressEvent.nonComputable(), new unit__http__browser_utils_test.MockProgressEvent.nonComputable()]));
          let wEventStream = events.transform(src__http__request_progress.RequestProgress, src__http__browser__utils.transformProgressEvents);
          let wEvents = (yield wEventStream.toList());
          src__frontend__expect.expect(wEvents[$_get](0).percent, src__core_matchers.equals(0.0));
          src__frontend__expect.expect(wEvents[$_get](1).percent, src__core_matchers.equals(0.0));
        }), VoidToFutureOfNull()));
        test.test('should support pausing and resuming a subscription', dart.fn(() => async.async(core.Null, function*() {
          let eventController = StreamControllerOfProgressEvent().new();
          let wEventStream = eventController.stream.transform(src__http__request_progress.RequestProgress, src__http__browser__utils.transformProgressEvents);
          let c = CompleterOfNull().new();
          let eventCount = 0;
          let subscription = wEventStream.listen(dart.fn(_ => {
            eventCount++;
          }, RequestProgressToNull()), {onDone: dart.bind(c, 'complete')});
          eventController.add(new unit__http__browser_utils_test.MockProgressEvent.nonComputable());
          subscription.pause();
          eventController.add(new unit__http__browser_utils_test.MockProgressEvent.nonComputable());
          eventController.add(new unit__http__browser_utils_test.MockProgressEvent.nonComputable());
          subscription.resume();
          eventController.add(new unit__http__browser_utils_test.MockProgressEvent.nonComputable());
          yield eventController.close();
          yield c.future;
          src__frontend__expect.expect(eventCount, src__core_matchers.equals(4));
          yield subscription.cancel();
        }), VoidToFutureOfNull()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  const _initEvent = Symbol('_initEvent');
  const _selector = Symbol('_selector');
  const _get_currentTarget = Symbol('_get_currentTarget');
  const _get_target = Symbol('_get_target');
  unit__http__browser_utils_test.MockProgressEvent = class MockProgressEvent extends core.Object {
    get lengthComputable() {
      return this[lengthComputable];
    }
    set lengthComputable(value) {
      this[lengthComputable] = value;
    }
    get loaded() {
      return this[loaded$];
    }
    set loaded(value) {
      this[loaded$] = value;
    }
    get total() {
      return this[total$];
    }
    set total(value) {
      this[total$] = value;
    }
    noSuchMethod(i) {
      return super.noSuchMethod(i);
    }
    composedPath(...args) {
      return ListOfEventTarget()._check(this.noSuchMethod(new dart.InvocationImpl.new($composedPath, args, {isMethod: true})));
    }
    [_initEvent](...args) {
      return dart.void._check(this.noSuchMethod(new dart.InvocationImpl.new(_initEvent, args, {isMethod: true})));
    }
    preventDefault(...args) {
      return dart.void._check(this.noSuchMethod(new dart.InvocationImpl.new($preventDefault, args, {isMethod: true})));
    }
    stopImmediatePropagation(...args) {
      return dart.void._check(this.noSuchMethod(new dart.InvocationImpl.new($stopImmediatePropagation, args, {isMethod: true})));
    }
    stopPropagation(...args) {
      return dart.void._check(this.noSuchMethod(new dart.InvocationImpl.new($stopPropagation, args, {isMethod: true})));
    }
    get matchingTarget() {
      return html.Element._check(this.noSuchMethod(new dart.InvocationImpl.new($matchingTarget, [], {isGetter: true})));
    }
    get path() {
      return ListOfEventTarget()._check(this.noSuchMethod(new dart.InvocationImpl.new($path, [], {isGetter: true})));
    }
    get currentTarget() {
      return html.EventTarget._check(this.noSuchMethod(new dart.InvocationImpl.new($currentTarget, [], {isGetter: true})));
    }
    get target() {
      return html.EventTarget._check(this.noSuchMethod(new dart.InvocationImpl.new($target, [], {isGetter: true})));
    }
    get [_selector]() {
      return core.String._check(this.noSuchMethod(new dart.InvocationImpl.new(_selector, [], {isGetter: true})));
    }
    set [_selector](value) {
      return dart.void._check(this.noSuchMethod(new dart.InvocationImpl.new(_selector, [value], {isSetter: true})));
    }
    get bubbles() {
      return core.bool._check(this.noSuchMethod(new dart.InvocationImpl.new($bubbles, [], {isGetter: true})));
    }
    get cancelable() {
      return core.bool._check(this.noSuchMethod(new dart.InvocationImpl.new($cancelable, [], {isGetter: true})));
    }
    get composed() {
      return core.bool._check(this.noSuchMethod(new dart.InvocationImpl.new($composed, [], {isGetter: true})));
    }
    get [_get_currentTarget]() {
      return this.noSuchMethod(new dart.InvocationImpl.new(_get_currentTarget, [], {isGetter: true}));
    }
    get defaultPrevented() {
      return core.bool._check(this.noSuchMethod(new dart.InvocationImpl.new($defaultPrevented, [], {isGetter: true})));
    }
    get eventPhase() {
      return core.int._check(this.noSuchMethod(new dart.InvocationImpl.new($eventPhase, [], {isGetter: true})));
    }
    get isTrusted() {
      return core.bool._check(this.noSuchMethod(new dart.InvocationImpl.new($isTrusted, [], {isGetter: true})));
    }
    get [_get_target]() {
      return this.noSuchMethod(new dart.InvocationImpl.new(_get_target, [], {isGetter: true}));
    }
    get timeStamp() {
      return core.num._check(this.noSuchMethod(new dart.InvocationImpl.new($timeStamp, [], {isGetter: true})));
    }
    get type() {
      return core.String._check(this.noSuchMethod(new dart.InvocationImpl.new($type, [], {isGetter: true})));
    }
  };
  (unit__http__browser_utils_test.MockProgressEvent.computable = function(loaded, total) {
    this[loaded$] = loaded;
    this[total$] = total;
    this[lengthComputable] = true;
  }).prototype = unit__http__browser_utils_test.MockProgressEvent.prototype;
  (unit__http__browser_utils_test.MockProgressEvent.nonComputable = function() {
    this[loaded$] = null;
    this[total$] = null;
    this[lengthComputable] = false;
  }).prototype = unit__http__browser_utils_test.MockProgressEvent.prototype;
  dart.addTypeTests(unit__http__browser_utils_test.MockProgressEvent);
  const lengthComputable = Symbol("MockProgressEvent.lengthComputable");
  const loaded$ = Symbol("MockProgressEvent.loaded");
  const total$ = Symbol("MockProgressEvent.total");
  unit__http__browser_utils_test.MockProgressEvent[dart.implements] = () => [html.ProgressEvent];
  dart.setMethodSignature(unit__http__browser_utils_test.MockProgressEvent, () => ({
    __proto__: dart.getMethods(unit__http__browser_utils_test.MockProgressEvent.__proto__),
    [$composedPath]: dart.fnType(core.List$(html.EventTarget), []),
    [$composedPath]: dart.fnType(core.List$(html.EventTarget), []),
    [_initEvent]: dart.fnType(dart.void, [core.String], [core.bool, core.bool]),
    [$preventDefault]: dart.fnType(dart.void, []),
    [$preventDefault]: dart.fnType(dart.void, []),
    [$stopImmediatePropagation]: dart.fnType(dart.void, []),
    [$stopImmediatePropagation]: dart.fnType(dart.void, []),
    [$stopPropagation]: dart.fnType(dart.void, []),
    [$stopPropagation]: dart.fnType(dart.void, [])
  }));
  dart.setGetterSignature(unit__http__browser_utils_test.MockProgressEvent, () => ({
    __proto__: dart.getGetters(unit__http__browser_utils_test.MockProgressEvent.__proto__),
    [$matchingTarget]: html.Element,
    [$matchingTarget]: html.Element,
    [$path]: core.List$(html.EventTarget),
    [$path]: core.List$(html.EventTarget),
    [$currentTarget]: html.EventTarget,
    [$currentTarget]: html.EventTarget,
    [$target]: html.EventTarget,
    [$target]: html.EventTarget,
    [_selector]: core.String,
    [$bubbles]: core.bool,
    [$bubbles]: core.bool,
    [$cancelable]: core.bool,
    [$cancelable]: core.bool,
    [$composed]: core.bool,
    [$composed]: core.bool,
    [_get_currentTarget]: dart.dynamic,
    [$defaultPrevented]: core.bool,
    [$defaultPrevented]: core.bool,
    [$eventPhase]: core.int,
    [$eventPhase]: core.int,
    [$isTrusted]: core.bool,
    [$isTrusted]: core.bool,
    [_get_target]: dart.dynamic,
    [$timeStamp]: core.num,
    [$timeStamp]: core.num,
    [$type]: core.String,
    [$type]: core.String
  }));
  dart.setSetterSignature(unit__http__browser_utils_test.MockProgressEvent, () => ({
    __proto__: dart.getSetters(unit__http__browser_utils_test.MockProgressEvent.__proto__),
    [_selector]: core.String
  }));
  dart.setFieldSignature(unit__http__browser_utils_test.MockProgressEvent, () => ({
    __proto__: dart.getFields(unit__http__browser_utils_test.MockProgressEvent.__proto__),
    lengthComputable: dart.fieldType(core.bool),
    loaded: dart.fieldType(core.int),
    total: dart.fieldType(core.int)
  }));
  dart.defineExtensionMethods(unit__http__browser_utils_test.MockProgressEvent, [
    'noSuchMethod',
    'composedPath',
    'preventDefault',
    'stopImmediatePropagation',
    'stopPropagation'
  ]);
  dart.defineExtensionAccessors(unit__http__browser_utils_test.MockProgressEvent, [
    'lengthComputable',
    'loaded',
    'total',
    'matchingTarget',
    'path',
    'currentTarget',
    'target',
    'bubbles',
    'cancelable',
    'composed',
    'defaultPrevented',
    'eventPhase',
    'isTrusted',
    'timeStamp',
    'type'
  ]);
  dart.trackLibraries("test/test__unit__http__browser_utils_test", {
    "unit/http/browser_utils_test.dart": unit__http__browser_utils_test
  }, null);
  // Exports:
  return {
    unit__http__browser_utils_test: unit__http__browser_utils_test
  };
});
