define(['dart_sdk', 'test/test__shared_2', 'packages/w_transport/lib__w_transport', 'packages/test/lib__test', 'packages/matcher/lib__shared_0', 'packages/dart2_constant/lib__convert', 'packages/http_parser/lib__http_parser'], function(dart_sdk, test__shared_2, lib__w_transport, lib__test, lib__shared_0, lib__convert, lib__http_parser) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const _js_helper = dart_sdk._js_helper;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const src__mocks__mock_transports = lib__w_transport.src__mocks__mock_transports;
  const src__http__requests = lib__w_transport.src__http__requests;
  const src__http__http_body = lib__w_transport.src__http__http_body;
  const src__http__mock__response = lib__w_transport.src__http__mock__response;
  const src__http__finalized_request = lib__w_transport.src__http__finalized_request;
  const test = lib__test.test;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const src__frontend__throws_matchers = lib__test.src__frontend__throws_matchers;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const convert = lib__convert.convert;
  const src__media_type = lib__http_parser.src__media_type;
  const _root = Object.create(null);
  const unit__http__form_request_test = Object.create(_root);
  const $_set = dartx._set;
  const $_get = dartx._get;
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let IdentityMapOfString$dynamic = () => (IdentityMapOfString$dynamic = dart.constFn(_js_helper.IdentityMap$(core.String, dart.dynamic)))();
  let IdentityMapOfString$String = () => (IdentityMapOfString$String = dart.constFn(_js_helper.IdentityMap$(core.String, core.String)))();
  let CompleterOfString = () => (CompleterOfString = dart.constFn(async.Completer$(core.String)))();
  let FutureOfMockResponse = () => (FutureOfMockResponse = dart.constFn(async.Future$(src__http__mock__response.MockResponse)))();
  let FinalizedRequestToFutureOfMockResponse = () => (FinalizedRequestToFutureOfMockResponse = dart.constFn(dart.fnType(FutureOfMockResponse(), [src__http__finalized_request.FinalizedRequest])))();
  unit__http__form_request_test.main = function() {
    let naming = new naming$.Naming.new();
    naming.testType = "unit";
    naming.topic = "HTTP";
    test.group(naming.toString(), dart.fn(() => {
      test.group('FormRequest', dart.fn(() => {
        test.setUp(dart.fn(() => {
          src__mocks__mock_transports.MockTransports.install();
        }, VoidToNull()));
        test.tearDown(dart.fn(() => async.async(core.Null, function*() {
          src__mocks__mock_transports.MockTransports.verifyNoOutstandingExceptions();
          yield src__mocks__mock_transports.MockTransports.uninstall();
        }), VoidToFutureOfNull()));
        test.test('setting fields defaults to empty map if null', dart.fn(() => {
          let request = src__http__requests.FormRequest.new();
          request.fields = null;
          src__frontend__expect.expect(request.fields, src__core_matchers.equals(new _js_helper.LinkedMap.new()));
        }, VoidToNull()));
        test.test('setting entire fields map', dart.fn(() => {
          let request = src__http__requests.FormRequest.new();
          request.fields = new (IdentityMapOfString$dynamic()).from(['field', 'value']);
          src__frontend__expect.expect(request.fields, src__core_matchers.equals(new (IdentityMapOfString$String()).from(['field', 'value'])));
        }, VoidToNull()));
        test.test('setting fields incrementally', dart.fn(() => {
          let request = src__http__requests.FormRequest.new();
          request.fields[$_set]('field1', 'value1');
          request.fields[$_set]('field2', 'value2');
          src__frontend__expect.expect(request.fields, src__core_matchers.equals(new (IdentityMapOfString$String()).from(['field1', 'value1', 'field2', 'value2'])));
        }, VoidToNull()));
        test.test('setting body in request dispatcher is supported', dart.fn(() => async.async(core.Null, function*() {
          let uri = core.Uri.parse('/test');
          let c = CompleterOfString().new();
          src__mocks__mock_transports.MockTransports.http.when(uri, dart.fn(request => async.async(src__http__mock__response.MockResponse, function*() {
            let body = src__http__http_body.HttpBody._check(request.body);
            c.complete(body.asString());
            return src__http__mock__response.MockResponse.ok();
          }), FinalizedRequestToFutureOfMockResponse()));
          let request = src__http__requests.FormRequest.new();
          yield request.post({uri: uri, body: new (IdentityMapOfString$String()).from(['field', 'value'])});
          src__frontend__expect.expect(yield c.future, src__core_matchers.equals('field=value'));
        }), VoidToFutureOfNull()));
        test.test('setting body in request dispatcher should throw if invalid', dart.fn(() => async.async(core.Null, function*() {
          let uri = core.Uri.parse('/test');
          let request = src__http__requests.FormRequest.new();
          src__frontend__expect.expect(request.post({uri: uri, body: 'invalid'}), src__frontend__throws_matchers.throwsArgumentError);
        }), VoidToFutureOfNull()));
        test.test('body should be unmodifiable once sent', dart.fn(() => async.async(core.Null, function*() {
          let uri = core.Uri.parse('/test');
          src__mocks__mock_transports.MockTransports.http.expect('POST', uri);
          let request = src__http__requests.FormRequest.new();
          yield request.post({uri: uri});
          src__frontend__expect.expect(dart.fn(() => {
            request.fields[$_set]('too', 'late');
          }, VoidToNull()), src__frontend__throws_matchers.throwsUnsupportedError);
          src__frontend__expect.expect(dart.fn(() => {
            request.fields = new (IdentityMapOfString$dynamic()).from(['new', 'field']);
          }, VoidToNull()), src__frontend__throws_matchers.throwsStateError);
        }), VoidToFutureOfNull()));
        test.test('content-length cannot be set manually', dart.fn(() => {
          let request = src__http__requests.Request.new();
          src__frontend__expect.expect(dart.fn(() => {
            request.contentLength = 10;
          }, VoidToNull()), src__frontend__throws_matchers.throwsUnsupportedError);
        }, VoidToNull()));
        test.test('setting encoding to null should throw', dart.fn(() => {
          let request = src__http__requests.FormRequest.new();
          src__frontend__expect.expect(dart.fn(() => {
            request.encoding = null;
          }, VoidToNull()), src__frontend__throws_matchers.throwsArgumentError);
        }, VoidToNull()));
        test.test('setting encoding should update content-type', dart.fn(() => {
          let request = src__http__requests.FormRequest.new();
          src__frontend__expect.expect(request.contentType.parameters[$_get]('charset'), src__core_matchers.equals(convert.utf8.name));
          request.encoding = convert.latin1;
          src__frontend__expect.expect(request.contentType.parameters[$_get]('charset'), src__core_matchers.equals(convert.latin1.name));
          request.encoding = convert.ascii;
          src__frontend__expect.expect(request.contentType.parameters[$_get]('charset'), src__core_matchers.equals(convert.ascii.name));
        }, VoidToNull()));
        test.test('setting encoding should not update content-type if content-type has been set manually', dart.fn(() => {
          let request = src__http__requests.FormRequest.new();
          src__frontend__expect.expect(request.contentType.parameters[$_get]('charset'), src__core_matchers.equals(convert.utf8.name));
          request.contentType = new src__media_type.MediaType.new('application', 'x-custom', new (IdentityMapOfString$String()).from(['charset', convert.latin1.name]));
          src__frontend__expect.expect(request.contentType.mimeType, src__core_matchers.equals('application/x-custom'));
          src__frontend__expect.expect(request.contentType.parameters[$_get]('charset'), src__core_matchers.equals(convert.latin1.name));
          request.encoding = convert.ascii;
          src__frontend__expect.expect(request.contentType.parameters[$_get]('charset'), src__core_matchers.equals(convert.latin1.name));
        }, VoidToNull()));
        test.test('setting content-type should not be allowed once sent', dart.fn(() => async.async(core.Null, function*() {
          let uri = core.Uri.parse('/test');
          src__mocks__mock_transports.MockTransports.http.expect('GET', uri);
          let request = src__http__requests.FormRequest.new();
          yield request.get({uri: uri});
          src__frontend__expect.expect(dart.fn(() => {
            request.contentType = new src__media_type.MediaType.new('application', 'x-custom');
          }, VoidToNull()), src__frontend__throws_matchers.throwsStateError);
        }), VoidToFutureOfNull()));
        test.test('setting encoding should not be allowed once sent', dart.fn(() => async.async(core.Null, function*() {
          let uri = core.Uri.parse('/test');
          src__mocks__mock_transports.MockTransports.http.expect('GET', uri);
          let request = src__http__requests.FormRequest.new();
          yield request.get({uri: uri});
          src__frontend__expect.expect(dart.fn(() => {
            request.encoding = convert.latin1;
          }, VoidToNull()), src__frontend__throws_matchers.throwsStateError);
        }), VoidToFutureOfNull()));
        test.test('custom content-type without inferrable encoding', dart.fn(() => async.async(core.Null, function*() {
          let uri = core.Uri.parse('/test');
          src__mocks__mock_transports.MockTransports.http.expect('POST', uri);
          let request = src__http__requests.FormRequest.new();
          request.contentType = new src__media_type.MediaType.new('application', 'x-custom');
          request.fields[$_set]('foo', 'bar');
          yield request.post({uri: uri});
        }), VoidToFutureOfNull()));
        test.test('clone()', dart.fn(() => {
          let fields = new (IdentityMapOfString$String()).from(['f1', 'v1', 'f2', 'v2']);
          let orig = src__http__requests.FormRequest.new();
          orig.fields = fields;
          let clone = orig.clone();
          src__frontend__expect.expect(clone.fields, src__core_matchers.equals(fields));
        }, VoidToNull()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  dart.trackLibraries("test/test__unit__http__form_request_test", {
    "unit/http/form_request_test.dart": unit__http__form_request_test
  }, null);
  // Exports:
  return {
    unit__http__form_request_test: unit__http__form_request_test
  };
});
