define(['dart_sdk', 'test/test__shared_2', 'packages/http_parser/lib__http_parser', 'packages/w_transport/lib__w_transport', 'packages/matcher/lib__shared_0', 'packages/test/lib__test', 'packages/dart2_constant/lib__convert', 'packages/w_transport/lib__shared_0'], function(dart_sdk, test__shared_2, lib__http_parser, lib__w_transport, lib__shared_0, lib__test, lib__convert, lib__shared_0$) {
  'use strict';
  const core = dart_sdk.core;
  const _js_helper = dart_sdk._js_helper;
  const _interceptors = dart_sdk._interceptors;
  const typed_data = dart_sdk.typed_data;
  const async = dart_sdk.async;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const src__media_type = lib__http_parser.src__media_type;
  const src__http__http_body = lib__w_transport.src__http__http_body;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const test = lib__test.test;
  const convert = lib__convert.convert;
  const src__http__response_format_exception = lib__shared_0$.src__http__response_format_exception;
  const _root = Object.create(null);
  const unit__http__http_body_test = Object.create(_root);
  const $toString = dartx.toString;
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let IdentityMapOfString$String = () => (IdentityMapOfString$String = dart.constFn(_js_helper.IdentityMap$(core.String, core.String)))();
  let JSArrayOfint = () => (JSArrayOfint = dart.constFn(_interceptors.JSArray$(core.int)))();
  let MapOfString$String = () => (MapOfString$String = dart.constFn(core.Map$(core.String, core.String)))();
  let JSArrayOfMapOfString$String = () => (JSArrayOfMapOfString$String = dart.constFn(_interceptors.JSArray$(MapOfString$String())))();
  let isInstanceOfOfResponseFormatException = () => (isInstanceOfOfResponseFormatException = dart.constFn(src__core_matchers.isInstanceOf$(src__http__response_format_exception.ResponseFormatException)))();
  let ListOfint = () => (ListOfint = dart.constFn(core.List$(core.int)))();
  let JSArrayOfListOfint = () => (JSArrayOfListOfint = dart.constFn(_interceptors.JSArray$(ListOfint())))();
  let StreamOfListOfint = () => (StreamOfListOfint = dart.constFn(async.Stream$(ListOfint())))();
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  unit__http__http_body_test.main = function() {
    let naming = new naming$.Naming.new();
    naming.testType = "unit";
    naming.topic = "HTTP";
    test.group(naming.toString(), dart.fn(() => {
      test.group('HttpBody', dart.fn(() => {
        test.test('.fromBytes() ctor should default to empty list', dart.fn(() => {
          let contentType = new src__media_type.MediaType.new('text', 'plain');
          let body = new src__http__http_body.HttpBody.fromBytes(contentType, null);
          src__frontend__expect.expect(body.asBytes(), src__core_matchers.isEmpty);
        }, VoidToNull()));
        test.test('should use encoding if one is explicitly given', dart.fn(() => {
          let contentType = new src__media_type.MediaType.new('text', 'plain');
          let stringBody = new src__http__http_body.HttpBody.fromString(contentType, 'body', {encoding: convert.ascii});
          src__frontend__expect.expect(stringBody.encoding, src__core_matchers.equals(convert.ascii));
          let bytesBody = new src__http__http_body.HttpBody.fromBytes(contentType, convert.utf8.encode('body'), {encoding: convert.ascii});
          src__frontend__expect.expect(bytesBody.encoding, src__core_matchers.equals(convert.ascii));
        }, VoidToNull()));
        test.test('should parse encoding from content-type', dart.fn(() => {
          let contentType = new src__media_type.MediaType.new('text', 'plain', new (IdentityMapOfString$String()).from(['charset', convert.ascii.name]));
          let stringBody = new src__http__http_body.HttpBody.fromString(contentType, 'body');
          src__frontend__expect.expect(stringBody.encoding, src__core_matchers.equals(convert.ascii));
          let bytesBody = new src__http__http_body.HttpBody.fromBytes(contentType, convert.utf8.encode('body'));
          src__frontend__expect.expect(bytesBody.encoding, src__core_matchers.equals(convert.ascii));
        }, VoidToNull()));
        test.test('should allow a fallback encoding', dart.fn(() => {
          let contentType = new src__media_type.MediaType.new('text', 'plain');
          let stringBody = new src__http__http_body.HttpBody.fromString(contentType, 'body', {fallbackEncoding: convert.ascii});
          src__frontend__expect.expect(stringBody.encoding, src__core_matchers.equals(convert.ascii));
          let bytesBody = new src__http__http_body.HttpBody.fromBytes(contentType, convert.utf8.encode('body'), {fallbackEncoding: convert.ascii});
          src__frontend__expect.expect(bytesBody.encoding, src__core_matchers.equals(convert.ascii));
        }, VoidToNull()));
        test.test('should use UTF8 by default', dart.fn(() => {
          let contentType = new src__media_type.MediaType.new('text', 'plain');
          let stringBody = new src__http__http_body.HttpBody.fromString(contentType, 'body');
          src__frontend__expect.expect(stringBody.encoding, src__core_matchers.equals(convert.utf8));
          let bytesBody = new src__http__http_body.HttpBody.fromBytes(contentType, convert.utf8.encode('body'));
          src__frontend__expect.expect(bytesBody.encoding, src__core_matchers.equals(convert.utf8));
        }, VoidToNull()));
        test.test('content-length should be calculated automaticlaly', dart.fn(() => {
          let contentType = new src__media_type.MediaType.new('text', 'plain');
          let body = new src__http__http_body.HttpBody.fromBytes(contentType, JSArrayOfint().of([1, 2, 3, 4]));
          src__frontend__expect.expect(body.contentLength, src__core_matchers.equals(4));
        }, VoidToNull()));
        test.test('asBytes() UTF8', dart.fn(() => {
          let contentType = new src__media_type.MediaType.new('text', 'plain', new (IdentityMapOfString$String()).from(['charset', convert.utf8.name]));
          let body = new src__http__http_body.HttpBody.fromString(contentType, 'bodyçå®');
          let encoded = typed_data.Uint8List.fromList(convert.utf8.encode('bodyçå®'));
          src__frontend__expect.expect(body.asBytes(), src__core_matchers.equals(encoded));
        }, VoidToNull()));
        test.test('asBytes() LATIN1', dart.fn(() => {
          let contentType = new src__media_type.MediaType.new('text', 'plain', new (IdentityMapOfString$String()).from(['charset', convert.latin1.name]));
          let body = new src__http__http_body.HttpBody.fromString(contentType, 'bodyçå®');
          let encoded = typed_data.Uint8List.fromList(convert.latin1.encode('bodyçå®'));
          src__frontend__expect.expect(body.asBytes(), src__core_matchers.equals(encoded));
        }, VoidToNull()));
        test.test('asBytes() ASCII', dart.fn(() => {
          let contentType = new src__media_type.MediaType.new('text', 'plain', new (IdentityMapOfString$String()).from(['charset', convert.ascii.name]));
          let body = new src__http__http_body.HttpBody.fromString(contentType, 'body');
          let encoded = typed_data.Uint8List.fromList(convert.ascii.encode('body'));
          src__frontend__expect.expect(body.asBytes(), src__core_matchers.equals(encoded));
        }, VoidToNull()));
        test.test('asJson() UTF8', dart.fn(() => {
          let contentType = new src__media_type.MediaType.new('application', 'json', new (IdentityMapOfString$String()).from(['charset', convert.utf8.name]));
          let bodyJson = JSArrayOfMapOfString$String().of([new (IdentityMapOfString$String()).from(['foo', 'bar', 'baz', 'çå®"'])]);
          let body = new src__http__http_body.HttpBody.fromBytes(contentType, convert.utf8.encode(convert.json.encode(bodyJson)));
          src__frontend__expect.expect(body.asJson(), src__core_matchers.equals(bodyJson));
        }, VoidToNull()));
        test.test('asJson() LATIN1', dart.fn(() => {
          let contentType = new src__media_type.MediaType.new('application', 'json', new (IdentityMapOfString$String()).from(['charset', convert.latin1.name]));
          let bodyJson = JSArrayOfMapOfString$String().of([new (IdentityMapOfString$String()).from(['foo', 'bar', 'baz', 'çå®"'])]);
          let body = new src__http__http_body.HttpBody.fromBytes(contentType, convert.latin1.encode(convert.json.encode(bodyJson)));
          src__frontend__expect.expect(body.asJson(), src__core_matchers.equals(bodyJson));
        }, VoidToNull()));
        test.test('asJson() ASCII', dart.fn(() => {
          let contentType = new src__media_type.MediaType.new('application', 'json', new (IdentityMapOfString$String()).from(['charset', convert.ascii.name]));
          let bodyJson = JSArrayOfMapOfString$String().of([new (IdentityMapOfString$String()).from(['foo', 'bar', 'bar', 'baz'])]);
          let body = new src__http__http_body.HttpBody.fromBytes(contentType, convert.ascii.encode(convert.json.encode(bodyJson)));
          src__frontend__expect.expect(body.asJson(), src__core_matchers.equals(bodyJson));
        }, VoidToNull()));
        test.test('asString() UTF8', dart.fn(() => {
          let contentType = new src__media_type.MediaType.new('application', 'json', new (IdentityMapOfString$String()).from(['charset', convert.utf8.name]));
          let body = new src__http__http_body.HttpBody.fromBytes(contentType, convert.utf8.encode('bodyçå®'));
          src__frontend__expect.expect(body.asString(), src__core_matchers.equals('bodyçå®'));
        }, VoidToNull()));
        test.test('asString() LATIN1', dart.fn(() => {
          let contentType = new src__media_type.MediaType.new('application', 'json', new (IdentityMapOfString$String()).from(['charset', convert.latin1.name]));
          let body = new src__http__http_body.HttpBody.fromBytes(contentType, convert.latin1.encode('bodyçå®'));
          src__frontend__expect.expect(body.asString(), src__core_matchers.equals('bodyçå®'));
        }, VoidToNull()));
        test.test('asString() ASCII', dart.fn(() => {
          let contentType = new src__media_type.MediaType.new('application', 'json', new (IdentityMapOfString$String()).from(['charset', convert.ascii.name]));
          let body = new src__http__http_body.HttpBody.fromBytes(contentType, convert.ascii.encode('body'));
          src__frontend__expect.expect(body.asString(), src__core_matchers.equals('body'));
        }, VoidToNull()));
        test.test('should throw ResponseFormatException if body cannot be encoded', dart.fn(() => {
          let contentType = new src__media_type.MediaType.new('application', 'json', new (IdentityMapOfString$String()).from(['charset', convert.ascii.name]));
          let body = new src__http__http_body.HttpBody.fromString(contentType, 'bodyçå®');
          let exception = null;
          try {
            body.asBytes();
          } catch (e) {
            exception = e;
          }
          src__frontend__expect.expect(exception, src__core_matchers.isNotNull, {reason: 'should throw if body cannot be encoded'});
          src__frontend__expect.expect(exception, new (isInstanceOfOfResponseFormatException()).new(), {reason: 'should throw ResponseFormatException if body cannot be encoded'});
          src__frontend__expect.expect(dart.toString(exception), src__core_matchers.contains('Body could not be encoded'));
          src__frontend__expect.expect(dart.toString(exception), src__core_matchers.contains(dart.str`Content-Type: ${contentType}`));
          src__frontend__expect.expect(dart.toString(exception), src__core_matchers.contains(dart.str`Encoding: ${convert.ascii.name}`));
          src__frontend__expect.expect(dart.toString(exception), src__core_matchers.contains('bodyçå®'));
        }, VoidToNull()));
        test.test('should throw ResponseFormatException if bytes cannot be decoded', dart.fn(() => {
          let contentType = new src__media_type.MediaType.new('application', 'json', new (IdentityMapOfString$String()).from(['charset', convert.ascii.name]));
          let body = new src__http__http_body.HttpBody.fromBytes(contentType, convert.utf8.encode('bodyçå®'));
          let exception = null;
          try {
            body.asString();
          } catch (e) {
            exception = e;
          }
          src__frontend__expect.expect(exception, src__core_matchers.isNotNull, {reason: 'should throw if bytes cannot be decoded'});
          src__frontend__expect.expect(exception, new (isInstanceOfOfResponseFormatException()).new(), {reason: 'should throw ResponseFormatException if bytes cannot be decoded'});
          src__frontend__expect.expect(dart.toString(exception), src__core_matchers.contains('Bytes could not be decoded'));
          src__frontend__expect.expect(dart.toString(exception), src__core_matchers.contains(dart.str`Content-Type: ${contentType}`));
          src__frontend__expect.expect(dart.toString(exception), src__core_matchers.contains(dart.str`Encoding: ${convert.ascii.name}`));
          src__frontend__expect.expect(dart.toString(exception), src__core_matchers.contains(dart.toString(convert.utf8.encode('bodyçå®'))));
        }, VoidToNull()));
      }, VoidToNull()));
      test.group('StreamedHttpBody', dart.fn(() => {
        test.test('should parse encoding from content-type', dart.fn(() => {
          let contentType = new src__media_type.MediaType.new('text', 'plain', new (IdentityMapOfString$String()).from(['charset', convert.ascii.name]));
          let body = new src__http__http_body.StreamedHttpBody.fromByteStream(contentType, StreamOfListOfint().fromIterable(JSArrayOfListOfint().of([])));
          src__frontend__expect.expect(body.encoding.name, src__core_matchers.equals(convert.ascii.name));
        }, VoidToNull()));
        test.test('should allow a fallback encoding', dart.fn(() => {
          let contentType = new src__media_type.MediaType.new('text', 'plain');
          let body = new src__http__http_body.StreamedHttpBody.fromByteStream(contentType, StreamOfListOfint().fromIterable(JSArrayOfListOfint().of([])), {fallbackEncoding: convert.latin1});
          src__frontend__expect.expect(body.encoding.name, src__core_matchers.equals(convert.latin1.name));
        }, VoidToNull()));
        test.test('toBytes()', dart.fn(() => async.async(core.Null, function*() {
          let contentType = new src__media_type.MediaType.new('text', 'plain', new (IdentityMapOfString$String()).from(['charset', convert.utf8.name]));
          let body = new src__http__http_body.StreamedHttpBody.fromByteStream(contentType, StreamOfListOfint().fromIterable(JSArrayOfListOfint().of([JSArrayOfint().of([1, 2]), JSArrayOfint().of([3, 4])])), {fallbackEncoding: convert.latin1});
          src__frontend__expect.expect(yield body.toBytes(), src__core_matchers.equals(typed_data.Uint8List.fromList(JSArrayOfint().of([1, 2, 3, 4]))));
        }), VoidToFutureOfNull()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  dart.trackLibraries("test/test__unit__http__http_body_test", {
    "unit/http/http_body_test.dart": unit__http__http_body_test
  }, null);
  // Exports:
  return {
    unit__http__http_body_test: unit__http__http_body_test
  };
});
