define(['dart_sdk', 'test/test__shared_2', 'packages/w_transport/lib__w_transport', 'packages/test/lib__test', 'packages/http_parser/lib__http_parser', 'packages/matcher/lib__shared_0'], function(dart_sdk, test__shared_2, lib__w_transport, lib__test, lib__http_parser, lib__shared_0) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const _js_helper = dart_sdk._js_helper;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const src__mocks__mock_transports = lib__w_transport.src__mocks__mock_transports;
  const src__http__requests = lib__w_transport.src__http__requests;
  const src__http__http_body = lib__w_transport.src__http__http_body;
  const src__http__finalized_request = lib__w_transport.src__http__finalized_request;
  const src__http__mock__response = lib__w_transport.src__http__mock__response;
  const src__http__http_interceptor = lib__w_transport.src__http__http_interceptor;
  const test = lib__test.test;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const src__frontend__throws_matchers = lib__test.src__frontend__throws_matchers;
  const src__media_type = lib__http_parser.src__media_type;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const _root = Object.create(null);
  const unit__http__http_interceptor_test = Object.create(_root);
  const $times = dartx['*'];
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let IdentityMapOfString$String = () => (IdentityMapOfString$String = dart.constFn(_js_helper.IdentityMap$(core.String, core.String)))();
  let PathwayOfString = () => (PathwayOfString = dart.constFn(src__http__http_interceptor.Pathway$(core.String)))();
  let FutureOfString = () => (FutureOfString = dart.constFn(async.Future$(core.String)))();
  let StringToFutureOfString = () => (StringToFutureOfString = dart.constFn(dart.fnType(FutureOfString(), [core.String])))();
  let StringToString = () => (StringToString = dart.constFn(dart.fnType(core.String, [core.String])))();
  let StringToint = () => (StringToint = dart.constFn(dart.fnType(core.int, [core.String])))();
  unit__http__http_interceptor_test.main = function() {
    let naming = new naming$.Naming.new();
    naming.testType = "unit";
    naming.topic = "HTTP";
    test.group(naming.toString(), dart.fn(() => {
      test.group('HttpInterceptor', dart.fn(() => {
        test.setUp(dart.fn(() => {
          src__mocks__mock_transports.MockTransports.install();
        }, VoidToNull()));
        test.tearDown(dart.fn(() => async.async(core.Null, function*() {
          src__mocks__mock_transports.MockTransports.verifyNoOutstandingExceptions();
          yield src__mocks__mock_transports.MockTransports.uninstall();
        }), VoidToFutureOfNull()));
        test.test('default implementations should not modify the payloads', dart.fn(() => async.async(core.Null, function*() {
          let req = src__http__requests.Request.new();
          req.uri = core.Uri.parse('/test');
          let body = new src__http__http_body.HttpBody.fromString(new src__media_type.MediaType.new('text', 'plain'), 'body');
          let finalizedReq = new src__http__finalized_request.FinalizedRequest.new('GET', req.uri, new (IdentityMapOfString$String()).new(), body, false);
          let resp = src__http__mock__response.MockResponse.ok();
          let reqPayload = new src__http__http_interceptor.RequestPayload.new(src__http__requests.Request.new());
          let respPayload = new src__http__http_interceptor.ResponsePayload.new(finalizedReq, resp);
          let interceptor = new src__http__http_interceptor.HttpInterceptor.new();
          src__frontend__expect.expect(reqPayload === (yield interceptor.interceptRequest(reqPayload)), src__core_matchers.isTrue);
          src__frontend__expect.expect(respPayload === (yield interceptor.interceptResponse(respPayload)), src__core_matchers.isTrue);
        }), VoidToFutureOfNull()));
      }, VoidToNull()));
      test.group('Pathway', dart.fn(() => {
        test.test('waits for Futures to resolve', dart.fn(() => async.async(core.Null, function*() {
          let pathway = new (PathwayOfString()).new();
          pathway.addInterceptor(dart.fn(input => async.async(core.String, function*() {
            return input[$times](2);
          }), StringToFutureOfString()));
          pathway.addInterceptor(dart.fn(input => async.async(core.String, function*() {
            return dart.notNull(input) + 'b';
          }), StringToFutureOfString()));
          let result = (yield pathway.process('a'));
          src__frontend__expect.expect(result, src__core_matchers.equals('aab'));
        }), VoidToFutureOfNull()));
        test.test('handles values returned immediately (no Future)', dart.fn(() => async.async(core.Null, function*() {
          let pathway = new (PathwayOfString()).new();
          pathway.addInterceptor(dart.fn(input => input[$times](2), StringToString()));
          pathway.addInterceptor(dart.fn(input => dart.notNull(input) + 'b', StringToString()));
          let result = (yield pathway.process('a'));
          src__frontend__expect.expect(result, src__core_matchers.equals('aab'));
        }), VoidToFutureOfNull()));
        test.test('handles a mix of immediate values and Futures', dart.fn(() => async.async(core.Null, function*() {
          let pathway = new (PathwayOfString()).new();
          pathway.addInterceptor(dart.fn(input => async.async(core.String, function*() {
            return input[$times](2);
          }), StringToFutureOfString()));
          pathway.addInterceptor(dart.fn(input => dart.notNull(input) + 'b', StringToString()));
          let result = (yield pathway.process('a'));
          src__frontend__expect.expect(result, src__core_matchers.equals('aab'));
        }), VoidToFutureOfNull()));
        test.test('throws if an invalid value is returned', dart.fn(() => async.async(core.Null, function*() {
          let pathway = new (PathwayOfString()).new();
          pathway.addInterceptor(dart.fn(input => async.async(core.String, function*() {
            return input[$times](2);
          }), StringToFutureOfString()));
          pathway.addInterceptor(dart.fn(input => dart.notNull(input) + 'b', StringToString()));
          pathway.addInterceptor(dart.fn(input => 10, StringToint()));
          src__frontend__expect.expect(pathway.process('a'), src__frontend__throws_matchers.throwsException);
        }), VoidToFutureOfNull()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  dart.trackLibraries("test/test__unit__http__http_interceptor_test", {
    "unit/http/http_interceptor_test.dart": unit__http__http_interceptor_test
  }, null);
  // Exports:
  return {
    unit__http__http_interceptor_test: unit__http__http_interceptor_test
  };
});
