define(['dart_sdk', 'test/test__shared_2', 'packages/w_transport/lib__w_transport', 'packages/test/lib__test', 'packages/matcher/lib__shared_0', 'packages/dart2_constant/lib__convert'], function(dart_sdk, test__shared_2, lib__w_transport, lib__test, lib__shared_0, lib__convert) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const _js_helper = dart_sdk._js_helper;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const src__mocks__mock_transports = lib__w_transport.src__mocks__mock_transports;
  const src__http__requests = lib__w_transport.src__http__requests;
  const test = lib__test.test;
  const src__frontend__throws_matchers = lib__test.src__frontend__throws_matchers;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const src__map_matchers = lib__shared_0.src__map_matchers;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const convert = lib__convert.convert;
  const _root = Object.create(null);
  const unit__http__multipart_request_test = Object.create(_root);
  const $_set = dartx._set;
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let IdentityMapOfString$String = () => (IdentityMapOfString$String = dart.constFn(_js_helper.IdentityMap$(core.String, core.String)))();
  let IdentityMapOfString$dynamic = () => (IdentityMapOfString$dynamic = dart.constFn(_js_helper.IdentityMap$(core.String, dart.dynamic)))();
  unit__http__multipart_request_test.main = function() {
    let naming = new naming$.Naming.new();
    naming.testType = "unit";
    naming.topic = "HTTP";
    test.group(naming.toString(), dart.fn(() => {
      test.group('MultipartRequest', dart.fn(() => {
        test.setUp(dart.fn(() => {
          src__mocks__mock_transports.MockTransports.install();
        }, VoidToNull()));
        test.tearDown(dart.fn(() => async.async(core.Null, function*() {
          src__mocks__mock_transports.MockTransports.verifyNoOutstandingExceptions();
          yield src__mocks__mock_transports.MockTransports.uninstall();
        }), VoidToFutureOfNull()));
        test.test('content-type cannot be set manually', dart.fn(() => {
          let request = src__http__requests.MultipartRequest.new();
          src__frontend__expect.expect(dart.fn(() => request.contentType = null, VoidToNull()), src__frontend__throws_matchers.throwsUnsupportedError);
        }, VoidToNull()));
        test.test('content-length cannot be set manually', dart.fn(() => {
          let request = src__http__requests.MultipartRequest.new();
          src__frontend__expect.expect(dart.fn(() => {
            request.contentLength = 10;
          }, VoidToNull()), src__frontend__throws_matchers.throwsUnsupportedError);
        }, VoidToNull()));
        test.test('setting body in request dispatcher is unsupported', dart.fn(() => async.async(core.Null, function*() {
          let uri = core.Uri.parse('/test');
          let request = src__http__requests.MultipartRequest.new();
          src__frontend__expect.expect(request.post({uri: uri, body: 'body'}), src__frontend__throws_matchers.throwsUnsupportedError);
        }), VoidToFutureOfNull()));
        test.test('body cannot be empty', dart.fn(() => {
          let request = src__http__requests.MultipartRequest.new();
          src__frontend__expect.expect(request.post({uri: core.Uri.parse('/test')}), src__frontend__throws_matchers.throwsUnsupportedError);
        }, VoidToNull()));
        test.test('body can be set incrementally or all at once', dart.fn(() => {
          let request = src__http__requests.MultipartRequest.new();
          request.fields = new (IdentityMapOfString$String()).from(['field1', 'v1']);
          src__frontend__expect.expect(request.fields, src__map_matchers.containsPair('field1', 'v1'));
          request.files = new (IdentityMapOfString$dynamic()).from(['file1', 'f1']);
          src__frontend__expect.expect(request.files, src__map_matchers.containsPair('file1', 'f1'));
          request.fields[$_set]('field2', 'v2');
          src__frontend__expect.expect(request.fields, src__map_matchers.containsPair('field2', 'v2'));
          request.files[$_set]('file2', 'f2');
          src__frontend__expect.expect(request.files, src__map_matchers.containsPair('file2', 'f2'));
        }, VoidToNull()));
        test.test('body should be unmodifiable once sent', dart.fn(() => async.async(core.Null, function*() {
          let uri = core.Uri.parse('/test');
          src__mocks__mock_transports.MockTransports.http.expect('POST', uri);
          let request = src__http__requests.MultipartRequest.new();
          request.fields[$_set]('field1', 'value1');
          yield request.post({uri: uri});
          src__frontend__expect.expect(dart.fn(() => {
            request.fields[$_set]('too', 'late');
          }, VoidToNull()), src__frontend__throws_matchers.throwsUnsupportedError);
          src__frontend__expect.expect(dart.fn(() => {
            request.files[$_set]('too', 'late');
          }, VoidToNull()), src__frontend__throws_matchers.throwsUnsupportedError);
          src__frontend__expect.expect(dart.fn(() => {
            request.fields = new (IdentityMapOfString$String()).from(['too', 'late']);
          }, VoidToNull()), src__frontend__throws_matchers.throwsStateError);
          src__frontend__expect.expect(dart.fn(() => {
            request.files = new (IdentityMapOfString$dynamic()).from(['too', 'late']);
          }, VoidToNull()), src__frontend__throws_matchers.throwsStateError);
        }), VoidToFutureOfNull()));
        test.test('setting encoding should be unsupported', dart.fn(() => {
          let request = src__http__requests.MultipartRequest.new();
          src__frontend__expect.expect(dart.fn(() => {
            request.encoding = convert.utf8;
          }, VoidToNull()), src__frontend__throws_matchers.throwsUnsupportedError);
        }, VoidToNull()));
        test.test('clone()', dart.fn(() => {
          let fields = new (IdentityMapOfString$String()).from(['f1', 'v1', 'f2', 'v2']);
          let orig = src__http__requests.MultipartRequest.new();
          orig.fields = fields;
          let clone = orig.clone();
          src__frontend__expect.expect(clone.fields, src__core_matchers.equals(fields));
        }, VoidToNull()));
        test.test('autoRetry with files not supported', dart.fn(() => {
          let request = src__http__requests.MultipartRequest.new();
          request.files[$_set]('k', 'f');
          src__frontend__expect.expect(request.autoRetry.supported, src__core_matchers.isFalse);
        }, VoidToNull()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  dart.trackLibraries("test/test__unit__http__multipart_request_test", {
    "unit/http/multipart_request_test.dart": unit__http__multipart_request_test
  }, null);
  // Exports:
  return {
    unit__http__multipart_request_test: unit__http__multipart_request_test
  };
});
