define(['dart_sdk', 'test/test__shared_2', 'packages/w_transport/lib__w_transport', 'packages/matcher/lib__shared_0', 'packages/test/lib__test'], function(dart_sdk, test__shared_2, lib__w_transport, lib__shared_0, lib__test) {
  'use strict';
  const core = dart_sdk.core;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const src__http__request_exception = lib__w_transport.src__http__request_exception;
  const src__http__mock__response = lib__w_transport.src__http__mock__response;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const test = lib__test.test;
  const _root = Object.create(null);
  const unit__http__request_exception_test = Object.create(_root);
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  unit__http__request_exception_test.main = function() {
    let naming = new naming$.Naming.new();
    naming.testType = "unit";
    naming.topic = "HTTP";
    test.group(naming.toString(), dart.fn(() => {
      test.group('RequestException', dart.fn(() => {
        test.test('should include the method and URI if given', dart.fn(() => {
          let exception = new src__http__request_exception.RequestException.new('POST', core.Uri.parse('/path'), null, null);
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains('POST'));
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains('/path'));
        }, VoidToNull()));
        test.test('should include the response status and text if given', dart.fn(() => {
          let response = src__http__mock__response.MockResponse.ok();
          let exception = new src__http__request_exception.RequestException.new('GET', null, null, response);
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains('200 OK'));
        }, VoidToNull()));
        test.test('should include the original error if given', dart.fn(() => {
          let exception = new src__http__request_exception.RequestException.new('GET', null, null, null, core.Exception.new('original'));
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains('original'));
        }, VoidToNull()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  dart.trackLibraries("test/test__unit__http__request_exception_test", {
    "unit/http/request_exception_test.dart": unit__http__request_exception_test
  }, null);
  // Exports:
  return {
    unit__http__request_exception_test: unit__http__request_exception_test
  };
});
