define(['dart_sdk', 'test/test__shared_2', 'packages/dart2_constant/lib__convert', 'packages/http_parser/lib__http_parser', 'packages/w_transport/lib__shared_0', 'packages/matcher/lib__shared_0', 'packages/test/lib__test'], function(dart_sdk, test__shared_2, lib__convert, lib__http_parser, lib__shared_0, lib__shared_0$, lib__test) {
  'use strict';
  const core = dart_sdk.core;
  const _js_helper = dart_sdk._js_helper;
  const typed_data = dart_sdk.typed_data;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const convert = lib__convert.convert;
  const src__media_type = lib__http_parser.src__media_type;
  const src__http__response_format_exception = lib__shared_0.src__http__response_format_exception;
  const src__core_matchers = lib__shared_0$.src__core_matchers;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const test = lib__test.test;
  const _root = Object.create(null);
  const unit__http__response_format_exception_test = Object.create(_root);
  const $toString = dartx.toString;
  let IdentityMapOfString$String = () => (IdentityMapOfString$String = dart.constFn(_js_helper.IdentityMap$(core.String, core.String)))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  unit__http__response_format_exception_test.main = function() {
    let naming = new naming$.Naming.new();
    naming.testType = "unit";
    naming.topic = "HTTP";
    test.group(naming.toString(), dart.fn(() => {
      test.group('ResponseFormatException', dart.fn(() => {
        test.test('should detail why bytes could not be decoded', dart.fn(() => {
          let bytes = convert.utf8.encode('bodyçå®');
          let contentType = new src__media_type.MediaType.new('application', 'json', new (IdentityMapOfString$String()).from(['charset', convert.ascii.name]));
          let exception = new src__http__response_format_exception.ResponseFormatException.new(contentType, convert.ascii, {bytes: typed_data.Uint8List._check(bytes)});
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains('Bytes could not be decoded'));
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains(dart.str`Content-Type: ${contentType}`));
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains(dart.str`Encoding: ${convert.ascii.name}`));
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains(dart.toString(convert.utf8.encode('bodyçå®'))));
        }, VoidToNull()));
        test.test('should detail why string could not be encoded', dart.fn(() => {
          let body = 'bodyçå®';
          let contentType = new src__media_type.MediaType.new('application', 'json', new (IdentityMapOfString$String()).from(['charset', convert.ascii.name]));
          let exception = new src__http__response_format_exception.ResponseFormatException.new(contentType, convert.ascii, {body: body});
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains('Body could not be encoded'));
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains(dart.str`Content-Type: ${contentType}`));
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains(dart.str`Encoding: ${convert.ascii.name}`));
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains('bodyçå®'));
        }, VoidToNull()));
        test.test('should warn if encoding is null', dart.fn(() => {
          let body = 'bodyçå®';
          let contentType = new src__media_type.MediaType.new('application', 'json', new (IdentityMapOfString$String()).from(['charset', convert.ascii.name]));
          let exception = new src__http__response_format_exception.ResponseFormatException.new(contentType, null, {body: body});
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains('Body could not be encoded'));
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains(dart.str`Content-Type: ${contentType}`));
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains('Encoding: null'));
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains('bodyçå®'));
        }, VoidToNull()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  dart.trackLibraries("test/test__unit__http__response_format_exception_test", {
    "unit/http/response_format_exception_test.dart": unit__http__response_format_exception_test
  }, null);
  // Exports:
  return {
    unit__http__response_format_exception_test: unit__http__response_format_exception_test
  };
});
