define(['dart_sdk', 'test/test__shared_2', 'packages/w_transport/lib__w_transport', 'packages/matcher/lib__shared_0', 'packages/test/lib__test'], function(dart_sdk, test__shared_2, lib__w_transport, lib__shared_0, lib__test) {
  'use strict';
  const core = dart_sdk.core;
  const _interceptors = dart_sdk._interceptors;
  const _js_helper = dart_sdk._js_helper;
  const async = dart_sdk.async;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const src__http__response = lib__w_transport.src__http__response;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const test = lib__test.test;
  const _root = Object.create(null);
  const unit__http__response_test = Object.create(_root);
  const $length = dartx.length;
  let JSArrayOfint = () => (JSArrayOfint = dart.constFn(_interceptors.JSArray$(core.int)))();
  let IdentityMapOfString$String = () => (IdentityMapOfString$String = dart.constFn(_js_helper.IdentityMap$(core.String, core.String)))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let ListOfint = () => (ListOfint = dart.constFn(core.List$(core.int)))();
  let JSArrayOfListOfint = () => (JSArrayOfListOfint = dart.constFn(_interceptors.JSArray$(ListOfint())))();
  let StreamOfListOfint = () => (StreamOfListOfint = dart.constFn(async.Stream$(ListOfint())))();
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  unit__http__response_test.main = function() {
    let naming = new naming$.Naming.new();
    naming.testType = "unit";
    naming.topic = "HTTP";
    test.group(naming.toString(), dart.fn(() => {
      test.group('Response', dart.fn(() => {
        test.test('content-length should be set automatically', dart.fn(() => {
          let bytes = JSArrayOfint().of([10, 390]);
          let response = new src__http__response.Response.fromBytes(200, 'OK', new (IdentityMapOfString$String()).new(), bytes);
          src__frontend__expect.expect(response.contentLength, src__core_matchers.equals(bytes[$length]));
        }, VoidToNull()));
        test.test('body', dart.fn(() => {
          let response = new src__http__response.Response.fromString(200, 'OK', new (IdentityMapOfString$String()).new(), 'body');
          src__frontend__expect.expect(response.body.asString(), src__core_matchers.equals('body'));
        }, VoidToNull()));
        test.test('replace', dart.fn(() => {
          let response = new src__http__response.Response.fromString(200, 'OK', new (IdentityMapOfString$String()).new(), 'body');
          let response2 = response.replace({status: 301});
          src__frontend__expect.expect(response2.status, src__core_matchers.equals(301));
          src__frontend__expect.expect(response2.statusText, src__core_matchers.equals('OK'));
          src__frontend__expect.expect(response2.headers, src__core_matchers.equals(new _js_helper.LinkedMap.new()));
          src__frontend__expect.expect(response2.body.asString(), src__core_matchers.equals('body'));
          let response3 = response.replace({statusText: 'Not OK'});
          src__frontend__expect.expect(response3.status, src__core_matchers.equals(200));
          src__frontend__expect.expect(response3.statusText, src__core_matchers.equals('Not OK'));
          src__frontend__expect.expect(response3.headers, src__core_matchers.equals(new _js_helper.LinkedMap.new()));
          src__frontend__expect.expect(response3.body.asString(), src__core_matchers.equals('body'));
          let response4 = response.replace({headers: new (IdentityMapOfString$String()).from(['origin', 'pluto'])});
          src__frontend__expect.expect(response4.status, src__core_matchers.equals(200));
          src__frontend__expect.expect(response4.statusText, src__core_matchers.equals('OK'));
          src__frontend__expect.expect(response4.headers, src__core_matchers.equals(new (IdentityMapOfString$String()).from(['origin', 'pluto'])));
          src__frontend__expect.expect(response4.body.asString(), src__core_matchers.equals('body'));
          let response5 = response.replace({bodyString: 'phrasing'});
          src__frontend__expect.expect(response5.status, src__core_matchers.equals(200));
          src__frontend__expect.expect(response5.statusText, src__core_matchers.equals('OK'));
          src__frontend__expect.expect(response5.headers, src__core_matchers.equals(new _js_helper.LinkedMap.new()));
          src__frontend__expect.expect(response5.body.asString(), src__core_matchers.equals('phrasing'));
          let response6 = response.replace({bodyBytes: JSArrayOfint().of([10, 134])});
          src__frontend__expect.expect(response6.status, src__core_matchers.equals(200));
          src__frontend__expect.expect(response6.statusText, src__core_matchers.equals('OK'));
          src__frontend__expect.expect(response6.headers, src__core_matchers.equals(new _js_helper.LinkedMap.new()));
          src__frontend__expect.expect(response6.body.asBytes(), src__core_matchers.equals(JSArrayOfint().of([10, 134])));
        }, VoidToNull()));
      }, VoidToNull()));
      test.group('StreamedResponse', dart.fn(() => {
        test.test('content-length should be taken from headers', dart.fn(() => {
          let bytes = JSArrayOfint().of([10, 390]);
          let headers = new (IdentityMapOfString$String()).from(['content-length', dart.str`${bytes[$length]}`]);
          let response = new src__http__response.StreamedResponse.fromByteStream(200, 'OK', headers, StreamOfListOfint().fromIterable(JSArrayOfListOfint().of([bytes])));
          src__frontend__expect.expect(response.contentLength, src__core_matchers.equals(bytes[$length]));
        }, VoidToNull()));
        test.test('body', dart.fn(() => async.async(core.Null, function*() {
          let bytes = JSArrayOfint().of([1, 2, 3, 4]);
          let response = new src__http__response.StreamedResponse.fromByteStream(200, 'OK', new (IdentityMapOfString$String()).new(), StreamOfListOfint().fromIterable(JSArrayOfListOfint().of([bytes])));
          src__frontend__expect.expect(yield response.body.byteStream.toList(), src__core_matchers.equals(JSArrayOfListOfint().of([bytes])));
        }), VoidToFutureOfNull()));
        test.test('replace', dart.fn(() => async.async(core.Null, function*() {
          let bytes = JSArrayOfint().of([1, 2, 3, 4]);
          let response = new src__http__response.StreamedResponse.fromByteStream(200, 'OK', new (IdentityMapOfString$String()).new(), StreamOfListOfint().fromIterable(JSArrayOfListOfint().of([bytes])));
          let response2 = response.replace({status: 301});
          src__frontend__expect.expect(response2.status, src__core_matchers.equals(301));
          src__frontend__expect.expect(response2.statusText, src__core_matchers.equals('OK'));
          src__frontend__expect.expect(response2.headers, src__core_matchers.equals(new _js_helper.LinkedMap.new()));
          src__frontend__expect.expect(response2.body, src__core_matchers.equals(response.body));
          let response3 = response.replace({statusText: 'Not OK'});
          src__frontend__expect.expect(response3.status, src__core_matchers.equals(200));
          src__frontend__expect.expect(response3.statusText, src__core_matchers.equals('Not OK'));
          src__frontend__expect.expect(response3.headers, src__core_matchers.equals(new _js_helper.LinkedMap.new()));
          src__frontend__expect.expect(response3.body, src__core_matchers.equals(response.body));
          let response4 = response.replace({headers: new (IdentityMapOfString$String()).from(['origin', 'pluto'])});
          src__frontend__expect.expect(response4.status, src__core_matchers.equals(200));
          src__frontend__expect.expect(response4.statusText, src__core_matchers.equals('OK'));
          src__frontend__expect.expect(response4.headers, src__core_matchers.equals(new (IdentityMapOfString$String()).from(['origin', 'pluto'])));
          src__frontend__expect.expect(response4.body, src__core_matchers.equals(response.body));
          let bytes2 = JSArrayOfint().of([5, 6, 7]);
          let response5 = response.replace({byteStream: StreamOfListOfint().fromIterable(JSArrayOfListOfint().of([bytes2]))});
          src__frontend__expect.expect(response5.status, src__core_matchers.equals(200));
          src__frontend__expect.expect(response5.statusText, src__core_matchers.equals('OK'));
          src__frontend__expect.expect(response5.headers, src__core_matchers.equals(new _js_helper.LinkedMap.new()));
          src__frontend__expect.expect(yield response5.body.byteStream.toList(), src__core_matchers.equals(JSArrayOfListOfint().of([bytes2])));
        }), VoidToFutureOfNull()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  dart.trackLibraries("test/test__unit__http__response_test", {
    "unit/http/response_test.dart": unit__http__response_test
  }, null);
  // Exports:
  return {
    unit__http__response_test: unit__http__response_test
  };
});
