define(['dart_sdk', 'test/test__shared_2', 'packages/w_transport/lib__w_transport', 'packages/test/lib__test', 'packages/http_parser/lib__http_parser', 'packages/matcher/lib__shared_0', 'packages/dart2_constant/lib__convert'], function(dart_sdk, test__shared_2, lib__w_transport, lib__test, lib__http_parser, lib__shared_0, lib__convert) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const _interceptors = dart_sdk._interceptors;
  const _js_helper = dart_sdk._js_helper;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const src__mocks__mock_transports = lib__w_transport.src__mocks__mock_transports;
  const src__http__requests = lib__w_transport.src__http__requests;
  const src__http__http_body = lib__w_transport.src__http__http_body;
  const src__http__mock__response = lib__w_transport.src__http__mock__response;
  const src__http__finalized_request = lib__w_transport.src__http__finalized_request;
  const test = lib__test.test;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const src__frontend__throws_matchers = lib__test.src__frontend__throws_matchers;
  const src__media_type = lib__http_parser.src__media_type;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const convert = lib__convert.convert;
  const _root = Object.create(null);
  const unit__http__streamed_request_test = Object.create(_root);
  const $_get = dartx._get;
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let JSArrayOfint = () => (JSArrayOfint = dart.constFn(_interceptors.JSArray$(core.int)))();
  let ListOfint = () => (ListOfint = dart.constFn(core.List$(core.int)))();
  let JSArrayOfListOfint = () => (JSArrayOfListOfint = dart.constFn(_interceptors.JSArray$(ListOfint())))();
  let StreamOfListOfint = () => (StreamOfListOfint = dart.constFn(async.Stream$(ListOfint())))();
  let CompleterOfString = () => (CompleterOfString = dart.constFn(async.Completer$(core.String)))();
  let FutureOfMockResponse = () => (FutureOfMockResponse = dart.constFn(async.Future$(src__http__mock__response.MockResponse)))();
  let FinalizedRequestToFutureOfMockResponse = () => (FinalizedRequestToFutureOfMockResponse = dart.constFn(dart.fnType(FutureOfMockResponse(), [src__http__finalized_request.FinalizedRequest])))();
  let IdentityMapOfString$String = () => (IdentityMapOfString$String = dart.constFn(_js_helper.IdentityMap$(core.String, core.String)))();
  unit__http__streamed_request_test.main = function() {
    let naming = new naming$.Naming.new();
    naming.testType = "unit";
    naming.topic = "HTTP";
    test.group(naming.toString(), dart.fn(() => {
      test.group('StreamedRequest', dart.fn(() => {
        test.setUp(dart.fn(() => {
          src__mocks__mock_transports.MockTransports.install();
        }, VoidToNull()));
        test.tearDown(dart.fn(() => async.async(core.Null, function*() {
          src__mocks__mock_transports.MockTransports.verifyNoOutstandingExceptions();
          yield src__mocks__mock_transports.MockTransports.uninstall();
        }), VoidToFutureOfNull()));
        test.test('content-type can be set manually', dart.fn(() => {
          let request = src__http__requests.StreamedRequest.new();
          request.contentType = new src__media_type.MediaType.new('application', 'json');
          src__frontend__expect.expect(request.contentType.mimeType, src__core_matchers.equals('application/json'));
        }, VoidToNull()));
        test.test('setting body', dart.fn(() => async.async(core.Null, function*() {
          let request = src__http__requests.StreamedRequest.new();
          let chunks = JSArrayOfListOfint().of([JSArrayOfint().of([1, 2]), JSArrayOfint().of([3, 4])]);
          request.body = StreamOfListOfint().fromIterable(chunks);
          src__frontend__expect.expect(yield request.body.toList(), src__core_matchers.equals(chunks));
        }), VoidToFutureOfNull()));
        test.test('setting body in request dispatcher is supported', dart.fn(() => async.async(core.Null, function*() {
          let uri = core.Uri.parse('/test');
          let c = CompleterOfString().new();
          src__mocks__mock_transports.MockTransports.http.when(uri, dart.fn(request => async.async(src__http__mock__response.MockResponse, function*() {
            let body = src__http__http_body.StreamedHttpBody._check(request.body);
            c.complete(convert.utf8.decode(yield body.toBytes()));
            return src__http__mock__response.MockResponse.ok();
          }), FinalizedRequestToFutureOfMockResponse()));
          let request = src__http__requests.StreamedRequest.new();
          yield request.post({uri: uri, body: StreamOfListOfint().fromIterable(JSArrayOfListOfint().of([convert.utf8.encode('body')]))});
          src__frontend__expect.expect(yield c.future, src__core_matchers.equals('body'));
        }), VoidToFutureOfNull()));
        test.test('setting body in request dispatcher should throw on invalid data', dart.fn(() => async.async(core.Null, function*() {
          let uri = core.Uri.parse('/test');
          let request = src__http__requests.StreamedRequest.new();
          src__frontend__expect.expect(request.post({uri: uri, body: 'body'}), src__frontend__throws_matchers.throwsArgumentError);
        }), VoidToFutureOfNull()));
        test.test('body should be unmodifiable once sent', dart.fn(() => async.async(core.Null, function*() {
          let uri = core.Uri.parse('/test');
          src__mocks__mock_transports.MockTransports.http.expect('POST', uri);
          let request = src__http__requests.StreamedRequest.new();
          yield request.post({uri: uri});
          src__frontend__expect.expect(dart.fn(() => {
            request.body = StreamOfListOfint().fromIterable(JSArrayOfListOfint().of([JSArrayOfint().of([1, 2])]));
          }, VoidToNull()), src__frontend__throws_matchers.throwsStateError);
        }), VoidToFutureOfNull()));
        test.test('content-length must be set manually', dart.fn(() => {
          let request = src__http__requests.StreamedRequest.new();
          request.contentLength = 10;
          src__frontend__expect.expect(request.contentLength, src__core_matchers.equals(10));
        }, VoidToNull()));
        test.test('content-length should be unmodifiable once sent', dart.fn(() => async.async(core.Null, function*() {
          let uri = core.Uri.parse('/test');
          src__mocks__mock_transports.MockTransports.http.expect('GET', uri);
          let request = src__http__requests.StreamedRequest.new();
          yield request.get({uri: uri});
          src__frontend__expect.expect(dart.fn(() => {
            request.contentLength = 10;
          }, VoidToNull()), src__frontend__throws_matchers.throwsStateError);
        }), VoidToFutureOfNull()));
        test.test('setting encoding to null should throw', dart.fn(() => {
          let request = src__http__requests.StreamedRequest.new();
          src__frontend__expect.expect(dart.fn(() => {
            request.encoding = null;
          }, VoidToNull()), src__frontend__throws_matchers.throwsArgumentError);
        }, VoidToNull()));
        test.test('setting encoding should update content-type', dart.fn(() => {
          let request = src__http__requests.StreamedRequest.new();
          src__frontend__expect.expect(request.contentType.parameters[$_get]('charset'), src__core_matchers.equals(convert.utf8.name));
          request.encoding = convert.latin1;
          src__frontend__expect.expect(request.contentType.parameters[$_get]('charset'), src__core_matchers.equals(convert.latin1.name));
          request.encoding = convert.ascii;
          src__frontend__expect.expect(request.contentType.parameters[$_get]('charset'), src__core_matchers.equals(convert.ascii.name));
        }, VoidToNull()));
        test.test('setting encoding should not update content-type if content-type has been set manually', dart.fn(() => {
          let request = src__http__requests.StreamedRequest.new();
          src__frontend__expect.expect(request.contentType.parameters[$_get]('charset'), src__core_matchers.equals(convert.utf8.name));
          request.contentType = new src__media_type.MediaType.new('application', 'x-custom', new (IdentityMapOfString$String()).from(['charset', convert.latin1.name]));
          src__frontend__expect.expect(request.contentType.mimeType, src__core_matchers.equals('application/x-custom'));
          src__frontend__expect.expect(request.contentType.parameters[$_get]('charset'), src__core_matchers.equals(convert.latin1.name));
          request.encoding = convert.ascii;
          src__frontend__expect.expect(request.contentType.parameters[$_get]('charset'), src__core_matchers.equals(convert.latin1.name));
        }, VoidToNull()));
        test.test('setting content-type should not be allowed once sent', dart.fn(() => async.async(core.Null, function*() {
          let uri = core.Uri.parse('/test');
          src__mocks__mock_transports.MockTransports.http.expect('GET', uri);
          let request = src__http__requests.StreamedRequest.new();
          yield request.get({uri: uri});
          src__frontend__expect.expect(dart.fn(() => {
            request.contentType = new src__media_type.MediaType.new('application', 'x-custom');
          }, VoidToNull()), src__frontend__throws_matchers.throwsStateError);
        }), VoidToFutureOfNull()));
        test.test('setting encoding should not be allowed once sent', dart.fn(() => async.async(core.Null, function*() {
          let uri = core.Uri.parse('/test');
          src__mocks__mock_transports.MockTransports.http.expect('GET', uri);
          let request = src__http__requests.StreamedRequest.new();
          yield request.get({uri: uri});
          src__frontend__expect.expect(dart.fn(() => {
            request.encoding = convert.latin1;
          }, VoidToNull()), src__frontend__throws_matchers.throwsStateError);
        }), VoidToFutureOfNull()));
        test.test('custom content-type without inferrable encoding', dart.fn(() => async.async(core.Null, function*() {
          let uri = core.Uri.parse('/test');
          src__mocks__mock_transports.MockTransports.http.expect('POST', uri);
          let request = src__http__requests.StreamedRequest.new();
          request.contentType = new src__media_type.MediaType.new('application', 'x-custom');
          request.body = StreamOfListOfint().fromIterable(JSArrayOfListOfint().of([JSArrayOfint().of([1, 2])]));
          yield request.post({uri: uri});
        }), VoidToFutureOfNull()));
        test.test('clone()', dart.fn(() => {
          let request = src__http__requests.StreamedRequest.new();
          src__frontend__expect.expect(dart.bind(request, 'clone'), src__frontend__throws_matchers.throwsUnsupportedError);
        }, VoidToNull()));
        test.test('autoRetry not supported', dart.fn(() => {
          src__frontend__expect.expect(src__http__requests.StreamedRequest.new().autoRetry.supported, src__core_matchers.isFalse);
        }, VoidToNull()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  dart.trackLibraries("test/test__unit__http__streamed_request_test", {
    "unit/http/streamed_request_test.dart": unit__http__streamed_request_test
  }, null);
  // Exports:
  return {
    unit__http__streamed_request_test: unit__http__streamed_request_test
  };
});
