define(['dart_sdk', 'test/test__shared_2', 'packages/w_transport/lib__w_transport', 'packages/test/lib__test', 'packages/matcher/lib__shared_0', 'packages/dart2_constant/lib__convert', 'packages/http_parser/lib__http_parser'], function(dart_sdk, test__shared_2, lib__w_transport, lib__test, lib__shared_0, lib__convert, lib__http_parser) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const math = dart_sdk.math;
  const _js_helper = dart_sdk._js_helper;
  const _interceptors = dart_sdk._interceptors;
  const typed_data = dart_sdk.typed_data;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const src__mocks__mock_transports = lib__w_transport.src__mocks__mock_transports;
  const src__http__requests = lib__w_transport.src__http__requests;
  const src__http__auto_retry = lib__w_transport.src__http__auto_retry;
  const src__http__utils = lib__w_transport.src__http__utils;
  const test = lib__test.test;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const src__frontend__throws_matchers = lib__test.src__frontend__throws_matchers;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const src__order_matchers = lib__shared_0.src__order_matchers;
  const src__map_matchers = lib__shared_0.src__map_matchers;
  const convert = lib__convert.convert;
  const src__media_type = lib__http_parser.src__media_type;
  const _root = Object.create(null);
  const unit__http__utils_test = Object.create(_root);
  const $truncate = dartx.truncate;
  const $join = dartx.join;
  const $add = dartx.add;
  const $length = dartx.length;
  const $_get = dartx._get;
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let IdentityMapOfString$String = () => (IdentityMapOfString$String = dart.constFn(_js_helper.IdentityMap$(core.String, core.String)))();
  let JSArrayOfString = () => (JSArrayOfString = dart.constFn(_interceptors.JSArray$(core.String)))();
  let JSArrayOfint = () => (JSArrayOfint = dart.constFn(_interceptors.JSArray$(core.int)))();
  let ListOfint = () => (ListOfint = dart.constFn(core.List$(core.int)))();
  let JSArrayOfListOfint = () => (JSArrayOfListOfint = dart.constFn(_interceptors.JSArray$(ListOfint())))();
  let StreamOfListOfint = () => (StreamOfListOfint = dart.constFn(async.Stream$(ListOfint())))();
  let CompleterOfNull = () => (CompleterOfNull = dart.constFn(async.Completer$(core.Null)))();
  let ListOfintToNull = () => (ListOfintToNull = dart.constFn(dart.fnType(core.Null, [ListOfint()])))();
  unit__http__utils_test.main = function() {
    let naming = new naming$.Naming.new();
    naming.testType = "unit";
    naming.topic = "HTTP";
    test.group(naming.toString(), dart.fn(() => {
      test.group('HTTP utils', dart.fn(() => {
        test.group('calculateBackoff()', dart.fn(() => {
          test.setUp(dart.fn(() => {
            src__mocks__mock_transports.MockTransports.install();
          }, VoidToNull()));
          test.tearDown(dart.fn(() => async.async(core.Null, function*() {
            src__mocks__mock_transports.MockTransports.verifyNoOutstandingExceptions();
            yield src__mocks__mock_transports.MockTransports.uninstall();
          }), VoidToFutureOfNull()));
          test.group('exponential', dart.fn(() => {
            test.test('maxInterval should not be exceeded (no jitter)', dart.fn(() => async.async(core.Null, function*() {
              let request = src__http__requests.Request.new();
              let interval = new core.Duration.new({milliseconds: 5});
              let maxInterval = new core.Duration.new({milliseconds: 400});
              request.autoRetry.backOff = new src__http__auto_retry.RetryBackOff.exponential(interval, {withJitter: false, maxInterval: maxInterval});
              for (let i = 0; i < 5; i++) {
                request.autoRetry.numAttempts = i;
                if (i === 0) {
                  src__frontend__expect.expect(src__http__utils.calculateBackOff(request.autoRetry).inMilliseconds, src__core_matchers.equals(interval.inMilliseconds));
                } else {
                  src__frontend__expect.expect(src__http__utils.calculateBackOff(request.autoRetry).inMilliseconds, src__core_matchers.equals(dart.notNull(interval.inMilliseconds) * math.pow(2, request.autoRetry.numAttempts)));
                }
              }
            }), VoidToFutureOfNull()));
            test.test('maxInterval should not be exceeded (with jitter)', dart.fn(() => async.async(core.Null, function*() {
              let request = src__http__requests.Request.new();
              let interval = new core.Duration.new({milliseconds: 5});
              let maxInterval = new core.Duration.new({milliseconds: 400});
              request.autoRetry.backOff = new src__http__auto_retry.RetryBackOff.exponential(interval, {withJitter: true, maxInterval: maxInterval});
              for (let i = 0; i < 5; i++) {
                request.autoRetry.numAttempts = i;
                if (i === 0) {
                  src__frontend__expect.expect(src__http__utils.calculateBackOff(request.autoRetry).inMilliseconds, src__order_matchers.lessThanOrEqualTo(interval.inMilliseconds));
                } else {
                  src__frontend__expect.expect(src__http__utils.calculateBackOff(request.autoRetry).inMilliseconds, src__order_matchers.lessThanOrEqualTo(dart.notNull(interval.inMilliseconds) * math.pow(2, request.autoRetry.numAttempts)));
                }
              }
            }), VoidToFutureOfNull()));
            test.test('maxInterval should be exceeded (no jitter)', dart.fn(() => async.async(core.Null, function*() {
              let request = src__http__requests.Request.new();
              let interval = new core.Duration.new({milliseconds: 5});
              let maxInterval = new core.Duration.new({milliseconds: 20});
              let withJitter = false;
              request.autoRetry.backOff = new src__http__auto_retry.RetryBackOff.exponential(interval, {withJitter: withJitter, maxInterval: maxInterval});
              for (let i = 0; i < 5; i++) {
                request.autoRetry.numAttempts = i;
                if (i === 0) {
                  src__frontend__expect.expect(src__http__utils.calculateBackOff(request.autoRetry).inMilliseconds, src__core_matchers.equals(interval.inMilliseconds));
                } else if (i === 1) {
                  src__frontend__expect.expect(src__http__utils.calculateBackOff(request.autoRetry).inMilliseconds, src__core_matchers.equals(10));
                } else {
                  src__frontend__expect.expect(src__http__utils.calculateBackOff(request.autoRetry).inMilliseconds, src__core_matchers.equals(request.autoRetry.backOff.maxInterval.inMilliseconds));
                }
              }
            }), VoidToFutureOfNull()));
            test.test('maxInterval should be exceeded (with jitter)', dart.fn(() => async.async(core.Null, function*() {
              let request = src__http__requests.Request.new();
              let interval = new core.Duration.new({milliseconds: 5});
              let maxInterval = new core.Duration.new({milliseconds: 20});
              let withJitter = true;
              request.autoRetry.backOff = new src__http__auto_retry.RetryBackOff.exponential(interval, {withJitter: withJitter, maxInterval: maxInterval});
              for (let i = 0; i < 50; i++) {
                request.autoRetry.numAttempts = i;
                if (i === 0) {
                  src__frontend__expect.expect(src__http__utils.calculateBackOff(request.autoRetry).inMilliseconds, src__order_matchers.lessThanOrEqualTo(interval.inMilliseconds));
                } else if (i === 1) {
                  src__frontend__expect.expect(src__http__utils.calculateBackOff(request.autoRetry).inMilliseconds, src__order_matchers.lessThanOrEqualTo(request.autoRetry.backOff.maxInterval.inMilliseconds));
                } else {
                  src__frontend__expect.expect(src__http__utils.calculateBackOff(request.autoRetry).inMilliseconds, src__order_matchers.lessThanOrEqualTo(request.autoRetry.backOff.maxInterval.inMilliseconds));
                }
              }
            }), VoidToFutureOfNull()));
          }, VoidToNull()));
          test.group('fixed', dart.fn(() => {
            test.test('no jitter', dart.fn(() => async.async(core.Null, function*() {
              let request = src__http__requests.Request.new();
              let interval = new core.Duration.new({milliseconds: 5});
              let withJitter = false;
              request.autoRetry.backOff = new src__http__auto_retry.RetryBackOff.fixed(interval, {withJitter: withJitter});
              for (let i = 0; i < 5; i++) {
                request.autoRetry.numAttempts = i;
                if (i === 0) {
                  src__frontend__expect.expect(src__http__utils.calculateBackOff(request.autoRetry).inMilliseconds, src__core_matchers.equals(interval.inMilliseconds));
                }
              }
            }), VoidToFutureOfNull()));
            test.test('with jitter', dart.fn(() => async.async(core.Null, function*() {
              let request = src__http__requests.Request.new();
              let interval = new core.Duration.new({milliseconds: 5});
              let withJitter = true;
              request.autoRetry.backOff = new src__http__auto_retry.RetryBackOff.fixed(interval, {withJitter: withJitter});
              for (let i = 0; i < 5; i++) {
                let backOff = src__http__utils.calculateBackOff(request.autoRetry).inMilliseconds;
                src__frontend__expect.expect(backOff, src__order_matchers.lessThanOrEqualTo(dart.notNull(interval.inMilliseconds) * 1.5));
                src__frontend__expect.expect(backOff, src__order_matchers.greaterThanOrEqualTo((dart.notNull(interval.inMilliseconds) / 2)[$truncate]()));
              }
            }), VoidToFutureOfNull()));
          }, VoidToNull()));
        }, VoidToNull()));
        test.test('isAsciiOnly()', dart.fn(() => {
          src__frontend__expect.expect(src__http__utils.isAsciiOnly('abc'), src__core_matchers.isTrue);
          src__frontend__expect.expect(src__http__utils.isAsciiOnly('abç'), src__core_matchers.isFalse);
        }, VoidToNull()));
        test.test('mapToQuery() with default encoding (UTF8)', dart.fn(() => {
          let map = new (IdentityMapOfString$String()).from(['foo', 'bar', 'count', '10', 'sentence', 'words with spaces', 'chars', 'ç%/\\{].+"\'']);
          let expected = JSArrayOfString().of(['foo=bar', 'count=10', 'sentence=words+with+spaces', 'chars=%C3%A7%25%2F%5C%7B%5D.%2B%22%27'])[$join]('&');
          src__frontend__expect.expect(src__http__utils.mapToQuery(map), src__core_matchers.equals(expected));
        }, VoidToNull()));
        test.test('mapToQuery() with non-default encoding (LATIN1)', dart.fn(() => {
          let map = new (IdentityMapOfString$String()).from(['foo', 'bar', 'count', '10', 'sentence', 'words with spaces', 'chars', 'ç%/\\{].+"\'']);
          let expected = JSArrayOfString().of(['foo=bar', 'count=10', 'sentence=words+with+spaces', 'chars=%E7%25%2F%5C%7B%5D.%2B%22%27'])[$join]('&');
          src__frontend__expect.expect(src__http__utils.mapToQuery(map, {encoding: convert.latin1}), src__core_matchers.equals(expected));
        }, VoidToNull()));
        test.test('queryToMap() with default encoding (UTF8)', dart.fn(() => {
          let query = JSArrayOfString().of(['foo=bar', 'count=10', 'sentence=words+with+spaces', 'chars=%C3%A7%25%2F%5C%7B%5D.%2B%22%27'])[$join]('&');
          let expected = new (IdentityMapOfString$String()).from(['foo', 'bar', 'count', '10', 'sentence', 'words with spaces', 'chars', 'ç%/\\{].+"\'']);
          src__frontend__expect.expect(src__http__utils.queryToMap(query), src__core_matchers.equals(expected));
        }, VoidToNull()));
        test.test('queryToMap() with default encoding (UTF8)', dart.fn(() => {
          let query = JSArrayOfString().of(['foo=bar', 'count=10', 'sentence=words+with+spaces', 'chars=%E7%25%2F%5C%7B%5D.%2B%22%27'])[$join]('&');
          let expected = new (IdentityMapOfString$String()).from(['foo', 'bar', 'count', '10', 'sentence', 'words with spaces', 'chars', 'ç%/\\{].+"\'']);
          src__frontend__expect.expect(src__http__utils.queryToMap(query, {encoding: convert.latin1}), src__core_matchers.equals(expected));
        }, VoidToNull()));
        test.test('parseContentTypeFromHeaders()', dart.fn(() => {
          let headers = new (IdentityMapOfString$String()).from(['content-type', 'text/plain']);
          let ct = src__http__utils.parseContentTypeFromHeaders(headers);
          src__frontend__expect.expect(ct.mimeType, src__core_matchers.equals('text/plain'));
          src__frontend__expect.expect(ct.parameters, src__core_matchers.isEmpty);
        }, VoidToNull()));
        test.test('parseContentTypeFromHeaders() no content-type header', dart.fn(() => {
          let headers = new (IdentityMapOfString$String()).new();
          let ct = src__http__utils.parseContentTypeFromHeaders(headers);
          src__frontend__expect.expect(ct.mimeType, src__core_matchers.equals('application/octet-stream'), {reason: 'application/octet-stream content-type should be assumed if header is missing.'});
          src__frontend__expect.expect(ct.parameters, src__core_matchers.isEmpty);
        }, VoidToNull()));
        test.test('parseContentTypeFromHeaders() case mismatch', dart.fn(() => {
          let headers = new (IdentityMapOfString$String()).from(['cOntEnt-tYPe', 'text/plain']);
          let ct = src__http__utils.parseContentTypeFromHeaders(headers);
          src__frontend__expect.expect(ct.mimeType, src__core_matchers.equals('text/plain'));
          src__frontend__expect.expect(ct.parameters, src__core_matchers.isEmpty);
        }, VoidToNull()));
        test.test('parseContentTypeFromHeaders() with parameters', dart.fn(() => {
          let headers = new (IdentityMapOfString$String()).from(['content-type', 'text/plain; charset=utf-8']);
          let ct = src__http__utils.parseContentTypeFromHeaders(headers);
          src__frontend__expect.expect(ct.mimeType, src__core_matchers.equals('text/plain'));
          src__frontend__expect.expect(ct.parameters, src__map_matchers.containsPair('charset', 'utf-8'));
        }, VoidToNull()));
        test.test('parseEncodingFromContentType()', dart.fn(() => {
          let ct = null;
          ct = new src__media_type.MediaType.new('text', 'plain', new (IdentityMapOfString$String()).from(['charset', convert.utf8.name]));
          src__frontend__expect.expect(src__http__utils.parseEncodingFromContentType(ct), src__core_matchers.equals(convert.utf8));
          ct = new src__media_type.MediaType.new('text', 'plain', new (IdentityMapOfString$String()).from(['charset', convert.latin1.name]));
          src__frontend__expect.expect(src__http__utils.parseEncodingFromContentType(ct), src__core_matchers.equals(convert.latin1));
        }, VoidToNull()));
        test.test('parseEncodingFromContentType() no charset', dart.fn(() => {
          let ct = new src__media_type.MediaType.new('text', 'plain');
          src__frontend__expect.expect(src__http__utils.parseEncodingFromContentType(ct, {fallback: convert.ascii}), src__core_matchers.equals(convert.ascii));
        }, VoidToNull()));
        test.test('parseEncodingFromContentType() null content-type', dart.fn(() => {
          src__frontend__expect.expect(src__http__utils.parseEncodingFromContentType(null, {fallback: convert.ascii}), src__core_matchers.equals(convert.ascii));
        }, VoidToNull()));
        test.test('parseEncodingFromContentType() unrecognized charset', dart.fn(() => {
          let ct = new src__media_type.MediaType.new('text', 'plain', new (IdentityMapOfString$String()).from(['charset', 'unknown']));
          src__frontend__expect.expect(src__http__utils.parseEncodingFromContentType(ct, {fallback: convert.ascii}), src__core_matchers.equals(convert.ascii));
        }, VoidToNull()));
        test.test('parseEncodingFromContentTypeOrFail()', dart.fn(() => {
          let ct = null;
          ct = new src__media_type.MediaType.new('text', 'plain', new (IdentityMapOfString$String()).from(['charset', convert.utf8.name]));
          src__frontend__expect.expect(src__http__utils.parseEncodingFromContentTypeOrFail(ct), src__core_matchers.equals(convert.utf8));
          ct = new src__media_type.MediaType.new('text', 'plain', new (IdentityMapOfString$String()).from(['charset', convert.latin1.name]));
          src__frontend__expect.expect(src__http__utils.parseEncodingFromContentTypeOrFail(ct), src__core_matchers.equals(convert.latin1));
        }, VoidToNull()));
        test.test('parseEncodingFromContentTypeOrFail() no charset', dart.fn(() => {
          let ct = new src__media_type.MediaType.new('text', 'plain');
          src__frontend__expect.expect(dart.fn(() => {
            src__http__utils.parseEncodingFromContentTypeOrFail(ct);
          }, VoidToNull()), src__frontend__throws_matchers.throwsFormatException);
        }, VoidToNull()));
        test.test('parseEncodingFromContentTypeOrFail() null content-type', dart.fn(() => {
          src__frontend__expect.expect(dart.fn(() => {
            src__http__utils.parseEncodingFromContentTypeOrFail(null);
          }, VoidToNull()), src__frontend__throws_matchers.throwsFormatException);
        }, VoidToNull()));
        test.test('parseEncodingFromContentTypeOrFail() unrecognized charset', dart.fn(() => {
          let ct = new src__media_type.MediaType.new('text', 'plain', new (IdentityMapOfString$String()).from(['charset', 'unknown']));
          src__frontend__expect.expect(dart.fn(() => {
            src__http__utils.parseEncodingFromContentTypeOrFail(ct);
          }, VoidToNull()), src__frontend__throws_matchers.throwsFormatException);
        }, VoidToNull()));
        test.test('parseEncodingFromHeaders()', dart.fn(() => {
          let headers = null;
          headers = new (IdentityMapOfString$String()).from(['content-type', 'text/plain; charset=utf-8']);
          src__frontend__expect.expect(src__http__utils.parseEncodingFromHeaders(headers), src__core_matchers.equals(convert.utf8));
          headers = new (IdentityMapOfString$String()).from(['content-type', 'text/plain; charset=iso-8859-1']);
          src__frontend__expect.expect(src__http__utils.parseEncodingFromHeaders(headers), src__core_matchers.equals(convert.latin1));
        }, VoidToNull()));
        test.test('parseEncodingFromHeaders() case mismatch', dart.fn(() => {
          let headers = new (IdentityMapOfString$String()).from(['cOnteNt-tYPe', 'text/plain; charset=utf-8']);
          src__frontend__expect.expect(src__http__utils.parseEncodingFromHeaders(headers), src__core_matchers.equals(convert.utf8));
        }, VoidToNull()));
        test.test('parseEncodingFromHeaders() no charset', dart.fn(() => {
          let headers = new (IdentityMapOfString$String()).from(['content-type', 'text/plain']);
          src__frontend__expect.expect(src__http__utils.parseEncodingFromHeaders(headers, {fallback: convert.ascii}), src__core_matchers.equals(convert.ascii));
        }, VoidToNull()));
        test.test('parseEncodingFromHeaders() no content-type', dart.fn(() => {
          let headers = new (IdentityMapOfString$String()).new();
          src__frontend__expect.expect(src__http__utils.parseEncodingFromHeaders(headers, {fallback: convert.ascii}), src__core_matchers.equals(convert.ascii));
        }, VoidToNull()));
        test.test('parseEncodingFromHeaders() unrecognized charset', dart.fn(() => {
          let headers = new (IdentityMapOfString$String()).from(['content-type', 'text/plain; charset=unknown']);
          src__frontend__expect.expect(src__http__utils.parseEncodingFromHeaders(headers, {fallback: convert.ascii}), src__core_matchers.equals(convert.ascii));
        }, VoidToNull()));
        test.test('reduceByteStream()', dart.fn(() => async.async(core.Null, function*() {
          let byteStream = StreamOfListOfint().fromIterable(JSArrayOfListOfint().of([JSArrayOfint().of([1, 2, 3]), JSArrayOfint().of([4, 5]), JSArrayOfint().of([6, 7, 8])]));
          let expected = typed_data.Uint8List.fromList(JSArrayOfint().of([1, 2, 3, 4, 5, 6, 7, 8]));
          src__frontend__expect.expect(yield src__http__utils.reduceByteStream(byteStream), src__core_matchers.equals(expected));
        }), VoidToFutureOfNull()));
        test.test('reduceByteStream() empty', dart.fn(() => async.async(core.Null, function*() {
          let byteStream = StreamOfListOfint().fromIterable(JSArrayOfListOfint().of([]));
          src__frontend__expect.expect(yield src__http__utils.reduceByteStream(byteStream), src__core_matchers.isEmpty);
        }), VoidToFutureOfNull()));
        test.test('reduceByteStream() single element', dart.fn(() => async.async(core.Null, function*() {
          let byteStream = StreamOfListOfint().fromIterable(JSArrayOfListOfint().of([JSArrayOfint().of([1, 2])]));
          let expected = typed_data.Uint8List.fromList(JSArrayOfint().of([1, 2]));
          src__frontend__expect.expect(yield src__http__utils.reduceByteStream(byteStream), src__core_matchers.equals(expected));
        }), VoidToFutureOfNull()));
        test.test('ByteStreamProgressListener', dart.fn(() => async.async(core.Null, function*() {
          let byteStream = StreamOfListOfint().fromIterable(JSArrayOfListOfint().of([JSArrayOfint().of([1, 2, 3]), JSArrayOfint().of([4, 5, 6]), JSArrayOfint().of([7, 8, 9, 10])]));
          let listener = new src__http__utils.ByteStreamProgressListener.new(byteStream, {total: 10});
          let chunks = JSArrayOfListOfint().of([]);
          let iter = async.StreamIterator.new(listener.byteStream);
          try {
            while (yield iter.moveNext()) {
              let chunk = iter.current;
              {
                chunks[$add](chunk);
              }
            }
          } finally {
            yield iter.cancel();
          }
          src__frontend__expect.expect(chunks, src__core_matchers.equals(JSArrayOfListOfint().of([JSArrayOfint().of([1, 2, 3]), JSArrayOfint().of([4, 5, 6]), JSArrayOfint().of([7, 8, 9, 10])])));
          let progressEvents = (yield listener.progressStream.toList());
          src__frontend__expect.expect(progressEvents[$length], src__core_matchers.equals(3));
          src__frontend__expect.expect(progressEvents[$_get](0).percent, src__core_matchers.equals(30.0));
          src__frontend__expect.expect(progressEvents[$_get](1).percent, src__core_matchers.equals(60.0));
          src__frontend__expect.expect(progressEvents[$_get](2).percent, src__core_matchers.equals(100.0));
        }), VoidToFutureOfNull()));
        test.test('ByteStreamProgressListener pause/resume', dart.fn(() => async.async(core.Null, function*() {
          let byteStream = StreamOfListOfint().fromIterable(JSArrayOfListOfint().of([JSArrayOfint().of([1, 2, 3]), JSArrayOfint().of([4, 5, 6])]));
          let listener = new src__http__utils.ByteStreamProgressListener.new(byteStream);
          let done = CompleterOfNull().new();
          let sub = listener.byteStream.listen(dart.fn(_ => {
          }, ListOfintToNull()), {onDone: dart.bind(done, 'complete')});
          sub.pause();
          sub.resume();
          yield done.future;
          yield sub.cancel();
        }), VoidToFutureOfNull()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  dart.trackLibraries("test/test__unit__http__utils_test", {
    "unit/http/utils_test.dart": unit__http__utils_test
  }, null);
  // Exports:
  return {
    unit__http__utils_test: unit__http__utils_test
  };
});
