define(['dart_sdk', 'test/test__shared_2', 'packages/w_transport/lib__w_transport', 'packages/test/lib__test', 'packages/w_transport/lib__shared_2', 'packages/matcher/lib__shared_0', 'test/test__shared_20'], function(dart_sdk, test__shared_2, lib__w_transport, lib__test, lib__shared_2, lib__shared_0, test__shared_20) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const _interceptors = dart_sdk._interceptors;
  const _js_helper = dart_sdk._js_helper;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const src__mocks__mock_transports = lib__w_transport.src__mocks__mock_transports;
  const src__http__mock__http_client = lib__w_transport.src__http__mock__http_client;
  const src__http__requests = lib__w_transport.src__http__requests;
  const src__http__request_exception = lib__w_transport.src__http__request_exception;
  const src__http__mock__response = lib__w_transport.src__http__mock__response;
  const src__http__http = lib__w_transport.src__http__http;
  const src__http__finalized_request = lib__w_transport.src__http__finalized_request;
  const src__http__mock__requests = lib__w_transport.src__http__mock__requests;
  const test = lib__test.test;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const src__frontend__throws_matcher = lib__test.src__frontend__throws_matcher;
  const src__frontend__throws_matchers = lib__test.src__frontend__throws_matchers;
  const src__http__mock__client = lib__shared_2.src__http__mock__client;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const utils = test__shared_20.utils;
  const _root = Object.create(null);
  const unit__mocks__mock_http_test = Object.create(_root);
  const $contains = dartx.contains;
  const $toString = dartx.toString;
  const $add = dartx.add;
  const $_get = dartx._get;
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let isInstanceOfOfMockHttpClient = () => (isInstanceOfOfMockHttpClient = dart.constFn(src__core_matchers.isInstanceOf$(src__http__mock__http_client.MockHttpClient)))();
  let isInstanceOfOfRequestException = () => (isInstanceOfOfRequestException = dart.constFn(src__core_matchers.isInstanceOf$(src__http__request_exception.RequestException)))();
  let dynamicTobool = () => (dynamicTobool = dart.constFn(dart.fnType(core.bool, [dart.dynamic])))();
  let FutureOfMockResponse = () => (FutureOfMockResponse = dart.constFn(async.Future$(src__http__mock__response.MockResponse)))();
  let FinalizedRequestToFutureOfMockResponse = () => (FinalizedRequestToFutureOfMockResponse = dart.constFn(dart.fnType(FutureOfMockResponse(), [src__http__finalized_request.FinalizedRequest])))();
  let FinalizedRequestAndMatchToFutureOfMockResponse = () => (FinalizedRequestAndMatchToFutureOfMockResponse = dart.constFn(dart.fnType(FutureOfMockResponse(), [src__http__finalized_request.FinalizedRequest, core.Match])))();
  let FutureOfbottom = () => (FutureOfbottom = dart.constFn(async.Future$(dart.bottom)))();
  let FinalizedRequestToFutureOfbottom = () => (FinalizedRequestToFutureOfbottom = dart.constFn(dart.fnType(FutureOfbottom(), [src__http__finalized_request.FinalizedRequest])))();
  let FinalizedRequestAndMatchToFutureOfbottom = () => (FinalizedRequestAndMatchToFutureOfbottom = dart.constFn(dart.fnType(FutureOfbottom(), [src__http__finalized_request.FinalizedRequest, core.Match])))();
  let JSArrayOfMatch = () => (JSArrayOfMatch = dart.constFn(_interceptors.JSArray$(core.Match)))();
  let IdentityMapOfString$String = () => (IdentityMapOfString$String = dart.constFn(_js_helper.IdentityMap$(core.String, core.String)))();
  unit__mocks__mock_http_test.main = function() {
    let naming = new naming$.Naming.new();
    naming.testType = "unit";
    naming.topic = "Mocks";
    test.group(naming.toString(), dart.fn(() => {
      let requestUri = core.Uri.parse('/mock/test');
      test.setUp(dart.fn(() => {
        src__mocks__mock_transports.MockTransports.install();
      }, VoidToNull()));
      test.tearDown(dart.fn(() => async.async(core.Null, function*() {
        src__mocks__mock_transports.MockTransports.verifyNoOutstandingExceptions();
        yield src__mocks__mock_transports.MockTransports.uninstall();
      }), VoidToFutureOfNull()));
      test.test('MockClient extends MockHttpClient', dart.fn(() => {
        src__frontend__expect.expect(new src__http__mock__client.MockClient.new(null), new (isInstanceOfOfMockHttpClient()).new());
      }, VoidToNull()));
      test.group('TransportMocks.http', dart.fn(() => {
        test.test('causeFailureOnOpen() should cause request to throw', dart.fn(() => async.async(core.Null, function*() {
          let request = src__http__requests.Request.new();
          src__mocks__mock_transports.MockTransports.http.causeFailureOnOpen(request);
          src__frontend__expect.expect(request.get({uri: requestUri}), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfRequestException()).new()));
        }), VoidToFutureOfNull()));
        test.test('verifies that requests are mock requests before controlling them', dart.fn(() => {
          let request = null;
          src__frontend__expect.expect(dart.fn(() => {
            src__mocks__mock_transports.MockTransports.http.completeRequest(request);
          }, VoidToNull()), src__frontend__throws_matchers.throwsArgumentError);
        }, VoidToNull()));
        test.group('completeRequest()', dart.fn(() => {
          test.test('completes a request with 200 OK by default', dart.fn(() => async.async(core.Null, function*() {
            let request = src__http__requests.Request.new();
            src__mocks__mock_transports.MockTransports.http.completeRequest(request);
            src__frontend__expect.expect((yield request.get({uri: requestUri})).status, src__core_matchers.equals(200));
          }), VoidToFutureOfNull()));
          test.test('can complete a request with custom response', dart.fn(() => async.async(core.Null, function*() {
            let request = src__http__requests.Request.new();
            let response = new src__http__mock__response.MockResponse.new(202);
            src__mocks__mock_transports.MockTransports.http.completeRequest(request, {response: response});
            src__frontend__expect.expect((yield request.get({uri: requestUri})).status, src__core_matchers.equals(202));
          }), VoidToFutureOfNull()));
        }, VoidToNull()));
        test.group('expect()', dart.fn(() => {
          test.test('expected request completes automatically with 200 OK by default', dart.fn(() => async.async(core.Null, function*() {
            src__mocks__mock_transports.MockTransports.http.expect('GET', requestUri);
            src__frontend__expect.expect((yield src__http__http.Http.get(requestUri)).status, src__core_matchers.equals(200));
          }), VoidToFutureOfNull()));
          test.test('expected request with custom response', dart.fn(() => async.async(core.Null, function*() {
            let response = new src__http__mock__response.MockResponse.new(202);
            src__mocks__mock_transports.MockTransports.http.expect('POST', requestUri, {respondWith: response});
            src__frontend__expect.expect((yield src__http__http.Http.post(requestUri)).status, src__core_matchers.equals(202));
          }), VoidToFutureOfNull()));
          test.test('expected request failure', dart.fn(() => async.async(core.Null, function*() {
            let exception = core.Exception.new('Custom exception');
            src__mocks__mock_transports.MockTransports.http.expect('DELETE', requestUri, {failWith: exception});
            src__frontend__expect.expect(src__http__http.Http.delete(requestUri), src__frontend__throws_matcher.throwsA(src__core_matchers.predicate(dart.dynamic, dart.fn(error => dart.toString(error)[$contains]('Custom exception'), dynamicTobool()))));
          }), VoidToFutureOfNull()));
          test.test('expected request has to match URI and method', dart.fn(() => async.async(core.Null, function*() {
            src__mocks__mock_transports.MockTransports.http.expect('GET', requestUri);
            src__http__http.Http.delete(requestUri);
            src__http__http.Http.get(core.Uri.parse('/wrong'));
            yield src__http__http.Http.get(requestUri);
            src__frontend__expect.expect(src__mocks__mock_transports.MockTransports.http.numPendingRequests, src__core_matchers.equals(2));
            yield src__mocks__mock_transports.MockTransports.reset();
          }), VoidToFutureOfNull()));
          test.test('supports failWith, or respondWith, but not both', dart.fn(() => async.async(core.Null, function*() {
            src__frontend__expect.expect(dart.fn(() => {
              src__mocks__mock_transports.MockTransports.http.expect('GET', requestUri, {failWith: core.Exception.new(), respondWith: src__http__mock__response.MockResponse.ok()});
            }, VoidToNull()), src__frontend__throws_matchers.throwsArgumentError);
            yield src__mocks__mock_transports.MockTransports.reset();
          }), VoidToFutureOfNull()));
        }, VoidToNull()));
        test.group('expectPattern()', dart.fn(() => {
          test.test('expected request completes automatically with 200 OK by default', dart.fn(() => async.async(core.Null, function*() {
            src__mocks__mock_transports.MockTransports.http.expectPattern('GET', dart.toString(requestUri));
            src__frontend__expect.expect((yield src__http__http.Http.get(requestUri)).status, src__core_matchers.equals(200));
          }), VoidToFutureOfNull()));
          test.test('expected request with custom response', dart.fn(() => async.async(core.Null, function*() {
            let response = new src__http__mock__response.MockResponse.new(202);
            src__mocks__mock_transports.MockTransports.http.expectPattern('POST', dart.toString(requestUri), {respondWith: response});
            src__frontend__expect.expect((yield src__http__http.Http.post(requestUri)).status, src__core_matchers.equals(202));
          }), VoidToFutureOfNull()));
          test.test('expected request failure', dart.fn(() => async.async(core.Null, function*() {
            let exception = core.Exception.new('Custom exception');
            src__mocks__mock_transports.MockTransports.http.expectPattern('DELETE', dart.toString(requestUri), {failWith: exception});
            src__frontend__expect.expect(src__http__http.Http.delete(requestUri), src__frontend__throws_matcher.throwsA(src__core_matchers.predicate(dart.dynamic, dart.fn(error => dart.toString(error)[$contains]('Custom exception'), dynamicTobool()))));
          }), VoidToFutureOfNull()));
          test.test('expected request has to match URI and method', dart.fn(() => async.async(core.Null, function*() {
            src__mocks__mock_transports.MockTransports.http.expectPattern('GET', dart.toString(requestUri));
            src__http__http.Http.delete(requestUri);
            src__http__http.Http.get(core.Uri.parse('/wrong'));
            yield src__http__http.Http.get(requestUri);
            src__frontend__expect.expect(src__mocks__mock_transports.MockTransports.http.numPendingRequests, src__core_matchers.equals(2));
            yield src__mocks__mock_transports.MockTransports.reset();
          }), VoidToFutureOfNull()));
          test.test('supports failWith, or respondWith, but not both', dart.fn(() => async.async(core.Null, function*() {
            src__frontend__expect.expect(dart.fn(() => {
              src__mocks__mock_transports.MockTransports.http.expectPattern('GET', dart.toString(requestUri), {failWith: core.Exception.new(), respondWith: src__http__mock__response.MockResponse.ok()});
            }, VoidToNull()), src__frontend__throws_matchers.throwsArgumentError);
            yield src__mocks__mock_transports.MockTransports.reset();
          }), VoidToFutureOfNull()));
          test.test('handles requests that match a pattern', dart.fn(() => async.async(core.Null, function*() {
            let pattern = core.RegExp.new('https://(google|github).com');
            src__http__http.Http.get(core.Uri.parse('https://example.com'));
            src__mocks__mock_transports.MockTransports.http.expectPattern('GET', pattern);
            yield src__http__http.Http.get(core.Uri.parse('https://google.com'));
            src__mocks__mock_transports.MockTransports.http.expectPattern('GET', pattern);
            yield src__http__http.Http.get(core.Uri.parse('https://github.com'));
            src__frontend__expect.expect(src__mocks__mock_transports.MockTransports.http.numPendingRequests, src__core_matchers.equals(1));
            yield src__mocks__mock_transports.MockTransports.reset();
          }), VoidToFutureOfNull()));
        }, VoidToNull()));
        test.group('failRequest()', dart.fn(() => {
          test.test('causes request to throw', dart.fn(() => async.async(core.Null, function*() {
            let request = src__http__requests.Request.new();
            src__mocks__mock_transports.MockTransports.http.failRequest(request);
            src__frontend__expect.expect(request.get({uri: requestUri}), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfRequestException()).new()));
          }), VoidToFutureOfNull()));
          test.test('can include a custom exception', dart.fn(() => async.async(core.Null, function*() {
            let request = src__http__requests.Request.new();
            src__mocks__mock_transports.MockTransports.http.failRequest(request, {error: core.Exception.new('Custom exception')});
            src__frontend__expect.expect(request.get({uri: requestUri}), src__frontend__throws_matcher.throwsA(src__core_matchers.predicate(dart.dynamic, dart.fn(error => dart.toString(error)[$contains]('Custom exception'), dynamicTobool()))));
          }), VoidToFutureOfNull()));
          test.test('can include a custom response', dart.fn(() => async.async(core.Null, function*() {
            let request = src__http__requests.Request.new();
            let response = src__http__mock__response.MockResponse.internalServerError();
            src__mocks__mock_transports.MockTransports.http.failRequest(request, {response: response});
            src__frontend__expect.expect(request.get({uri: requestUri}), src__frontend__throws_matcher.throwsA(src__core_matchers.predicate(dart.dynamic, dart.fn(error => src__http__request_exception.RequestException.is(error) && error.response.status === 500, dynamicTobool()))));
          }), VoidToFutureOfNull()));
        }, VoidToNull()));
        test.test('reset() should clear all expectations, pending requests, and handlers', dart.fn(() => async.async(core.Null, function*() {
          src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(req => async.async(src__http__mock__response.MockResponse, function*() {
            return src__http__mock__response.MockResponse.ok();
          }), FinalizedRequestToFutureOfMockResponse()));
          src__mocks__mock_transports.MockTransports.http.whenPattern(dart.toString(requestUri), dart.fn((req, match) => async.async(src__http__mock__response.MockResponse, function*() {
            return src__http__mock__response.MockResponse.ok();
          }), FinalizedRequestAndMatchToFutureOfMockResponse()));
          src__mocks__mock_transports.MockTransports.http.expect('GET', core.Uri.parse('/expected'));
          src__mocks__mock_transports.MockTransports.http.expectPattern('GET', '/expected');
          let request = src__http__requests.Request.new();
          request.get({uri: core.Uri.parse('/other')});
          let mockRequest = src__http__mock__requests.MockPlainTextRequest._check(request);
          yield mockRequest.onSent;
          src__frontend__expect.expect(src__mocks__mock_transports.MockTransports.http.numPendingRequests, src__core_matchers.equals(1));
          yield src__mocks__mock_transports.MockTransports.reset();
          let request2 = src__http__requests.Request.new();
          request2.delete({uri: requestUri});
          let mockRequest2 = src__http__mock__requests.MockPlainTextRequest._check(request2);
          yield mockRequest2.onSent;
          let request3 = src__http__requests.Request.new();
          request3.get({uri: core.Uri.parse('/expected')});
          let mockRequest3 = src__http__mock__requests.MockPlainTextRequest._check(request3);
          yield mockRequest3.onSent;
          src__frontend__expect.expect(src__mocks__mock_transports.MockTransports.http.numPendingRequests, src__core_matchers.equals(2));
          yield src__mocks__mock_transports.MockTransports.reset();
        }), VoidToFutureOfNull()));
        test.group('verifyNoOutstandingExceptions()', dart.fn(() => {
          test.test('does not throw if no pending requests and no unfulfilled expectations', dart.fn(() => {
            src__mocks__mock_transports.MockTransports.http.verifyNoOutstandingExceptions();
          }, VoidToNull()));
          test.test('throws if requests are pending', dart.fn(() => async.async(core.Null, function*() {
            let request = src__http__requests.Request.new();
            request.get({uri: requestUri});
            let mockRequest = src__http__mock__requests.MockPlainTextRequest._check(request);
            yield mockRequest.onSent;
            src__frontend__expect.expect(dart.fn(() => {
              src__mocks__mock_transports.MockTransports.http.verifyNoOutstandingExceptions();
            }, VoidToNull()), src__frontend__throws_matchers.throwsStateError);
            yield src__mocks__mock_transports.MockTransports.reset();
          }), VoidToFutureOfNull()));
          test.test('throws if expectation is unfulfilled', dart.fn(() => async.async(core.Null, function*() {
            src__mocks__mock_transports.MockTransports.http.expect('GET', requestUri);
            src__frontend__expect.expect(dart.fn(() => {
              src__mocks__mock_transports.MockTransports.http.verifyNoOutstandingExceptions();
            }, VoidToNull()), src__frontend__throws_matchers.throwsStateError);
            yield src__mocks__mock_transports.MockTransports.reset();
          }), VoidToFutureOfNull()));
        }, VoidToNull()));
        test.group('when()', dart.fn(() => {
          test.test('registers a handler for all requests with matching URI and method', dart.fn(() => async.async(core.Null, function*() {
            let ok = src__http__mock__response.MockResponse.ok();
            src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(_ => async.async(src__http__mock__response.MockResponse, function*() {
              return ok;
            }), FinalizedRequestToFutureOfMockResponse()), {method: 'GET'});
            src__http__http.Http.get(core.Uri.parse('/wrong'));
            src__http__http.Http.delete(requestUri);
            yield src__http__http.Http.get(requestUri);
            yield src__http__http.Http.get(requestUri);
            src__frontend__expect.expect(src__mocks__mock_transports.MockTransports.http.numPendingRequests, src__core_matchers.equals(2));
            yield src__mocks__mock_transports.MockTransports.reset();
          }), VoidToFutureOfNull()));
          test.test('registers a handler for all requests with matching URI and ANY method', dart.fn(() => async.async(core.Null, function*() {
            let ok = src__http__mock__response.MockResponse.ok();
            src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(_ => async.async(src__http__mock__response.MockResponse, function*() {
              return ok;
            }), FinalizedRequestToFutureOfMockResponse()));
            src__http__http.Http.get(core.Uri.parse('/wrong'));
            yield src__http__http.Http.delete(requestUri);
            yield src__http__http.Http.get(requestUri);
            yield src__http__http.Http.get(requestUri);
            src__frontend__expect.expect(src__mocks__mock_transports.MockTransports.http.numPendingRequests, src__core_matchers.equals(1));
            yield src__mocks__mock_transports.MockTransports.reset();
          }), VoidToFutureOfNull()));
          test.test('supports all standard methods', dart.fn(() => async.async(core.Null, function*() {
            let ok = src__http__mock__response.MockResponse.ok();
            src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(_ => async.async(src__http__mock__response.MockResponse, function*() {
              return ok;
            }), FinalizedRequestToFutureOfMockResponse()), {method: 'DELETE'});
            src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(_ => async.async(src__http__mock__response.MockResponse, function*() {
              return ok;
            }), FinalizedRequestToFutureOfMockResponse()), {method: 'GET'});
            src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(_ => async.async(src__http__mock__response.MockResponse, function*() {
              return ok;
            }), FinalizedRequestToFutureOfMockResponse()), {method: 'HEAD'});
            src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(_ => async.async(src__http__mock__response.MockResponse, function*() {
              return ok;
            }), FinalizedRequestToFutureOfMockResponse()), {method: 'OPTIONS'});
            src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(_ => async.async(src__http__mock__response.MockResponse, function*() {
              return ok;
            }), FinalizedRequestToFutureOfMockResponse()), {method: 'PATCH'});
            src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(_ => async.async(src__http__mock__response.MockResponse, function*() {
              return ok;
            }), FinalizedRequestToFutureOfMockResponse()), {method: 'POST'});
            src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(_ => async.async(src__http__mock__response.MockResponse, function*() {
              return ok;
            }), FinalizedRequestToFutureOfMockResponse()), {method: 'PUT'});
            yield src__http__http.Http.delete(requestUri);
            yield src__http__http.Http.get(requestUri);
            yield src__http__http.Http.head(requestUri);
            yield src__http__http.Http.options(requestUri);
            yield src__http__http.Http.patch(requestUri);
            yield src__http__http.Http.post(requestUri);
            yield src__http__http.Http.put(requestUri);
          }), VoidToFutureOfNull()));
          test.test('supports custom method', dart.fn(() => async.async(core.Null, function*() {
            let ok = src__http__mock__response.MockResponse.ok();
            src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(_ => async.async(src__http__mock__response.MockResponse, function*() {
              return ok;
            }), FinalizedRequestToFutureOfMockResponse()), {method: 'COPY'});
            yield src__http__http.Http.send('COPY', requestUri);
          }), VoidToFutureOfNull()));
          test.test('registers handler that throws to cause request failure', dart.fn(() => async.async(core.Null, function*() {
            src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(_ => async.async(dart.bottom, function*() {
              return dart.throw(core.Exception.new());
            }), FinalizedRequestToFutureOfbottom()));
            src__frontend__expect.expect(src__http__http.Http.get(requestUri), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfRequestException()).new()));
          }), VoidToFutureOfNull()));
          test.test('registers a handler that can be canceled', dart.fn(() => async.async(core.Null, function*() {
            let ok = src__http__mock__response.MockResponse.ok();
            let handler = src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(_ => async.async(src__http__mock__response.MockResponse, function*() {
              return ok;
            }), FinalizedRequestToFutureOfMockResponse()));
            yield src__http__http.Http.get(requestUri);
            handler.cancel();
            src__http__http.Http.get(requestUri);
            yield utils.nextTick();
            src__frontend__expect.expect(src__mocks__mock_transports.MockTransports.http.numPendingRequests, src__core_matchers.equals(1));
            yield src__mocks__mock_transports.MockTransports.reset();
          }), VoidToFutureOfNull()));
          test.test('canceling a handler does nothing if handler no longer exists', dart.fn(() => async.async(core.Null, function*() {
            let oldHandler = src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(_ => async.async(src__http__mock__response.MockResponse, function*() {
              return src__http__mock__response.MockResponse.notFound();
            }), FinalizedRequestToFutureOfMockResponse()));
            src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(_ => async.async(src__http__mock__response.MockResponse, function*() {
              return src__http__mock__response.MockResponse.ok();
            }), FinalizedRequestToFutureOfMockResponse()));
            src__frontend__expect.expect(dart.fn(() => {
              oldHandler.cancel();
            }, VoidToNull()), src__core_matchers.returnsNormally);
            yield src__http__http.Http.get(requestUri);
            oldHandler = src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(_ => async.async(src__http__mock__response.MockResponse, function*() {
              return src__http__mock__response.MockResponse.notFound();
            }), FinalizedRequestToFutureOfMockResponse()), {method: 'DELETE'});
            src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(_ => async.async(src__http__mock__response.MockResponse, function*() {
              return src__http__mock__response.MockResponse.ok();
            }), FinalizedRequestToFutureOfMockResponse()), {method: 'DELETE'});
            src__frontend__expect.expect(dart.fn(() => {
              oldHandler.cancel();
            }, VoidToNull()), src__core_matchers.returnsNormally);
            yield src__http__http.Http.get(requestUri);
          }), VoidToFutureOfNull()));
          test.test('canceling a handler does nothing if handler was reset', dart.fn(() => async.async(core.Null, function*() {
            let oldHandler = src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(_ => async.async(src__http__mock__response.MockResponse, function*() {
              return src__http__mock__response.MockResponse.ok();
            }), FinalizedRequestToFutureOfMockResponse()));
            yield src__mocks__mock_transports.MockTransports.reset();
            src__frontend__expect.expect(dart.fn(() => {
              oldHandler.cancel();
            }, VoidToNull()), src__core_matchers.returnsNormally);
            src__http__http.Http.get(requestUri);
            yield utils.nextTick();
            src__frontend__expect.expect(src__mocks__mock_transports.MockTransports.http.numPendingRequests, src__core_matchers.equals(1));
            yield src__mocks__mock_transports.MockTransports.reset();
          }), VoidToFutureOfNull()));
        }, VoidToNull()));
        test.group('whenPattern()', dart.fn(() => {
          test.test('registers a handler for all requests with a matching URI and method', dart.fn(() => async.async(core.Null, function*() {
            let ok = src__http__mock__response.MockResponse.ok();
            src__mocks__mock_transports.MockTransports.http.whenPattern(dart.toString(requestUri), dart.fn((_a, _b) => async.async(src__http__mock__response.MockResponse, function*() {
              return ok;
            }), FinalizedRequestAndMatchToFutureOfMockResponse()), {method: 'GET'});
            src__http__http.Http.get(core.Uri.parse('/wrong'));
            src__http__http.Http.delete(requestUri);
            yield src__http__http.Http.get(requestUri);
            yield src__http__http.Http.get(requestUri);
            src__frontend__expect.expect(src__mocks__mock_transports.MockTransports.http.numPendingRequests, src__core_matchers.equals(2));
            yield src__mocks__mock_transports.MockTransports.reset();
          }), VoidToFutureOfNull()));
          test.test('registers a handler for all requests with a matching URI and ANY method', dart.fn(() => async.async(core.Null, function*() {
            let ok = src__http__mock__response.MockResponse.ok();
            src__mocks__mock_transports.MockTransports.http.whenPattern(dart.toString(requestUri), dart.fn((_a, _b) => async.async(src__http__mock__response.MockResponse, function*() {
              return ok;
            }), FinalizedRequestAndMatchToFutureOfMockResponse()));
            src__http__http.Http.get(core.Uri.parse('/wrong'));
            yield src__http__http.Http.delete(requestUri);
            yield src__http__http.Http.get(requestUri);
            yield src__http__http.Http.get(requestUri);
            src__frontend__expect.expect(src__mocks__mock_transports.MockTransports.http.numPendingRequests, src__core_matchers.equals(1));
            yield src__mocks__mock_transports.MockTransports.reset();
          }), VoidToFutureOfNull()));
          test.test('registers a handler that throws to cause request failure', dart.fn(() => async.async(core.Null, function*() {
            src__mocks__mock_transports.MockTransports.http.whenPattern(dart.toString(requestUri), dart.fn((_a, _b) => async.async(dart.bottom, function*() {
              return dart.throw(core.Exception.new());
            }), FinalizedRequestAndMatchToFutureOfbottom()));
            src__frontend__expect.expect(src__http__http.Http.get(requestUri), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfRequestException()).new()));
          }), VoidToFutureOfNull()));
          test.test('registers a handler for all requests with a partially matching URI', dart.fn(() => async.async(core.Null, function*() {
            let pattern = core.RegExp.new('https://(google|github).com.*');
            let ok = src__http__mock__response.MockResponse.ok();
            src__mocks__mock_transports.MockTransports.http.whenPattern(pattern, dart.fn((_a, _b) => async.async(src__http__mock__response.MockResponse, function*() {
              return ok;
            }), FinalizedRequestAndMatchToFutureOfMockResponse()));
            src__http__http.Http.get(core.Uri.parse('/wrong'));
            yield src__http__http.Http.get(core.Uri.parse('https://google.com'));
            yield src__http__http.Http.get(core.Uri.parse('https://github.com/Workiva/w_transport'));
            src__frontend__expect.expect(src__mocks__mock_transports.MockTransports.http.numPendingRequests, src__core_matchers.equals(1));
            yield src__mocks__mock_transports.MockTransports.reset();
          }), VoidToFutureOfNull()));
          test.test('handler should recieve the Match instance from the pattern test', dart.fn(() => async.async(core.Null, function*() {
            let pattern = core.RegExp.new('https://(google|github).com');
            let matches = JSArrayOfMatch().of([]);
            src__mocks__mock_transports.MockTransports.http.whenPattern(pattern, dart.fn((_, match) => async.async(src__http__mock__response.MockResponse, function*() {
              matches[$add](match);
              return src__http__mock__response.MockResponse.ok();
            }), FinalizedRequestAndMatchToFutureOfMockResponse()));
            yield src__http__http.Http.get(core.Uri.parse('https://google.com'));
            yield src__http__http.Http.get(core.Uri.parse('https://github.com'));
            src__frontend__expect.expect(matches[$_get](0).group(0), src__core_matchers.equals('https://google.com'));
            src__frontend__expect.expect(matches[$_get](0).group(1), src__core_matchers.equals('google'));
            src__frontend__expect.expect(matches[$_get](1).group(0), src__core_matchers.equals('https://github.com'));
            src__frontend__expect.expect(matches[$_get](1).group(1), src__core_matchers.equals('github'));
          }), VoidToFutureOfNull()));
          test.test('registers a handler that can be canceled', dart.fn(() => async.async(core.Null, function*() {
            let ok = src__http__mock__response.MockResponse.ok();
            let handler = src__mocks__mock_transports.MockTransports.http.whenPattern(dart.toString(requestUri), dart.fn((_a, _b) => async.async(src__http__mock__response.MockResponse, function*() {
              return ok;
            }), FinalizedRequestAndMatchToFutureOfMockResponse()));
            yield src__http__http.Http.get(requestUri);
            handler.cancel();
            src__http__http.Http.get(requestUri);
            yield utils.nextTick();
            src__frontend__expect.expect(src__mocks__mock_transports.MockTransports.http.numPendingRequests, src__core_matchers.equals(1));
            yield src__mocks__mock_transports.MockTransports.reset();
          }), VoidToFutureOfNull()));
          test.test('canceling a handler does nothing if handler no longer exists', dart.fn(() => async.async(core.Null, function*() {
            let oldHandler = src__mocks__mock_transports.MockTransports.http.whenPattern(dart.toString(requestUri), dart.fn((_a, _b) => async.async(src__http__mock__response.MockResponse, function*() {
              return src__http__mock__response.MockResponse.notFound();
            }), FinalizedRequestAndMatchToFutureOfMockResponse()));
            src__mocks__mock_transports.MockTransports.http.whenPattern(dart.toString(requestUri), dart.fn((_a, _b) => async.async(src__http__mock__response.MockResponse, function*() {
              return src__http__mock__response.MockResponse.ok();
            }), FinalizedRequestAndMatchToFutureOfMockResponse()));
            src__frontend__expect.expect(dart.fn(() => {
              oldHandler.cancel();
            }, VoidToNull()), src__core_matchers.returnsNormally);
            yield src__http__http.Http.get(requestUri);
            oldHandler = src__mocks__mock_transports.MockTransports.http.whenPattern(dart.toString(requestUri), dart.fn((_a, _b) => async.async(src__http__mock__response.MockResponse, function*() {
              return src__http__mock__response.MockResponse.notFound();
            }), FinalizedRequestAndMatchToFutureOfMockResponse()), {method: 'DELETE'});
            src__mocks__mock_transports.MockTransports.http.whenPattern(dart.toString(requestUri), dart.fn((_a, _b) => async.async(src__http__mock__response.MockResponse, function*() {
              return src__http__mock__response.MockResponse.ok();
            }), FinalizedRequestAndMatchToFutureOfMockResponse()), {method: 'DELETE'});
            src__frontend__expect.expect(dart.fn(() => {
              oldHandler.cancel();
            }, VoidToNull()), src__core_matchers.returnsNormally);
            yield src__http__http.Http.get(requestUri);
          }), VoidToFutureOfNull()));
          test.test('canceling a handler does nothing if handler was reset', dart.fn(() => async.async(core.Null, function*() {
            let oldHandler = src__mocks__mock_transports.MockTransports.http.whenPattern(dart.toString(requestUri), dart.fn((_a, _b) => async.async(src__http__mock__response.MockResponse, function*() {
              return src__http__mock__response.MockResponse.ok();
            }), FinalizedRequestAndMatchToFutureOfMockResponse()));
            yield src__mocks__mock_transports.MockTransports.reset();
            src__frontend__expect.expect(dart.fn(() => {
              oldHandler.cancel();
            }, VoidToNull()), src__core_matchers.returnsNormally);
            src__http__http.Http.get(requestUri);
            yield utils.nextTick();
            src__frontend__expect.expect(src__mocks__mock_transports.MockTransports.http.numPendingRequests, src__core_matchers.equals(1));
            yield src__mocks__mock_transports.MockTransports.reset();
          }), VoidToFutureOfNull()));
        }, VoidToNull()));
      }, VoidToNull()));
      test.group('MockHttpInternal', dart.fn(() => {
        test.group('hasHandlerForRequest()', dart.fn(() => {
          test.test('returns true if there is a matching expectation', dart.fn(() => async.async(core.Null, function*() {
            src__mocks__mock_transports.MockTransports.http.expect('GET', requestUri);
            src__frontend__expect.expect(src__mocks__mock_transports.MockHttpInternal.hasHandlerForRequest('GET', requestUri, new (IdentityMapOfString$String()).new()), src__core_matchers.isTrue);
            yield src__mocks__mock_transports.MockTransports.reset();
          }), VoidToFutureOfNull()));
          test.test('returns true if there is a matching handler', dart.fn(() => async.async(core.Null, function*() {
            src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(request => async.async(src__http__mock__response.MockResponse, function*() {
              return src__http__mock__response.MockResponse.ok();
            }), FinalizedRequestToFutureOfMockResponse()), {method: 'GET'});
            src__frontend__expect.expect(src__mocks__mock_transports.MockHttpInternal.hasHandlerForRequest('GET', requestUri, new (IdentityMapOfString$String()).new()), src__core_matchers.isTrue);
            yield src__mocks__mock_transports.MockTransports.reset();
          }), VoidToFutureOfNull()));
          test.test('returns false if there are no matching expectations nor handlers', dart.fn(() => {
            src__frontend__expect.expect(src__mocks__mock_transports.MockHttpInternal.hasHandlerForRequest('GET', requestUri, new (IdentityMapOfString$String()).new()), src__core_matchers.isFalse);
          }, VoidToNull()));
        }, VoidToNull()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  dart.trackLibraries("test/test__unit__mocks__mock_http_test", {
    "unit/mocks/mock_http_test.dart": unit__mocks__mock_http_test
  }, null);
  // Exports:
  return {
    unit__mocks__mock_http_test: unit__mocks__mock_http_test
  };
});
