define(['dart_sdk', 'test/test__shared_2', 'packages/w_transport/lib__w_transport', 'packages/test/lib__test', 'packages/matcher/lib__shared_0'], function(dart_sdk, test__shared_2, lib__w_transport, lib__test, lib__shared_0) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const src__mocks__mock_transports = lib__w_transport.src__mocks__mock_transports;
  const src__web_socket__mock__web_socket = lib__w_transport.src__web_socket__mock__web_socket;
  const src__web_socket__mock__w_socket = lib__w_transport.src__web_socket__mock__w_socket;
  const src__web_socket__w_socket = lib__w_transport.src__web_socket__w_socket;
  const src__transport_platform = lib__w_transport.src__transport_platform;
  const test = lib__test.test;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const src__frontend__throws_matcher = lib__test.src__frontend__throws_matcher;
  const src__frontend__throws_matchers = lib__test.src__frontend__throws_matchers;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const _root = Object.create(null);
  const unit__mocks__mock_web_socket_test = Object.create(_root);
  const $contains = dartx.contains;
  const $toString = dartx.toString;
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let isInstanceOfOfMockWSocket = () => (isInstanceOfOfMockWSocket = dart.constFn(src__core_matchers.isInstanceOf$(src__web_socket__mock__w_socket.MockWSocket)))();
  let dynamicTobool = () => (dynamicTobool = dart.constFn(dart.fnType(core.bool, [dart.dynamic])))();
  let isInstanceOfOfTransportPlatformMissing = () => (isInstanceOfOfTransportPlatformMissing = dart.constFn(src__core_matchers.isInstanceOf$(src__transport_platform.TransportPlatformMissing)))();
  let FutureOfWSocket = () => (FutureOfWSocket = dart.constFn(async.Future$(src__web_socket__w_socket.WSocket)))();
  let MapOfString$dynamic = () => (MapOfString$dynamic = dart.constFn(core.Map$(core.String, dart.dynamic)))();
  let IterableOfString = () => (IterableOfString = dart.constFn(core.Iterable$(core.String)))();
  let Uri__ToFutureOfWSocket = () => (Uri__ToFutureOfWSocket = dart.constFn(dart.fnType(FutureOfWSocket(), [core.Uri], {headers: MapOfString$dynamic(), protocols: IterableOfString()})))();
  let Uri__ToFutureOfWSocket$ = () => (Uri__ToFutureOfWSocket$ = dart.constFn(dart.fnType(FutureOfWSocket(), [core.Uri], {headers: MapOfString$dynamic(), match: core.Match, protocols: IterableOfString()})))();
  let FutureOfMockWSocket = () => (FutureOfMockWSocket = dart.constFn(async.Future$(src__web_socket__mock__w_socket.MockWSocket)))();
  let Uri__ToFutureOfMockWSocket = () => (Uri__ToFutureOfMockWSocket = dart.constFn(dart.fnType(FutureOfMockWSocket(), [core.Uri], {protocols: IterableOfString(), headers: MapOfString$dynamic()})))();
  let FutureOfString = () => (FutureOfString = dart.constFn(async.Future$(core.String)))();
  let Uri__ToFutureOfString = () => (Uri__ToFutureOfString = dart.constFn(dart.fnType(FutureOfString(), [core.Uri], {headers: MapOfString$dynamic(), protocols: IterableOfString()})))();
  let Uri__ToFutureOfMockWSocket$ = () => (Uri__ToFutureOfMockWSocket$ = dart.constFn(dart.fnType(FutureOfMockWSocket(), [core.Uri], {protocols: IterableOfString(), headers: MapOfString$dynamic(), match: core.Match})))();
  let Uri__ToFutureOfString$ = () => (Uri__ToFutureOfString$ = dart.constFn(dart.fnType(FutureOfString(), [core.Uri], {headers: MapOfString$dynamic(), match: core.Match, protocols: IterableOfString()})))();
  let CompleterOfNull = () => (CompleterOfNull = dart.constFn(async.Completer$(core.Null)))();
  let ObjectTovoid = () => (ObjectTovoid = dart.constFn(dart.fnType(dart.void, [core.Object])))();
  let MockWebSocketConnectionToNull = () => (MockWebSocketConnectionToNull = dart.constFn(dart.fnType(core.Null, [src__mocks__mock_transports.MockWebSocketConnection])))();
  unit__mocks__mock_web_socket_test.main = function() {
    let naming = new naming$.Naming.new();
    naming.testType = "unit";
    naming.topic = "Mocks";
    test.group(naming.toString(), dart.fn(() => {
      let webSocketUri = core.Uri.parse('/mock/ws');
      test.setUp(dart.fn(() => {
        src__mocks__mock_transports.MockTransports.install();
      }, VoidToNull()));
      test.tearDown(dart.fn(() => async.async(core.Null, function*() {
        src__mocks__mock_transports.MockTransports.verifyNoOutstandingExceptions();
        yield src__mocks__mock_transports.MockTransports.uninstall();
      }), VoidToFutureOfNull()));
      test.test('MockWebSocket extends MockWSocket', dart.fn(() => {
        src__frontend__expect.expect(src__web_socket__mock__web_socket.MockWebSocket.new(), new (isInstanceOfOfMockWSocket()).new());
      }, VoidToNull()));
      test.group('TransportMocks.webSocket', dart.fn(() => {
        test.group('expect()', dart.fn(() => {
          test.test('expected web socket connection completes automatically', dart.fn(() => async.async(core.Null, function*() {
            let webSocket = src__web_socket__mock__w_socket.MockWSocket.new();
            src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: webSocket});
            src__frontend__expect.expect(yield src__web_socket__w_socket.WSocket.connect(webSocketUri), src__core_matchers.equals(webSocket));
          }), VoidToFutureOfNull()));
          test.test('expected web socket connection rejected', dart.fn(() => async.async(core.Null, function*() {
            src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {reject: true});
            src__frontend__expect.expect(src__web_socket__w_socket.WSocket.connect(webSocketUri), src__frontend__throws_matcher.throwsA(src__core_matchers.predicate(dart.dynamic, dart.fn(error => dart.toString(error)[$contains]('rejected'), dynamicTobool()))));
          }), VoidToFutureOfNull()));
          test.test('unexpected web socket connection throws', dart.fn(() => async.async(core.Null, function*() {
            src__frontend__expect.expect(src__web_socket__w_socket.WSocket.connect(webSocketUri), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfTransportPlatformMissing()).new()));
          }), VoidToFutureOfNull()));
          test.test('supports connectTo OR reject, but not both', dart.fn(() => {
            src__frontend__expect.expect(dart.fn(() => {
              src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: src__web_socket__mock__w_socket.MockWSocket.new(), reject: true});
            }, VoidToNull()), src__frontend__throws_matchers.throwsArgumentError);
          }, VoidToNull()));
          test.test('requires connectTo OR reject', dart.fn(() => {
            src__frontend__expect.expect(dart.fn(() => {
              src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri);
            }, VoidToNull()), src__frontend__throws_matchers.throwsArgumentError);
          }, VoidToNull()));
          test.test('requires that connectTo is a MockWSocket or MockWebSocketServer', dart.fn(() => {
            src__frontend__expect.expect(dart.fn(() => {
              src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: 'invalid'});
            }, VoidToNull()), src__frontend__throws_matchers.throwsArgumentError);
          }, VoidToNull()));
        }, VoidToNull()));
        test.group('expectPattern()', dart.fn(() => {
          test.test('expected web socket connection completes automatically', dart.fn(() => async.async(core.Null, function*() {
            let webSocket = src__web_socket__mock__w_socket.MockWSocket.new();
            src__mocks__mock_transports.MockTransports.webSocket.expectPattern(dart.toString(webSocketUri), {connectTo: webSocket});
            src__frontend__expect.expect(yield src__web_socket__w_socket.WSocket.connect(webSocketUri), src__core_matchers.equals(webSocket));
          }), VoidToFutureOfNull()));
          test.test('expected web socket connection rejected', dart.fn(() => async.async(core.Null, function*() {
            src__mocks__mock_transports.MockTransports.webSocket.expectPattern(dart.toString(webSocketUri), {reject: true});
            src__frontend__expect.expect(src__web_socket__w_socket.WSocket.connect(webSocketUri), src__frontend__throws_matcher.throwsA(src__core_matchers.predicate(dart.dynamic, dart.fn(error => dart.toString(error)[$contains]('rejected'), dynamicTobool()))));
          }), VoidToFutureOfNull()));
          test.test('supports connectTo OR reject, but not both', dart.fn(() => {
            src__frontend__expect.expect(dart.fn(() => {
              src__mocks__mock_transports.MockTransports.webSocket.expectPattern(dart.toString(webSocketUri), {connectTo: src__web_socket__mock__w_socket.MockWSocket.new(), reject: true});
            }, VoidToNull()), src__frontend__throws_matchers.throwsArgumentError);
          }, VoidToNull()));
          test.test('requires connectTo OR reject', dart.fn(() => {
            src__frontend__expect.expect(dart.fn(() => {
              src__mocks__mock_transports.MockTransports.webSocket.expectPattern(dart.toString(webSocketUri));
            }, VoidToNull()), src__frontend__throws_matchers.throwsArgumentError);
          }, VoidToNull()));
          test.test('requires that connectTo is a MockWSocket or MockWebSocketServer', dart.fn(() => {
            src__frontend__expect.expect(dart.fn(() => {
              src__mocks__mock_transports.MockTransports.webSocket.expectPattern(dart.toString(webSocketUri), {connectTo: 'invalid'});
            }, VoidToNull()), src__frontend__throws_matchers.throwsArgumentError);
          }, VoidToNull()));
        }, VoidToNull()));
        test.test('reset() should clear all expectations and handlers', dart.fn(() => async.async(core.Null, function*() {
          function handler(uri, opts) {
            return async.async(src__web_socket__w_socket.WSocket, function* handler() {
              let headers = opts && 'headers' in opts ? opts.headers : null;
              let protocols = opts && 'protocols' in opts ? opts.protocols : null;
              return src__web_socket__mock__w_socket.MockWSocket.new();
            });
          }
          dart.fn(handler, Uri__ToFutureOfWSocket());
          function patternHandler(uri, opts) {
            return async.async(src__web_socket__w_socket.WSocket, function* patternHandler() {
              let headers = opts && 'headers' in opts ? opts.headers : null;
              let match = opts && 'match' in opts ? opts.match : null;
              let protocols = opts && 'protocols' in opts ? opts.protocols : null;
              return src__web_socket__mock__w_socket.MockWSocket.new();
            });
          }
          dart.fn(patternHandler, Uri__ToFutureOfWSocket$());
          src__mocks__mock_transports.MockTransports.webSocket.when(webSocketUri, {handler: handler});
          src__mocks__mock_transports.MockTransports.webSocket.whenPattern(dart.toString(webSocketUri), {handler: patternHandler});
          src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: src__web_socket__mock__w_socket.MockWSocket.new()});
          src__mocks__mock_transports.MockTransports.webSocket.expectPattern(dart.toString(webSocketUri), {connectTo: src__web_socket__mock__w_socket.MockWSocket.new()});
          src__mocks__mock_transports.MockTransports.webSocket.reset();
          src__frontend__expect.expect(src__web_socket__w_socket.WSocket.connect(webSocketUri), src__frontend__throws_matcher.throws);
        }), VoidToFutureOfNull()));
        test.group('when()', dart.fn(() => {
          test.test('registers a handler for all web socket connections with matching URI', dart.fn(() => async.async(core.Null, function*() {
            let webSocket = src__web_socket__mock__w_socket.MockWSocket.new();
            function handler(uri, opts) {
              return async.async(src__web_socket__w_socket.WSocket, function* handler() {
                let headers = opts && 'headers' in opts ? opts.headers : null;
                let protocols = opts && 'protocols' in opts ? opts.protocols : null;
                return webSocket;
              });
            }
            dart.fn(handler, Uri__ToFutureOfWSocket());
            src__mocks__mock_transports.MockTransports.webSocket.when(webSocketUri, {handler: handler});
            src__frontend__expect.expect(yield src__web_socket__w_socket.WSocket.connect(webSocketUri), src__core_matchers.equals(webSocket));
            src__frontend__expect.expect(yield src__web_socket__w_socket.WSocket.connect(webSocketUri), src__core_matchers.equals(webSocket));
            src__frontend__expect.expect(src__web_socket__w_socket.WSocket.connect(core.Uri.parse('/other')), src__frontend__throws_matcher.throws);
          }), VoidToFutureOfNull()));
          test.test('registers a rejection for all requests with matching URI', dart.fn(() => async.async(core.Null, function*() {
            src__mocks__mock_transports.MockTransports.webSocket.when(webSocketUri, {reject: true});
            src__frontend__expect.expect(src__web_socket__w_socket.WSocket.connect(webSocketUri), src__frontend__throws_matcher.throwsA(src__core_matchers.predicate(dart.dynamic, dart.fn(error => dart.toString(error)[$contains]('rejected'), dynamicTobool()))));
            src__frontend__expect.expect(src__web_socket__w_socket.WSocket.connect(webSocketUri), src__frontend__throws_matcher.throwsA(src__core_matchers.predicate(dart.dynamic, dart.fn(error => dart.toString(error)[$contains]('rejected'), dynamicTobool()))));
            src__frontend__expect.expect(src__web_socket__w_socket.WSocket.connect(core.Uri.parse('/other')), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfTransportPlatformMissing()).new()));
          }), VoidToFutureOfNull()));
          test.test('supports handler OR reject, but not both', dart.fn(() => {
            src__frontend__expect.expect(dart.fn(() => {
              src__mocks__mock_transports.MockTransports.webSocket.when(webSocketUri, {handler: dart.fn((uri, opts) => async.async(src__web_socket__mock__w_socket.MockWSocket, function*() {
                  let protocols = opts && 'protocols' in opts ? opts.protocols : null;
                  let headers = opts && 'headers' in opts ? opts.headers : null;
                  return src__web_socket__mock__w_socket.MockWSocket.new();
                }), Uri__ToFutureOfMockWSocket()), reject: true});
            }, VoidToNull()), src__frontend__throws_matchers.throwsArgumentError);
          }, VoidToNull()));
          test.test('requires handler OR reject', dart.fn(() => {
            src__frontend__expect.expect(dart.fn(() => {
              src__mocks__mock_transports.MockTransports.webSocket.when(webSocketUri);
            }, VoidToNull()), src__frontend__throws_matchers.throwsArgumentError);
          }, VoidToNull()));
          test.test('requires that the handler returns MockWSocket or MockWebSocketServer', dart.fn(() => {
            src__mocks__mock_transports.MockTransports.webSocket.when(webSocketUri, {handler: dart.fn((uri, opts) => async.async(core.String, function*() {
                let headers = opts && 'headers' in opts ? opts.headers : null;
                let protocols = opts && 'protocols' in opts ? opts.protocols : null;
                return 'invalid';
              }), Uri__ToFutureOfString())});
            src__frontend__expect.expect(src__web_socket__mock__w_socket.MockWSocket.connect(webSocketUri), src__frontend__throws_matchers.throwsArgumentError);
          }, VoidToNull()));
          test.test('registers a handler that can be canceled', dart.fn(() => async.async(core.Null, function*() {
            let webSocket = src__web_socket__mock__w_socket.MockWSocket.new();
            let handler = src__mocks__mock_transports.MockTransports.webSocket.when(webSocketUri, {handler: dart.fn((uri, opts) => async.async(src__web_socket__mock__w_socket.MockWSocket, function*() {
                let protocols = opts && 'protocols' in opts ? opts.protocols : null;
                let headers = opts && 'headers' in opts ? opts.headers : null;
                return webSocket;
              }), Uri__ToFutureOfMockWSocket())});
            src__frontend__expect.expect(yield src__web_socket__w_socket.WSocket.connect(webSocketUri), src__core_matchers.equals(webSocket));
            handler.cancel();
            src__frontend__expect.expect(src__web_socket__w_socket.WSocket.connect(webSocketUri), src__frontend__throws_matchers.throwsStateError);
          }), VoidToFutureOfNull()));
          test.test('canceling a handler does nothing if handler no longer exists', dart.fn(() => async.async(core.Null, function*() {
            let webSocket = src__web_socket__mock__w_socket.MockWSocket.new();
            let oldHandler = src__mocks__mock_transports.MockTransports.webSocket.when(webSocketUri, {reject: true});
            src__mocks__mock_transports.MockTransports.webSocket.when(webSocketUri, {handler: dart.fn((uri, opts) => async.async(src__web_socket__mock__w_socket.MockWSocket, function*() {
                let protocols = opts && 'protocols' in opts ? opts.protocols : null;
                let headers = opts && 'headers' in opts ? opts.headers : null;
                return webSocket;
              }), Uri__ToFutureOfMockWSocket())});
            src__frontend__expect.expect(dart.fn(() => {
              oldHandler.cancel();
            }, VoidToNull()), src__core_matchers.returnsNormally);
            src__frontend__expect.expect(yield src__web_socket__w_socket.WSocket.connect(webSocketUri), src__core_matchers.equals(webSocket));
          }), VoidToFutureOfNull()));
          test.test('canceling a handler does nothing if handler was reset', dart.fn(() => async.async(core.Null, function*() {
            let webSocket = src__web_socket__mock__w_socket.MockWSocket.new();
            let oldHandler = src__mocks__mock_transports.MockTransports.webSocket.when(webSocketUri, {handler: dart.fn((uri, opts) => async.async(src__web_socket__mock__w_socket.MockWSocket, function*() {
                let protocols = opts && 'protocols' in opts ? opts.protocols : null;
                let headers = opts && 'headers' in opts ? opts.headers : null;
                return webSocket;
              }), Uri__ToFutureOfMockWSocket())});
            yield src__mocks__mock_transports.MockTransports.reset();
            src__frontend__expect.expect(dart.fn(() => {
              oldHandler.cancel();
            }, VoidToNull()), src__core_matchers.returnsNormally);
            src__frontend__expect.expect(src__web_socket__w_socket.WSocket.connect(webSocketUri), src__frontend__throws_matchers.throwsStateError);
            yield webSocket.close();
          }), VoidToFutureOfNull()));
        }, VoidToNull()));
        test.group('whenPattern()', dart.fn(() => {
          test.test('registers a handler for all web socket connections with matching URI', dart.fn(() => async.async(core.Null, function*() {
            let webSocket = src__web_socket__mock__w_socket.MockWSocket.new();
            function handler(uri, opts) {
              return async.async(src__web_socket__w_socket.WSocket, function* handler() {
                let headers = opts && 'headers' in opts ? opts.headers : null;
                let match = opts && 'match' in opts ? opts.match : null;
                let protocols = opts && 'protocols' in opts ? opts.protocols : null;
                return webSocket;
              });
            }
            dart.fn(handler, Uri__ToFutureOfWSocket$());
            src__mocks__mock_transports.MockTransports.webSocket.whenPattern(dart.toString(webSocketUri), {handler: handler});
            src__frontend__expect.expect(yield src__web_socket__w_socket.WSocket.connect(webSocketUri), src__core_matchers.equals(webSocket));
            src__frontend__expect.expect(yield src__web_socket__w_socket.WSocket.connect(webSocketUri), src__core_matchers.equals(webSocket));
            src__frontend__expect.expect(src__web_socket__w_socket.WSocket.connect(core.Uri.parse('/other')), src__frontend__throws_matcher.throws);
          }), VoidToFutureOfNull()));
          test.test('registers a rejection for all requests with matching URI', dart.fn(() => async.async(core.Null, function*() {
            src__mocks__mock_transports.MockTransports.webSocket.whenPattern(dart.toString(webSocketUri), {reject: true});
            src__frontend__expect.expect(src__web_socket__w_socket.WSocket.connect(webSocketUri), src__frontend__throws_matcher.throwsA(src__core_matchers.predicate(dart.dynamic, dart.fn(error => dart.toString(error)[$contains]('rejected'), dynamicTobool()))));
            src__frontend__expect.expect(src__web_socket__w_socket.WSocket.connect(webSocketUri), src__frontend__throws_matcher.throwsA(src__core_matchers.predicate(dart.dynamic, dart.fn(error => dart.toString(error)[$contains]('rejected'), dynamicTobool()))));
            src__frontend__expect.expect(src__web_socket__w_socket.WSocket.connect(core.Uri.parse('/other')), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfTransportPlatformMissing()).new()));
          }), VoidToFutureOfNull()));
          test.test('supports handler OR reject, but not both', dart.fn(() => {
            src__frontend__expect.expect(dart.fn(() => {
              src__mocks__mock_transports.MockTransports.webSocket.whenPattern(dart.toString(webSocketUri), {handler: dart.fn((uri, opts) => async.async(src__web_socket__mock__w_socket.MockWSocket, function*() {
                  let protocols = opts && 'protocols' in opts ? opts.protocols : null;
                  let headers = opts && 'headers' in opts ? opts.headers : null;
                  let match = opts && 'match' in opts ? opts.match : null;
                  return src__web_socket__mock__w_socket.MockWSocket.new();
                }), Uri__ToFutureOfMockWSocket$()), reject: true});
            }, VoidToNull()), src__frontend__throws_matchers.throwsArgumentError);
          }, VoidToNull()));
          test.test('requires handler OR reject', dart.fn(() => {
            src__frontend__expect.expect(dart.fn(() => {
              src__mocks__mock_transports.MockTransports.webSocket.whenPattern(dart.toString(webSocketUri));
            }, VoidToNull()), src__frontend__throws_matchers.throwsArgumentError);
          }, VoidToNull()));
          test.test('requires that the handler returns MockWSocket or MockWebSocketServer', dart.fn(() => {
            src__mocks__mock_transports.MockTransports.webSocket.whenPattern(dart.toString(webSocketUri), {handler: dart.fn((uri, opts) => async.async(core.String, function*() {
                let headers = opts && 'headers' in opts ? opts.headers : null;
                let match = opts && 'match' in opts ? opts.match : null;
                let protocols = opts && 'protocols' in opts ? opts.protocols : null;
                return 'invalid';
              }), Uri__ToFutureOfString$())});
            src__frontend__expect.expect(src__web_socket__w_socket.WSocket.connect(webSocketUri), src__frontend__throws_matchers.throwsArgumentError);
          }, VoidToNull()));
          test.test('registers a handler with a pattern that catches any connection with a matching URI', dart.fn(() => async.async(core.Null, function*() {
            let uriPattern = core.RegExp.new('ws://(google|github).com/ws.*');
            let webSocket = src__web_socket__mock__w_socket.MockWSocket.new();
            function handler(uri, opts) {
              return async.async(src__web_socket__w_socket.WSocket, function* handler() {
                let headers = opts && 'headers' in opts ? opts.headers : null;
                let match = opts && 'match' in opts ? opts.match : null;
                let protocols = opts && 'protocols' in opts ? opts.protocols : null;
                return webSocket;
              });
            }
            dart.fn(handler, Uri__ToFutureOfWSocket$());
            src__mocks__mock_transports.MockTransports.webSocket.whenPattern(uriPattern, {handler: handler});
            src__frontend__expect.expect(yield src__web_socket__w_socket.WSocket.connect(core.Uri.parse('ws://google.com/ws')), src__core_matchers.equals(webSocket));
            src__frontend__expect.expect(yield src__web_socket__w_socket.WSocket.connect(core.Uri.parse('ws://github.com/ws/listen')), src__core_matchers.equals(webSocket));
            src__frontend__expect.expect(src__web_socket__w_socket.WSocket.connect(core.Uri.parse('/other')), src__frontend__throws_matcher.throws);
          }), VoidToFutureOfNull()));
          test.test('registers a handler that will receive the uri Match on connection', dart.fn(() => async.async(core.Null, function*() {
            let uriPattern = core.RegExp.new('ws://(google|github).com/ws.*');
            let uriMatch = null;
            function handler(uri, opts) {
              return async.async(src__web_socket__w_socket.WSocket, function* handler() {
                let headers = opts && 'headers' in opts ? opts.headers : null;
                let match = opts && 'match' in opts ? opts.match : null;
                let protocols = opts && 'protocols' in opts ? opts.protocols : null;
                uriMatch = match;
                return src__web_socket__mock__w_socket.MockWSocket.new();
              });
            }
            dart.fn(handler, Uri__ToFutureOfWSocket$());
            src__mocks__mock_transports.MockTransports.webSocket.whenPattern(uriPattern, {handler: handler});
            yield src__web_socket__w_socket.WSocket.connect(core.Uri.parse('ws://github.com/ws/listen'));
            src__frontend__expect.expect(uriMatch.group(0), src__core_matchers.equals('ws://github.com/ws/listen'));
            src__frontend__expect.expect(uriMatch.group(1), src__core_matchers.equals('github'));
          }), VoidToFutureOfNull()));
          test.test('registers a handler that can be canceled', dart.fn(() => async.async(core.Null, function*() {
            let webSocket = src__web_socket__mock__w_socket.MockWSocket.new();
            let handler = src__mocks__mock_transports.MockTransports.webSocket.whenPattern(dart.toString(webSocketUri), {handler: dart.fn((uri, opts) => async.async(src__web_socket__mock__w_socket.MockWSocket, function*() {
                let protocols = opts && 'protocols' in opts ? opts.protocols : null;
                let headers = opts && 'headers' in opts ? opts.headers : null;
                let match = opts && 'match' in opts ? opts.match : null;
                return webSocket;
              }), Uri__ToFutureOfMockWSocket$())});
            src__frontend__expect.expect(yield src__web_socket__w_socket.WSocket.connect(webSocketUri), src__core_matchers.equals(webSocket));
            handler.cancel();
            src__frontend__expect.expect(src__web_socket__w_socket.WSocket.connect(webSocketUri), src__frontend__throws_matchers.throwsStateError);
          }), VoidToFutureOfNull()));
          test.test('canceling a handler does nothing if handler no longer exists', dart.fn(() => async.async(core.Null, function*() {
            let webSocket = src__web_socket__mock__w_socket.MockWSocket.new();
            let oldHandler = src__mocks__mock_transports.MockTransports.webSocket.whenPattern(dart.toString(webSocketUri), {reject: true});
            src__mocks__mock_transports.MockTransports.webSocket.whenPattern(dart.toString(webSocketUri), {handler: dart.fn((uri, opts) => async.async(src__web_socket__mock__w_socket.MockWSocket, function*() {
                let protocols = opts && 'protocols' in opts ? opts.protocols : null;
                let headers = opts && 'headers' in opts ? opts.headers : null;
                let match = opts && 'match' in opts ? opts.match : null;
                return webSocket;
              }), Uri__ToFutureOfMockWSocket$())});
            src__frontend__expect.expect(dart.fn(() => {
              oldHandler.cancel();
            }, VoidToNull()), src__core_matchers.returnsNormally);
            src__frontend__expect.expect(yield src__web_socket__w_socket.WSocket.connect(webSocketUri), src__core_matchers.equals(webSocket));
          }), VoidToFutureOfNull()));
          test.test('canceling a handler does nothing if handler was reset', dart.fn(() => async.async(core.Null, function*() {
            let webSocket = src__web_socket__mock__w_socket.MockWSocket.new();
            let oldHandler = src__mocks__mock_transports.MockTransports.webSocket.whenPattern(dart.toString(webSocketUri), {handler: dart.fn((uri, opts) => async.async(src__web_socket__mock__w_socket.MockWSocket, function*() {
                let protocols = opts && 'protocols' in opts ? opts.protocols : null;
                let headers = opts && 'headers' in opts ? opts.headers : null;
                let match = opts && 'match' in opts ? opts.match : null;
                return webSocket;
              }), Uri__ToFutureOfMockWSocket$())});
            yield src__mocks__mock_transports.MockTransports.reset();
            src__frontend__expect.expect(dart.fn(() => {
              oldHandler.cancel();
            }, VoidToNull()), src__core_matchers.returnsNormally);
            src__frontend__expect.expect(src__web_socket__w_socket.WSocket.connect(webSocketUri), src__frontend__throws_matchers.throwsStateError);
            yield webSocket.close();
          }), VoidToFutureOfNull()));
        }, VoidToNull()));
      }, VoidToNull()));
      test.group('MockWebSocketInternal', dart.fn(() => {
        test.group('hasHandlerForWebSocket()', dart.fn(() => {
          test.test('returns true if there is a matching expectation', dart.fn(() => async.async(core.Null, function*() {
            src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: new src__mocks__mock_transports.MockWebSocketServer.new()});
            src__frontend__expect.expect(src__mocks__mock_transports.MockWebSocketInternal.hasHandlerForWebSocket(webSocketUri), src__core_matchers.isTrue);
            yield src__mocks__mock_transports.MockTransports.reset();
          }), VoidToFutureOfNull()));
          test.test('returns true if there is a matching handler', dart.fn(() => async.async(core.Null, function*() {
            src__mocks__mock_transports.MockTransports.webSocket.when(webSocketUri, {reject: true});
            src__frontend__expect.expect(src__mocks__mock_transports.MockWebSocketInternal.hasHandlerForWebSocket(webSocketUri), src__core_matchers.isTrue);
            yield src__mocks__mock_transports.MockTransports.reset();
          }), VoidToFutureOfNull()));
          test.test('returns false if there are no matching expectations nor handlers', dart.fn(() => {
            src__frontend__expect.expect(src__mocks__mock_transports.MockWebSocketInternal.hasHandlerForWebSocket(webSocketUri), src__core_matchers.isFalse);
          }, VoidToNull()));
        }, VoidToNull()));
      }, VoidToNull()));
      test.group('MockWebSocketServer', dart.fn(() => {
        test.test('should expose `done` for connected clients', dart.fn(() => async.async(core.Null, function*() {
          let c = CompleterOfNull().new();
          let mockWebSocketServer = new src__mocks__mock_transports.MockWebSocketServer.new();
          mockWebSocketServer.onClientConnected.listen(dart.fn(connection => {
            connection.done.then(dart.void, dart.fn(_ => c.complete(), ObjectTovoid()));
          }, MockWebSocketConnectionToNull()));
          src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: mockWebSocketServer});
          let webSocket = (yield src__web_socket__w_socket.WSocket.connect(webSocketUri));
          yield webSocket.close();
          yield c.future;
        }), VoidToFutureOfNull()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  dart.trackLibraries("test/test__unit__mocks__mock_web_socket_test", {
    "unit/mocks/mock_web_socket_test.dart": unit__mocks__mock_web_socket_test
  }, null);
  // Exports:
  return {
    unit__mocks__mock_web_socket_test: unit__mocks__mock_web_socket_test
  };
});
