define(['dart_sdk', 'test/test__shared_2', 'packages/w_transport/lib__shared_0', 'packages/test/lib__test', 'packages/matcher/lib__shared_0', 'packages/mockito/lib__shared_0'], function(dart_sdk, test__shared_2, lib__shared_0, lib__test, lib__shared_0$, lib__shared_0$0) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const _interceptors = dart_sdk._interceptors;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const src__web_socket__w_socket_subscription = lib__shared_0.src__web_socket__w_socket_subscription;
  const test = lib__test.test;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const src__core_matchers = lib__shared_0$.src__core_matchers;
  const src__mock = lib__shared_0$0.src__mock;
  const _root = Object.create(null);
  const unit__ws__w_socket_subscription_test = Object.create(_root);
  let CompleterOfNull = () => (CompleterOfNull = dart.constFn(async.Completer$(core.Null)))();
  let dynamicToNull = () => (dynamicToNull = dart.constFn(dart.fnType(core.Null, [dart.dynamic])))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let JSArrayOfFuture = () => (JSArrayOfFuture = dart.constFn(_interceptors.JSArray$(async.Future)))();
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  unit__ws__w_socket_subscription_test.main = function() {
    let naming = new naming$.Naming.new();
    naming.testType = "unit";
    naming.topic = "WS";
    test.group(naming.toString(), dart.fn(() => {
      test.group('WSocketSubscription', dart.fn(() => {
        test.test('cancel() should cancel underlying subscription and call callback', dart.fn(() => async.async(core.Null, function*() {
          let onCancelCalled = CompleterOfNull().new();
          let sc = async.StreamController.new();
          let sub = sc.stream.listen(dart.fn(_ => {
          }, dynamicToNull()));
          let wsub = new src__web_socket__w_socket_subscription.WSocketSubscription.new(sub, dart.fn(() => {
          }, VoidToNull()), {onCancel: dart.bind(onCancelCalled, 'complete')});
          yield async.Future.wait(dart.dynamic, JSArrayOfFuture().of([wsub.cancel(), onCancelCalled.future]));
          yield sc.close();
          yield sub.cancel();
        }), VoidToFutureOfNull()));
        test.test('isPaused should return the status of the underlying subscription', dart.fn(() => async.async(core.Null, function*() {
          let sc = async.StreamController.new();
          let sub = sc.stream.listen(dart.fn(_ => {
          }, dynamicToNull()));
          let wsub = new src__web_socket__w_socket_subscription.WSocketSubscription.new(sub, dart.fn(() => {
          }, VoidToNull()));
          src__frontend__expect.expect(sub.isPaused, src__core_matchers.isFalse);
          src__frontend__expect.expect(wsub.isPaused, src__core_matchers.isFalse);
          sub.pause();
          src__frontend__expect.expect(sub.isPaused, src__core_matchers.isTrue);
          src__frontend__expect.expect(wsub.isPaused, src__core_matchers.isTrue);
          sub.resume();
          yield async.Future.wait(dart.dynamic, JSArrayOfFuture().of([sc.close(), sub.cancel(), wsub.cancel()]));
        }), VoidToFutureOfNull()));
        test.test('onDone() should update the done handler', dart.fn(() => async.async(core.Null, function*() {
          let sub = new unit__ws__w_socket_subscription_test.MockStreamSubscription.new();
          let wsub = new src__web_socket__w_socket_subscription.WSocketSubscription.new(sub, dart.fn(() => {
          }, VoidToNull()));
          let doneHandler = () => {
          };
          dart.fn(doneHandler, VoidToNull());
          wsub.onDone(doneHandler);
          src__frontend__expect.expect(wsub.doneHandler, src__core_matchers.equals(doneHandler));
          yield wsub.cancel();
          yield sub.cancel();
        }), VoidToFutureOfNull()));
        test.test('onError() should call onError() on the underlying subscription', dart.fn(() => async.async(core.Null, function*() {
          let sub = new unit__ws__w_socket_subscription_test.MockStreamSubscription.new();
          let wsub = new src__web_socket__w_socket_subscription.WSocketSubscription.new(sub, dart.fn(() => {
          }, VoidToNull()));
          let errorHandler = _ => {
          };
          dart.fn(errorHandler, dynamicToNull());
          wsub.onError(errorHandler);
          src__frontend__expect.expect(sub.onErrorHandler === errorHandler, src__core_matchers.isTrue);
          yield wsub.cancel();
          yield sub.cancel();
        }), VoidToFutureOfNull()));
        test.test('onData() should call onData() on the underlying subscription', dart.fn(() => async.async(core.Null, function*() {
          let sub = new unit__ws__w_socket_subscription_test.MockStreamSubscription.new();
          let wsub = new src__web_socket__w_socket_subscription.WSocketSubscription.new(sub, dart.fn(() => {
          }, VoidToNull()));
          let dataHandler = _ => {
          };
          dart.fn(dataHandler, dynamicToNull());
          wsub.onData(dataHandler);
          src__frontend__expect.expect(sub.onDataHandler === dataHandler, src__core_matchers.isTrue);
          yield wsub.cancel();
          yield sub.cancel();
        }), VoidToFutureOfNull()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  const _is_MockStreamSubscription_default = Symbol('_is_MockStreamSubscription_default');
  unit__ws__w_socket_subscription_test.MockStreamSubscription$ = dart.generic(T => {
    let StreamSubscriptionOfT = () => (StreamSubscriptionOfT = dart.constFn(async.StreamSubscription$(T)))();
    class MockStreamSubscription extends src__mock.Mock {
      get onDataHandler() {
        return this[onDataHandler];
      }
      set onDataHandler(value) {
        this[onDataHandler] = value;
      }
      get onDoneHandler() {
        return this[onDoneHandler];
      }
      set onDoneHandler(value) {
        this[onDoneHandler] = value;
      }
      get onErrorHandler() {
        return this[onErrorHandler];
      }
      set onErrorHandler(value) {
        this[onErrorHandler] = value;
      }
      onData(handleData) {
        this.onDataHandler = handleData;
      }
      onDone(handleDone) {
        this.onDoneHandler = handleDone;
      }
      onError(handleError) {
        this.onErrorHandler = handleError;
      }
      cancel(...args) {
        return async.Future._check(this.noSuchMethod(new dart.InvocationImpl.new('cancel', args, {isMethod: true})));
      }
      pause(...args) {
        return dart.void._check(this.noSuchMethod(new dart.InvocationImpl.new('pause', args, {isMethod: true})));
      }
      resume(...args) {
        return dart.void._check(this.noSuchMethod(new dart.InvocationImpl.new('resume', args, {isMethod: true})));
      }
      asFuture(E, ...args) {
        return async.Future$(E)._check(this.noSuchMethod(new dart.InvocationImpl.new('asFuture', args, {isMethod: true, typeArguments: [E]})));
      }
      get isPaused() {
        return core.bool._check(this.noSuchMethod(new dart.InvocationImpl.new('isPaused', [], {isGetter: true})));
      }
    }
    (MockStreamSubscription.new = function() {
      this[onDataHandler] = null;
      this[onDoneHandler] = null;
      this[onErrorHandler] = null;
      MockStreamSubscription.__proto__.new.call(this);
    }).prototype = MockStreamSubscription.prototype;
    MockStreamSubscription.prototype[dart.isStreamSubscription] = true;
    dart.addTypeTests(MockStreamSubscription);
    MockStreamSubscription.prototype[_is_MockStreamSubscription_default] = true;
    const onDataHandler = Symbol("MockStreamSubscription.onDataHandler");
    const onDoneHandler = Symbol("MockStreamSubscription.onDoneHandler");
    const onErrorHandler = Symbol("MockStreamSubscription.onErrorHandler");
    MockStreamSubscription[dart.implements] = () => [StreamSubscriptionOfT()];
    dart.setMethodSignature(MockStreamSubscription, () => ({
      __proto__: dart.getMethods(MockStreamSubscription.__proto__),
      onData: dart.fnType(dart.void, [dart.fnType(dart.void, [T])]),
      onDone: dart.fnType(dart.void, [dart.fnType(dart.void, [])]),
      onError: dart.fnType(dart.void, [core.Function]),
      cancel: dart.fnType(async.Future, []),
      pause: dart.fnType(dart.void, [], [async.Future]),
      resume: dart.fnType(dart.void, []),
      asFuture: dart.gFnType(E => [async.Future$(E), [], [E]])
    }));
    dart.setGetterSignature(MockStreamSubscription, () => ({
      __proto__: dart.getGetters(MockStreamSubscription.__proto__),
      isPaused: core.bool
    }));
    dart.setFieldSignature(MockStreamSubscription, () => ({
      __proto__: dart.getFields(MockStreamSubscription.__proto__),
      onDataHandler: dart.fieldType(core.Function),
      onDoneHandler: dart.fieldType(core.Function),
      onErrorHandler: dart.fieldType(core.Function)
    }));
    return MockStreamSubscription;
  });
  unit__ws__w_socket_subscription_test.MockStreamSubscription = unit__ws__w_socket_subscription_test.MockStreamSubscription$();
  dart.addTypeTests(unit__ws__w_socket_subscription_test.MockStreamSubscription, _is_MockStreamSubscription_default);
  dart.trackLibraries("test/test__unit__ws__w_socket_subscription_test", {
    "unit/ws/w_socket_subscription_test.dart": unit__ws__w_socket_subscription_test
  }, null);
  // Exports:
  return {
    unit__ws__w_socket_subscription_test: unit__ws__w_socket_subscription_test
  };
});
