define(['dart_sdk', 'test/test__shared_2', 'packages/w_transport/lib__w_transport', 'packages/test/lib__test', 'packages/w_transport/lib__mock', 'test/test__shared_20', 'packages/matcher/lib__shared_0'], function(dart_sdk, test__shared_2, lib__w_transport, lib__test, lib__mock, test__shared_20, lib__shared_0) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const _interceptors = dart_sdk._interceptors;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const src__web_socket__w_socket = lib__w_transport.src__web_socket__w_socket;
  const src__web_socket__web_socket = lib__w_transport.src__web_socket__web_socket;
  const src__mocks__mock_transports = lib__w_transport.src__mocks__mock_transports;
  const src__web_socket__mock__w_socket = lib__w_transport.src__web_socket__mock__w_socket;
  const test = lib__test.test;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const src__frontend__throws_matchers = lib__test.src__frontend__throws_matchers;
  const mock = lib__mock.mock;
  const utils = test__shared_20.utils;
  const src__iterable_matchers = lib__shared_0.src__iterable_matchers;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const _root = Object.create(null);
  const unit__ws__web_socket_test = Object.create(_root);
  const $add = dartx.add;
  let FutureOfWebSocket = () => (FutureOfWebSocket = dart.constFn(async.Future$(src__web_socket__web_socket.WebSocket)))();
  let UriToFutureOfWebSocket = () => (UriToFutureOfWebSocket = dart.constFn(dart.fnType(FutureOfWebSocket(), [core.Uri])))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let JSArrayOfString = () => (JSArrayOfString = dart.constFn(_interceptors.JSArray$(core.String)))();
  let dynamicToNull = () => (dynamicToNull = dart.constFn(dart.fnType(core.Null, [dart.dynamic])))();
  let CompleterOfString = () => (CompleterOfString = dart.constFn(async.Completer$(core.String)))();
  let FutureOrOfString = () => (FutureOrOfString = dart.constFn(async.FutureOr$(core.String)))();
  let CompleterOfNull = () => (CompleterOfNull = dart.constFn(async.Completer$(core.Null)))();
  let dynamicTovoid = () => (dynamicTovoid = dart.constFn(dart.fnType(dart.void, [dart.dynamic])))();
  unit__ws__web_socket_test.main = function() {
    let naming = new naming$.Naming.new();
    naming.testType = "unit";
    naming.topic = "WS";
    test.group(naming.toString(), dart.fn(() => {
      test.group('WSocket', dart.fn(() => {
        unit__ws__web_socket_test._runWebSocketSuite(dart.fn(uri => src__web_socket__w_socket.WSocket.connect(uri), UriToFutureOfWebSocket()));
        unit__ws__web_socket_test._runLegacyWebSocketSuite(dart.fn(uri => src__web_socket__w_socket.WSocket.connect(uri), UriToFutureOfWebSocket()));
      }, VoidToNull()));
      test.group('WebSocket', dart.fn(() => {
        unit__ws__web_socket_test._runWebSocketSuite(dart.fn(uri => src__web_socket__web_socket.WebSocket.connect(uri), UriToFutureOfWebSocket()));
        unit__ws__web_socket_test._runLegacyWebSocketSuite(dart.fn(uri => src__web_socket__web_socket.WebSocket.connect(uri), UriToFutureOfWebSocket()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  unit__ws__web_socket_test._runWebSocketSuite = function(getWebSocket) {
    let mockServer = null;
    let webSocketUri = core.Uri.parse('ws://mock.com/ws');
    test.setUp(dart.fn(() => async.async(core.Null, function*() {
      mock.configureWTransportForTest();
      yield src__mocks__mock_transports.MockTransports.reset();
      mockServer = new src__mocks__mock_transports.MockWebSocketServer.new();
    }), VoidToFutureOfNull()));
    test.tearDown(dart.fn(() => async.async(core.Null, function*() {
      yield mockServer.shutDown();
    }), VoidToFutureOfNull()));
    test.test('message events should be discarded prior to a subscription', dart.fn(() => async.async(core.Null, function*() {
      src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: mockServer});
      let webSocket = (yield getWebSocket(webSocketUri));
      let connection = (yield mockServer.onClientConnected.first);
      connection.send('1');
      connection.send('2');
      yield utils.nextTick();
      let messages = JSArrayOfString().of([]);
      webSocket.listen(dart.fn(data => {
        messages[$add](core.String._check(data));
      }, dynamicToNull()));
      connection.send('3');
      connection.send('4');
      yield utils.nextTick();
      yield connection.close();
      yield webSocket.done;
      src__frontend__expect.expect(messages, src__iterable_matchers.orderedEquals(['3', '4']));
      yield webSocket.close().catchError(dart.fn(_ => {
      }, dynamicToNull()));
    }), VoidToFutureOfNull()));
    test.test('the first event should be received if a subscription is made immediately', dart.fn(() => async.async(core.Null, function*() {
      src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: mockServer});
      let webSocket = (yield getWebSocket(webSocketUri));
      let connection = (yield mockServer.onClientConnected.first);
      let c = CompleterOfString().new();
      webSocket.listen(dart.fn(data => {
        c.complete(FutureOrOfString()._check(data));
      }, dynamicToNull()));
      connection.send('first');
      src__frontend__expect.expect(yield c.future, src__core_matchers.equals('first'));
      yield webSocket.close().catchError(dart.fn(_ => {
      }, dynamicToNull()));
    }), VoidToFutureOfNull()));
    test.test('all event streams should respect pause() and resume() signals', dart.fn(() => async.async(core.Null, function*() {
      src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: mockServer});
      let webSocket = (yield getWebSocket(webSocketUri));
      let connection = (yield mockServer.onClientConnected.first);
      let messages = JSArrayOfString().of([]);
      connection.send('1');
      yield utils.nextTick();
      let sub = webSocket.listen(dart.fn(data => {
        messages[$add](core.String._check(data));
      }, dynamicToNull()));
      connection.send('2');
      yield utils.nextTick();
      sub.pause();
      connection.send('3');
      yield utils.nextTick();
      sub.resume();
      connection.send('4');
      yield utils.nextTick();
      src__frontend__expect.expect(messages, src__iterable_matchers.orderedEquals(['2', '4']));
      yield webSocket.close().catchError(dart.fn(_ => {
      }, dynamicToNull()));
      yield sub.cancel();
    }), VoidToFutureOfNull()));
    test.test('onData() handler should be reassignable', dart.fn(() => async.async(core.Null, function*() {
      src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: mockServer});
      let webSocket = (yield getWebSocket(webSocketUri));
      let connection = (yield mockServer.onClientConnected.first);
      let origHandlerMessages = JSArrayOfString().of([]);
      let newHandlerMessages = JSArrayOfString().of([]);
      let sub = webSocket.listen(dart.fn(data => {
        origHandlerMessages[$add](core.String._check(data));
      }, dynamicToNull()));
      connection.send('orig');
      yield utils.nextTick();
      sub.onData(dart.fn(data => {
        newHandlerMessages[$add](core.String._check(data));
      }, dynamicToNull()));
      connection.send('new');
      yield utils.nextTick();
      src__frontend__expect.expect(origHandlerMessages, src__core_matchers.equals(JSArrayOfString().of(['orig'])));
      src__frontend__expect.expect(newHandlerMessages, src__core_matchers.equals(JSArrayOfString().of(['new'])));
      yield webSocket.close().catchError(dart.fn(_ => {
      }, dynamicToNull()));
      yield sub.cancel();
    }), VoidToFutureOfNull()));
    test.test('onDone() handler should be reassignable', dart.fn(() => async.async(core.Null, function*() {
      src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: mockServer});
      let webSocket = (yield getWebSocket(webSocketUri));
      let connection = (yield mockServer.onClientConnected.first);
      let sub = webSocket.listen(dart.fn(_ => {
      }, dynamicToNull()), {onDone: dart.fn(() => {
        }, VoidToNull())});
      let c = CompleterOfNull().new();
      sub.onDone(dart.fn(() => {
        c.complete();
      }, VoidToNull()));
      yield connection.close();
      yield c.future;
      yield webSocket.close().catchError(dart.fn(_ => {
      }, dynamicToNull()));
      yield sub.cancel();
    }), VoidToFutureOfNull()));
    test.test('add() should send data to underlying web socket', dart.fn(() => async.async(core.Null, function*() {
      src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: mockServer});
      let webSocket = (yield getWebSocket(webSocketUri));
      let connection = (yield mockServer.onClientConnected.first);
      let c = CompleterOfString().new();
      connection.onData(dart.fn(data => {
        if (!dart.test(c.isCompleted)) {
          c.complete(FutureOrOfString()._check(data));
        }
      }, dynamicToNull()));
      webSocket.add('message');
      src__frontend__expect.expect(yield c.future, src__core_matchers.equals('message'));
      yield webSocket.close();
    }), VoidToFutureOfNull()));
    test.test('addStream() should send data to underlying web socket', dart.fn(() => async.async(core.Null, function*() {
      src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: mockServer});
      let webSocket = (yield getWebSocket(webSocketUri));
      let connection = (yield mockServer.onClientConnected.first);
      let controller = async.StreamController.new();
      connection.onData(dart.bind(controller, 'add'));
      yield webSocket.addStream(async.Stream.fromIterable(['one', 'two']));
      controller.close();
      webSocket.close();
      src__frontend__expect.expect(yield controller.stream.toList(), src__core_matchers.equals(JSArrayOfString().of(['one', 'two'])));
    }), VoidToFutureOfNull()));
    test.test('addStream() should cause the web socket to close when erorr is added', dart.fn(() => async.async(core.Null, function*() {
      src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: mockServer});
      let webSocket = (yield getWebSocket(webSocketUri));
      let controller = async.StreamController.new();
      controller.add('message');
      controller.addError(core.Exception.new('addStream error, should close socket'));
      controller.close();
      yield webSocket.addStream(controller.stream);
      src__frontend__expect.expect(webSocket.done, src__frontend__throws_matchers.throwsException);
      yield FutureOfNull().new(dart.fn(() => {
      }, VoidToNull()));
      yield webSocket.close().catchError(dart.fn(_ => {
      }, dynamicToNull()));
    }), VoidToFutureOfNull()));
    test.test('addError() should cause the web socket to close', dart.fn(() => async.async(core.Null, function*() {
      src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: mockServer});
      let webSocket = (yield getWebSocket(webSocketUri));
      src__frontend__expect.expect(webSocket.done, src__frontend__throws_matchers.throwsException);
      webSocket.addError(core.Exception.new('web socket consumer error'));
      yield FutureOfNull().new(dart.fn(() => {
      }, VoidToNull()));
      yield webSocket.close().catchError(dart.fn(_ => {
      }, dynamicToNull()));
    }), VoidToFutureOfNull()));
    test.test('server closing the connection should close the socket', dart.fn(() => async.async(core.Null, function*() {
      src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: mockServer});
      let webSocket = (yield getWebSocket(webSocketUri));
      let connection = (yield mockServer.onClientConnected.first);
      yield connection.close(1000, 'closed');
      yield webSocket.done;
      src__frontend__expect.expect(webSocket.closeCode, src__core_matchers.equals(1000));
      src__frontend__expect.expect(webSocket.closeReason, src__core_matchers.equals('closed'));
      yield webSocket.close().catchError(dart.fn(_ => {
      }, dynamicToNull()));
    }), VoidToFutureOfNull()));
  };
  unit__ws__web_socket_test._runLegacyWebSocketSuite = function(getWebSocket) {
    test.group('legacy', dart.fn(() => {
      let webSocketUri = core.Uri.parse('ws://mock.com/ws');
      test.setUp(dart.fn(() => async.async(core.Null, function*() {
        mock.configureWTransportForTest();
        yield src__mocks__mock_transports.MockTransports.reset();
      }), VoidToFutureOfNull()));
      test.test('message events should be discarded prior to a subscription', dart.fn(() => async.async(core.Null, function*() {
        let mockWebSocket = src__web_socket__mock__w_socket.MockWSocket.new();
        src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: mockWebSocket});
        let webSocket = (yield getWebSocket(webSocketUri));
        mockWebSocket.addIncoming('1');
        mockWebSocket.addIncoming('2');
        yield utils.nextTick();
        let messages = JSArrayOfString().of([]);
        webSocket.listen(dart.fn(data => {
          messages[$add](core.String._check(data));
        }, dynamicToNull()));
        mockWebSocket.addIncoming('3');
        mockWebSocket.addIncoming('4');
        yield utils.nextTick();
        mockWebSocket.triggerServerClose();
        yield webSocket.done;
        src__frontend__expect.expect(messages, src__iterable_matchers.orderedEquals(['3', '4']));
        yield webSocket.close().catchError(dart.fn(_ => {
        }, dynamicToNull()));
        yield mockWebSocket.close().catchError(dart.fn(_ => {
        }, dynamicToNull()));
      }), VoidToFutureOfNull()));
      test.test('the first event should be received if a subscription is made immediately', dart.fn(() => async.async(core.Null, function*() {
        let mockWebSocket = src__web_socket__mock__w_socket.MockWSocket.new();
        src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: mockWebSocket});
        let webSocket = (yield getWebSocket(webSocketUri));
        let c = CompleterOfString().new();
        webSocket.listen(dart.fn(data => {
          c.complete(FutureOrOfString()._check(data));
        }, dynamicToNull()));
        mockWebSocket.addIncoming('first');
        src__frontend__expect.expect(yield c.future, src__core_matchers.equals('first'));
        yield webSocket.close().catchError(dart.fn(_ => {
        }, dynamicToNull()));
        yield mockWebSocket.close().catchError(dart.fn(_ => {
        }, dynamicToNull()));
      }), VoidToFutureOfNull()));
      test.test('all event streams should respect pause() and resume() signals', dart.fn(() => async.async(core.Null, function*() {
        let mockWebSocket = src__web_socket__mock__w_socket.MockWSocket.new();
        src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: mockWebSocket});
        let webSocket = (yield getWebSocket(webSocketUri));
        let messages = JSArrayOfString().of([]);
        mockWebSocket.addIncoming('1');
        yield utils.nextTick();
        let sub = webSocket.listen(dart.fn(data => {
          messages[$add](core.String._check(data));
        }, dynamicToNull()));
        mockWebSocket.addIncoming('2');
        yield utils.nextTick();
        sub.pause();
        mockWebSocket.addIncoming('3');
        yield utils.nextTick();
        sub.resume();
        mockWebSocket.addIncoming('4');
        yield utils.nextTick();
        src__frontend__expect.expect(messages, src__iterable_matchers.orderedEquals(['2', '4']));
        yield webSocket.close().catchError(dart.fn(_ => {
        }, dynamicToNull()));
        yield mockWebSocket.close().catchError(dart.fn(_ => {
        }, dynamicToNull()));
        yield sub.cancel();
      }), VoidToFutureOfNull()));
      test.test('onData() handler should be reassignable', dart.fn(() => async.async(core.Null, function*() {
        let mockWebSocket = src__web_socket__mock__w_socket.MockWSocket.new();
        src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: mockWebSocket});
        let webSocket = (yield getWebSocket(webSocketUri));
        let origHandlerMessages = JSArrayOfString().of([]);
        let newHandlerMessages = JSArrayOfString().of([]);
        let sub = webSocket.listen(dart.fn(data => {
          origHandlerMessages[$add](core.String._check(data));
        }, dynamicToNull()));
        mockWebSocket.addIncoming('orig');
        yield utils.nextTick();
        sub.onData(dart.fn(data => {
          newHandlerMessages[$add](core.String._check(data));
        }, dynamicToNull()));
        mockWebSocket.addIncoming('new');
        yield utils.nextTick();
        src__frontend__expect.expect(origHandlerMessages, src__core_matchers.equals(JSArrayOfString().of(['orig'])));
        src__frontend__expect.expect(newHandlerMessages, src__core_matchers.equals(JSArrayOfString().of(['new'])));
        yield webSocket.close().catchError(dart.fn(_ => {
        }, dynamicToNull()));
        yield mockWebSocket.close().catchError(dart.fn(_ => {
        }, dynamicToNull()));
        yield sub.cancel();
      }), VoidToFutureOfNull()));
      test.test('onDone() handler should be reassignable', dart.fn(() => async.async(core.Null, function*() {
        let mockWebSocket = src__web_socket__mock__w_socket.MockWSocket.new();
        src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: mockWebSocket});
        let webSocket = (yield getWebSocket(webSocketUri));
        let sub = webSocket.listen(dart.fn(_ => {
        }, dynamicToNull()), {onDone: dart.fn(() => {
          }, VoidToNull())});
        let c = CompleterOfNull().new();
        sub.onDone(dart.fn(() => {
          c.complete();
        }, VoidToNull()));
        mockWebSocket.triggerServerClose();
        yield c.future;
        yield sub.cancel();
        yield mockWebSocket.close();
        yield webSocket.close();
      }), VoidToFutureOfNull()));
      test.test('add() should send data to underlying web socket', dart.fn(() => async.async(core.Null, function*() {
        let mockWebSocket = src__web_socket__mock__w_socket.MockWSocket.new();
        src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: mockWebSocket});
        let webSocket = (yield getWebSocket(webSocketUri));
        let c = CompleterOfString().new();
        mockWebSocket.onOutgoing(dart.fn(data => c.complete(FutureOrOfString()._check(data)), dynamicTovoid()));
        webSocket.add('message');
        src__frontend__expect.expect(yield c.future, src__core_matchers.equals('message'));
        yield webSocket.close();
        yield mockWebSocket.close();
      }), VoidToFutureOfNull()));
      test.test('addStream() should send data to underlying web socket', dart.fn(() => async.async(core.Null, function*() {
        let mockWebSocket = src__web_socket__mock__w_socket.MockWSocket.new();
        src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: mockWebSocket});
        let webSocket = (yield getWebSocket(webSocketUri));
        let controller = async.StreamController.new();
        mockWebSocket.onOutgoing(dart.bind(controller, 'add'));
        yield webSocket.addStream(async.Stream.fromIterable(['one', 'two']));
        controller.close();
        webSocket.close();
        src__frontend__expect.expect(yield controller.stream.toList(), src__core_matchers.equals(JSArrayOfString().of(['one', 'two'])));
        yield mockWebSocket.close().catchError(dart.fn(_ => {
        }, dynamicToNull()));
      }), VoidToFutureOfNull()));
      test.test('addStream() should cause the web socket to close when erorr is added', dart.fn(() => async.async(core.Null, function*() {
        let mockWebSocket = src__web_socket__mock__w_socket.MockWSocket.new();
        src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: mockWebSocket});
        let webSocket = (yield getWebSocket(webSocketUri));
        let controller = async.StreamController.new();
        controller.add('message');
        controller.addError(core.Exception.new('addStream error, should close socket'));
        controller.close();
        yield webSocket.addStream(controller.stream);
        src__frontend__expect.expect(webSocket.done, src__frontend__throws_matchers.throwsException);
        yield FutureOfNull().new(dart.fn(() => {
        }, VoidToNull()));
        yield webSocket.close().catchError(dart.fn(_ => {
        }, dynamicToNull()));
        yield mockWebSocket.close().catchError(dart.fn(_ => {
        }, dynamicToNull()));
      }), VoidToFutureOfNull()));
      test.test('addError() should cause the web socket to close', dart.fn(() => async.async(core.Null, function*() {
        let mockWebSocket = src__web_socket__mock__w_socket.MockWSocket.new();
        src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: mockWebSocket});
        let webSocket = (yield getWebSocket(webSocketUri));
        src__frontend__expect.expect(webSocket.done, src__frontend__throws_matchers.throwsException);
        webSocket.addError(core.Exception.new('web socket consumer error'));
        yield FutureOfNull().new(dart.fn(() => {
        }, VoidToNull()));
        yield mockWebSocket.close().catchError(dart.fn(_ => {
        }, dynamicToNull()));
        yield webSocket.close().catchError(dart.fn(_ => {
        }, dynamicToNull()));
      }), VoidToFutureOfNull()));
      test.test('DEPRECATED: error should close the socket', dart.fn(() => async.async(core.Null, function*() {
        let mockWebSocket = src__web_socket__mock__w_socket.MockWSocket.new();
        src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: mockWebSocket});
        let webSocket = (yield getWebSocket(webSocketUri));
        mockWebSocket.triggerServerError(core.Exception.new('Server Exception'));
        yield webSocket.done;
        yield mockWebSocket.close().catchError(dart.fn(_ => {
        }, dynamicToNull()));
        yield webSocket.close().catchError(dart.fn(_ => {
        }, dynamicToNull()));
      }), VoidToFutureOfNull()));
      test.test('server closing the connection should close the socket', dart.fn(() => async.async(core.Null, function*() {
        let mockWebSocket = src__web_socket__mock__w_socket.MockWSocket.new();
        src__mocks__mock_transports.MockTransports.webSocket.expect(webSocketUri, {connectTo: mockWebSocket});
        let webSocket = (yield getWebSocket(webSocketUri));
        mockWebSocket.triggerServerClose(1000, 'closed');
        yield webSocket.done;
        src__frontend__expect.expect(webSocket.closeCode, src__core_matchers.equals(1000));
        src__frontend__expect.expect(webSocket.closeReason, src__core_matchers.equals('closed'));
        yield mockWebSocket.close();
        yield webSocket.close();
      }), VoidToFutureOfNull()));
    }, VoidToNull()));
  };
  dart.trackLibraries("test/test__unit__ws__web_socket_test", {
    "unit/ws/web_socket_test.dart": unit__ws__web_socket_test
  }, null);
  // Exports:
  return {
    unit__ws__web_socket_test: unit__ws__web_socket_test
  };
});
